# StringManipulation.jl

[![CI](https://img.shields.io/github/actions/workflow/status/ronisbr/StringManipulation.jl/ci.yml?style=flat-square&logo=githubactions&logoColor=white&labelColor=475569&label=CI)](https://github.com/ronisbr/StringManipulation.jl/actions/workflows/ci.yml)
[![Codecov](https://img.shields.io/codecov/c/github/ronisbr/StringManipulation.jl?token=XELRWB2KOO&style=flat-square&logo=codecov&logoColor=white&labelColor=475569)](https://codecov.io/gh/ronisbr/StringManipulation.jl)
[![Code Style: Blue](https://img.shields.io/badge/code%20style-blue-4495D1?style=flat-square&logo=julia&logoColor=white&labelColor=475569)](https://github.com/invenia/BlueStyle)
[![License](https://img.shields.io/github/license/ronisbr/StringManipulation.jl?style=flat-square&logo=readme&logoColor=white&labelColor=475569&color=0284C7)](https://github.com/ronisbr/StringManipulation.jl/blob/main/LICENSE.txt)
[![DOI](https://img.shields.io/badge/DOI-10.5281%2Fzenodo.8327572-DB2777?style=flat-square&logo=doi&logoColor=white&labelColor=475569)](https://doi.org/10.5281/zenodo.8327572)

This package provides functions to manipulate strings with ANSI escape sequences.

## Alignment

The function `align_string` can be used to align the string in a field with a specific size
to the left, center, or right.

```julia
julia> align_string(
       "A string with emojis 😃😃 and \e[4mdecoration\e[0m to be aligned",
       80,
       :c
       ) |> print
             A string with emojis 😃😃 and decoration to be aligned

julia> align_string(
       "A string with emojis 😃😃 and \e[4mdecoration\e[0m to be aligned",
       80,
       :r
       ) |> print
                          A string with emojis 😃😃 and decoration to be aligned
```

If the string has multiple lines, then all can be aligned at once using the function
`align_string_per_line`.

```julia
julia> str = """
       We have \e[38;5;231;48;5;243mhere\e[0m 😅😃 the first line
       We now have the 😊 \e[38;5;231;48;5;243msecond\e[0m 😃 line""";

julia> align_string_per_line(str, 80, :r) |> print
                                                We have here 😅😃 the first line
                                               We now have the 😊 second 😃 line
```

## ANSI String Parsing

The function `parse_ansi_string` can be used to obtain a vector of text together with the
decorations one must apply to obtain the same result as if this string is printed to the
terminal.

```julia
julia> str = "Test 😅 \e[38;5;231;48;5;243mTest 😅 \e[38;5;201;48;5;243mTest\e[0m";

julia> parse_ansi_string(str)
4-element Vector{Pair{String, Decoration}}:
 "Test 😅 " => Decoration("", "", StringManipulation.unchanged, StringManipulation.unchanged, StringManipulation.unchanged, StringManipulation.unchanged, false, "", false)
 "Test 😅 " => Decoration("38;5;231", "48;5;243", StringManipulation.unchanged, StringManipulation.unchanged, StringManipulation.unchanged, StringManipulation.unchanged, false, "", false)
     "Test" => Decoration("38;5;201", "48;5;243", StringManipulation.unchanged, StringManipulation.unchanged, StringManipulation.unchanged, StringManipulation.unchanged, false, "", false)
         "" => Decoration("", "", StringManipulation.unchanged, StringManipulation.unchanged, StringManipulation.unchanged, StringManipulation.unchanged, true, "", false)
```

## Cropping

### Fit String in a Field

The function `fit_string_in_field` crops the string so that its printable characters fit in
a field.

```julia
julia> str = "Test 😅 \e[38;5;231;48;5;243mTest 😅 \e[38;5;201;48;5;243mTest\e[0m";

julia> fit_string_in_field(str, 9)
"Test 😅 …\e[38;5;231;48;5;243m\e[38;5;201;48;5;243m\e[0m"
```

The function `fit_string_in_field` has many options. For more information, please see the
built-in help (type `?fit_string_in_field` in the REPL).

### Left Cropping

The function `left_crop` can be used to crop a field of specific width to the left of the
string. In this case, the function returns the ANSI escape sequence (non-printable string)
in the cropped field, and the cropped string.

```julia
julia> str = "Test 😅 \e[38;5;231;48;5;243mTest 😅 \e[38;5;201;48;5;243mTest\e[0m";

julia> left_crop(str, 9)
("\e[38;5;231;48;5;243m", "est 😅 \e[38;5;201;48;5;243mTest\e[0m")
```

### Right Cropping

The function `right_crop` can be used to crop a field of specific width to the right of the
string. In this case, the function returns the cropped string and the ANSI escape sequence
(non-printable string) in the cropped field.

```julia
julia> str = "Test 😅 \e[38;5;231;48;5;243mTest 😅 \e[38;5;201;48;5;243mTest\e[0m";

julia> right_crop(str, 5)
("Test 😅 \e[38;5;231;48;5;243mTest 😅", "\e[38;5;201;48;5;243m\e[0m")
```

If the keyword `keep_escape_seq` is set to `false`, then the ANSI escape sequence in the
cropped field will not be computed. This can provide a substantial performance improvement
for very long strings.

```julia
julia> right_crop(str, 5; keep_escape_seq = false)
("Test 😅 \e[38;5;231;48;5;243mTest 😅", "")
```

## Decorations

This package contains functions to work with ANSI escape sequences that decorate text.

### Get Decorations

All the decorations in a string can be retrieved using `get_decorations`:

```julia
julia> str = "Test 😅 \e[38;5;231;48;5;243mTest 😅 \e[38;5;201;48;5;243mTest\e[0m";

julia> get_decorations(str)
"\e[38;5;231;48;5;243m\e[38;5;201;48;5;243m\e[0m"
```

### Remove the Decorations

It is possible to remove all the decorations in a string using the function
`remove_decorations`:

```julia
julia> str = "Test 😅 \e[38;5;231;48;5;243mTest 😅 \e[38;5;201;48;5;243mTest\e[0m";

julia> remove_decorations(str)
"Test 😅 Test 😅 Test"
```

### Get and Remove Decorations

If someone wants to get all the decorations in a string, and the undecorated string, the
function `get_and_remove_decorations` can be used to improve the performance:

```julia
julia> str = "Test 😅 \e[38;5;231;48;5;243mTest 😅 \e[38;5;201;48;5;243mTest\e[0m";

julia> get_and_remove_decorations(str)
("\e[38;5;231;48;5;243m\e[38;5;201;48;5;243m\e[0m", "Test 😅 Test 😅 Test")
```

### Parsing Decorations

The ANSI escape sequences that decorate the text can be parsed using the function
`parse_decoration`. The result is an object of type `Decoration` with the combined
decoration created by the ANSI escape sequence.

```julia
julia> parse_decoration("\e[38;5;201;48;5;243;4;27m") |> dump
Decoration
  foreground: String "38;5;201"
  background: String "48;5;243"
  bold: StringManipulation.DecorationState StringManipulation.unchanged
  italic: StringManipulation.DecorationState StringManipulation.unchanged
  reversed: StringManipulation.DecorationState StringManipulation.inactive
  underline: StringManipulation.DecorationState StringManipulation.active
  reset: Bool false
  hyperlink_url: String ""
  hyperlink_url_changed: Bool false
```

### Updating Decorations

A decoration (object of type `Decoration`) can be updated given another ANSI escape sequence
using `update_decoration`:

```julia
julia> decoration = parse_decoration("\e[38;5;201;48;5;243;4;27m");

julia> update_decoration(decoration, "\e[33;1m") |> dump
Decoration
  foreground: String "33"
  background: String "48;5;243"
  bold: StringManipulation.DecorationState StringManipulation.active
  italic: StringManipulation.DecorationState StringManipulation.unchanged
  reversed: StringManipulation.DecorationState StringManipulation.inactive
  underline: StringManipulation.DecorationState StringManipulation.active
  reset: Bool false
  hyperlink_url: String ""
  hyperlink_url_changed: Bool false

julia> update_decoration(decoration, "\e]8;;https://ronanarraes.com\e\\") |> dump
Decoration
  foreground: String "38;5;201"
  background: String "48;5;243"
  bold: StringManipulation.DecorationState StringManipulation.unchanged
  italic: StringManipulation.DecorationState StringManipulation.unchanged
  reversed: StringManipulation.DecorationState StringManipulation.inactive
  underline: StringManipulation.DecorationState StringManipulation.active
  reset: Bool false
  hyperlink_url: String "https://ronanarraes.com"
  hyperlink_url_changed: Bool true
```

### Replacing the Default Background

The default background of a string can be replaced using the function
`replace_default_background`. The first argument is the string and the second is the ANSI
code of the new background:

![Replace default background](./assets/replace_default_background.png "Replace default background")

## Highlight Search Matches

The function `highlight_search` can be used to highlight search matches, given by a `Regex`,
in a string.

```julia
julia> str = """
  Lorem ipsum dolor sit amet, consectetur adipiscing elit. Pellentesque tempor
  risus vel diam ultrices volutpat. Nullam id tortor ut dolor rutrum cursus
  aliquam sed lorem. Donec interdum, risus eu scelerisque posuere, purus magna
  auctor purus, in faucibus nisi quam ac erat. Nulla facilisi. Aenean et augue
  augue. Donec ut sem posuere, venenatis est quis, ultrices elit. Vivamus elit
  sapien, ullamcorper quis dui ut, suscipit varius nibh. Duis varius arcu id
  ipsum egestas aliquam. Pellentesque eget sem ornare turpis fringilla fringilla
  id ac turpis.
  """;

julia> highlight_search(str, r"ing"; active_match = 2) |> println
```

![Highlight search](./assets/highlight_search.png "Highlight search")

The function `highlight_search` has many options. For more information, please see the
built-in help (type `?highlight_search` in the REPL).

## Printable Text Width

The printable text width of a string can be computed using the function
`printable_textwidth`:

```julia
julia> str = "Test 😅 \e[38;5;231;48;5;243mTest 😅 \e[38;5;201;48;5;243mTest\e[0m";

julia> printable_textwidth(str)
20
```

If the string has multiple lines, then the function `printable_textwidth_per_line` can be
used to compute the printable text width of each one of them:

```julia
julia> str = """
       Test 😅 \e[38;5;231;48;5;243mTest 😅 \e[38;5;201;48;5;243mTest\e[0m
       Test 😅 \e[38;5;231;48;5;243mTest 😅 \e[38;5;201;48;5;243mTest Test\e[0m
       Test 😅 \e[38;5;231;48;5;243mTest 😅 \e[38;5;201;48;5;243mTest Test Test\e[0m""";

julia> printable_textwidth_per_line(str)
3-element Vector{Int64}:
 20
 25
 30
```

## Splitting

The function `split_string` can be used to split a string given a desired size (printable
characters width).

```julia
julia> str = "Test 😅 \e[38;5;231;48;5;243mTest 😅 \e[38;5;201;48;5;243mTest\e[0m";

julia> split_string(str, 8)
("Test 😅 \e[38;5;231;48;5;243m", "Test 😅 \e[38;5;201;48;5;243mTest\e[0m")
```

## Text View

The function `textview` can be used to create a view of a text.

```julia
julia> str = """
         Lorem ipsum dolor sit amet, consectetur adipiscing elit. Pellentesque tempor
         risus vel diam ultrices volutpat. Nullam id tortor ut dolor rutrum cursus
         aliquam sed lorem. Donec interdum, risus eu scelerisque posuere, purus magna
         auctor purus, in faucibus nisi quam ac erat. Nulla facilisi. Aenean et augue
         augue. Donec ut sem posuere, venenatis est quis, ultrices elit. Vivamus elit
         sapien, ullamcorper quis dui ut, suscipit varius nibh. Duis varius arcu id
         ipsum egestas aliquam. Pellentesque eget sem ornare turpis fringilla fringilla
         id ac turpis.
         """;

julia> textview(str, (1, 3, 10, 50))[1] |> println
um dolor sit amet, consectetur adipiscing elit. Pe
 diam ultrices volutpat. Nullam id tortor ut dolor
ed lorem. Donec interdum, risus eu scelerisque pos
```

Notice that it correctly considers all the ANSI escape sequences that decorate the text,
yielding a view that matches all the characteristics of the original text (foreground
color, background color, underline, etc.).

The function `textview` has many options. For more information, please see the built-in help
(type `?textview` in the REPL).

### Prepared Text Views

Applications that repeatedly render different viewports of the same text can prepare it once
with `TextViewLayout`:

```julia
julia> lines = split(str, '\n');

julia> layout = TextViewLayout(lines);

julia> textview(layout, (1, 3, 10, 50))[1] |> println
um dolor sit amet, consectetur adipiscing elit. Pe
 diam ultrices volutpat. Nullam id tortor ut dolor
ed lorem. Donec interdum, risus eu scelerisque pos
```

Prepared views are owned, immutable snapshots: construction copies the input into canonical
lines, so later changes to a caller's input do not change the layout. Their private metadata
includes cached printable widths plus sparse Unicode checkpoints and ANSI event/checkpoint
storage. This makes repeated horizontal rendering proportional to the viewport and
checkpoint slack instead of the complete line width. Layout construction performs one-time
linear preprocessing with a bounded number of linear passes and retains the canonical lines
plus that metadata. The default checkpoint strides balance memory and seek work; smaller
values reduce local scans but retain more metadata. Search matches, active matches, and
visual backgrounds remain dynamic.

`TextViewLayout` also provides a read-only `AbstractVector{String}` interface. Its lines can
be indexed or iterated without exposing mutable backing storage. Use `collect(layout)` to
obtain an explicit mutable copy when an application needs to modify the line vector.

Preparation pays off when its one-time construction cost is amortized across enough renders.
A useful workload-specific break-even estimate is construction time divided by the time
saved per prepared render; no finite break-even exists when a prepared render is not faster.
ANSI metadata may canonicalize redundant events at a viewport's right boundary while
preserving the visible terminal state.

The existing string and vector `textview` methods do not prepare implicitly and remain
appropriate for one-off rendering.

# Benchmarks

From the package root, instantiate the isolated benchmark environment with the local checkout and
run the full suite:

```sh
julia --project=benchmark -e 'using Pkg; Pkg.develop(path=pwd()); Pkg.instantiate()'
julia --project=benchmark benchmark/benchmarks.jl
```

For a bounded smoke execution using the same workloads but fewer samples and smaller ANSI-scaling
inputs, run:

```sh
julia --project=benchmark benchmark/benchmarks.jl --quick
```

The script reports BenchmarkTools median elapsed time and warmed allocations for each operation.
Rendering trials compile their exact call once before measurement, reuse one `IOBuffer`, and reset
it outside each timed evaluation. Thus, “prepared warmed” describes steady warmed execution, not a
first render.

Output includes:

- paired raw/prepared rendering for ASCII, wide/combining Unicode, and ANSI text;
- paired raw/layout searches;
- layout construction time, warmed construction allocations, and retained
  `Base.summarysize` for sources and layouts;
- a construction break-even estimate, computed as construction time divided by the median time
  saved per prepared render. If prepared rendering is not faster in that run, the script labels the
  estimate unavailable rather than dividing by a non-positive value;
- repeated versus high-cardinality ANSI construction, rendering, and retention scaling;
- construction, rendering, retained bytes, and bytes per line for 100,000 short lines; and
- global `active_match` versus `active_match_location` with a sparse match near the end of 1,000,
  10,000, and 100,000-line inputs.

Benchmark times vary with Julia version, hardware, operating system, system load, and terminal/IO
conditions. Compare results from the same environment; the script makes no cross-platform
performance assertion. Quick mode is a smoke check, not a stable performance measurement.

## Description #############################################################################
#
# Tests related to the string width computation.
#
############################################################################################

@testset "Printable Text Width" verbose = true begin
    # Some examples here were obtained from:
    #   https://www.lihaoyi.com/post/BuildyourownCommandLinewithANSIescapecodes.html

    str = "\e[38;5;231;48;5;243mTes\e[3mt Test\e[1m Test\e[0m"
    @test printable_textwidth(str) == 14

    str = "\e[38;5;231;48;5;243m😃\e[3m😄\e[1m😊\e[0m"
    @test printable_textwidth(str) == 6

    str = "\e[1m😃\e[0m\e[4m😅\e[0m\e[7m🥳\e[0m"
    @test printable_textwidth(str) == 6

    # == Hyperlinks (OSC 8) ================================================================

    str = "Test 😅 \e[38;5;231;48;5;243;3m\e]8;;https://ronanarraes.com\e\\Test 😅 \e[38;5;201;48;5;243;23mTest\e[0m"
    @test printable_textwidth(str) == 20

    # == Multi Line Support ================================================================

    str = """
    \e[38;5;231;48;5;243mTes\e[3mt Test\e[1m Test\e[0m
    \e[38;5;231;48;5;243m😃\e[3m😄\e[1m😊\e[0m
    \e[1m😃\e[0m\e[4m😅\e[0m\e[7m🥳\e[0m
    Test 😅 \e[38;5;231;48;5;243;3m\e]8;;https://ronanarraes.com\e\\Test 😅 \e[38;5;201;48;5;243;23mTest\e[0m
    \u001b[30;1m A \u001b[31;1m B \u001b[32;1m C \u001b[33;1m D \u001b[0m
    \u001b[44;1m A \u001b[45;1m B \u001b[46;1m C \u001b[47;1m D \u001b[0m
    \u001b[1m BOLD \u001b[0m\u001b[4m Underline \u001b[0m\u001b[7m Reversed \u001b[0m
    \u001b[1m\u001b[4m\u001b[7m BOLD Underline Reversed \u001b[0m"""

    lines_width = printable_textwidth_per_line(str)

    @test length(lines_width) == 8
    @test lines_width[1] == 14
    @test lines_width[2] == 6
    @test lines_width[3] == 6
    @test lines_width[4] == 20
    @test lines_width[5] == 12
    @test lines_width[6] == 12
    @test lines_width[7] == 27
    @test lines_width[8] == 25
end

@testset "Printable Text Width Without Allocations" begin
    # The width must be computed without materializing the undecorated string.
    @test @allocated(printable_textwidth("plain ascii line")) == 0
    @test @allocated(printable_textwidth("\e[1mbold\e[0m and \e[31mred\e[0m")) == 0
    @test @allocated(printable_textwidth("日本語 and émojis 😅")) == 0

    # The result must match the definition based on `remove_decorations`.
    for str in (
        "",
        "plain",
        "\e[1mbold\e[0m",
        "日本語",
        "😅😅",
        "\e]8;;https://example.com\e\\link\e]8;;\e\\",
        "\e]8;;https://example.com\alink\e]8;;\a",
        "\e[38;5;231;48;5;243mcolored\e[0m",
        "a\tb\nc",
    )
        @test printable_textwidth(str) == textwidth(remove_decorations(str))
    end

    @test printable_textwidth_per_line("ab\n\e[1mcde\e[0m\n日本") == [2, 3, 4]
    @test printable_textwidth_per_line("") == [0]
    @test printable_textwidth_per_line("a\n") == [1, 0]
end

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
#
# Description
# ==========================================================================================
#
#   Tests related with string decorations.
#
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

@testset "Convert Decoration to String" begin
    d = Decoration(
        foreground = "35",
        background = "48;5;243",
        underline = StringManipulation.active
    )

    expected = "\e[35m\e[48;5;243m\e[4m"
    result = convert(String, d)

    d = Decoration(
        foreground = "35",
        background = "48;5;243",
        underline = StringManipulation.inactive
    )

    expected = "\e[35m\e[48;5;243m\e[24m"
    result = convert(String, d)

    d = Decoration(
        foreground = "35",
        background = "",
        bold = StringManipulation.active
    )

    expected = "\e[35m\e[1m"
    result = convert(String, d)

    d = Decoration(
        foreground = "35",
        background = "",
        bold = StringManipulation.inactive
    )

    expected = "\e[35m\e[22m"
    result = convert(String, d)

    d = Decoration(
        foreground = "",
        background = "45",
        reversed = StringManipulation.active
    )

    expected = "\e[45m\e[7m"
    result = convert(String, d)

    d = Decoration(
        foreground = "",
        background = "45",
        reversed = StringManipulation.inactive
    )

    expected = "\e[45m\e[27m"
    result = convert(String, d)

    @test result == expected

    d = Decoration(
        foreground = "35",
        background = "45",
        bold = StringManipulation.active,
        italic = StringManipulation.active
    )

    expected = "\e[35m\e[45m\e[1m\e[3m"
    result = convert(String, d)

    @test result == expected

    d = Decoration(
        foreground = "35",
        background = "45",
        bold = StringManipulation.active,
        italic = StringManipulation.active,
        hyperlink_url = "https://ronanarraes.com",
        hyperlink_url_changed = false
    )

    expected = "\e[35m\e[45m\e[1m\e[3m"
    result = convert(String, d)

    d = Decoration(
        foreground = "35",
        background = "45",
        bold = StringManipulation.active,
        italic = StringManipulation.active,
        hyperlink_url = "https://ronanarraes.com",
        hyperlink_url_changed = true
    )

    expected = "\e[35m\e[45m\e[1m\e[3m\e]8;;https://ronanarraes.com\e\\"
    result = convert(String, d)
end

@testset "Drop Inactive Decorations" begin
    decoration = Decoration(
        foreground = "39",
        background = "49",
        bold       = StringManipulation.inactive,
        italic     = StringManipulation.inactive,
        underline  = StringManipulation.inactive,
        reversed   = StringManipulation.inactive
    )

    decoration = drop_inactive_properties(decoration)

    @test decoration === Decoration()

    decoration = Decoration(
        foreground = "39",
        background = "245",
        bold       = StringManipulation.inactive,
        italic     = StringManipulation.inactive,
        underline  = StringManipulation.inactive,
        reversed   = StringManipulation.inactive
    )

    decoration = drop_inactive_properties(decoration)

    @test decoration === Decoration(background = "245")
end

@testset "Get Decorations" begin
    str = "Test 😅 \e[38;5;231;48;5;243;3m\e]8;;https://ronanarraes.com\e\\Test 😅 \e[38;5;201;48;5;243;23mTest\e[0m"
    expected = "\e[38;5;231;48;5;243;3m\e]8;;https://ronanarraes.com\e\\\e[38;5;201;48;5;243;23m\e[0m"
    result = get_decorations(str)
    @test expected == result
end

@testset "Get and Remove Decorations" begin
    str = "Test 😅 \e[38;5;231;48;5;243;3m\e]8;;https://ronanarraes.com\e\\Test 😅 \e[38;5;201;48;5;243;23mTest\e[0m"
    expected_decorations = "\e[38;5;231;48;5;243;3m\e]8;;https://ronanarraes.com\e\\\e[38;5;201;48;5;243;23m\e[0m"
    expected_text = "Test 😅 Test 😅 Test"
    decorations, text = get_and_remove_decorations(str)
    @test expected_decorations == decorations
    @test expected_text === text
end

# Those tests are also used to verify the function `_parse_ansi_decoration_code`.
@testset "Parse Decorations" begin
    decoration = parse_decoration("\e[35m\e[48;5;243m\e[4;27m")

    @test decoration.foreground == "35"
    @test decoration.background == "48;5;243"
    @test decoration.underline  == StringManipulation.active
    @test decoration.bold       == StringManipulation.unchanged
    @test decoration.italic     == StringManipulation.unchanged
    @test decoration.reversed   == StringManipulation.inactive

    decoration = parse_decoration("\e[45;1;3m")

    @test decoration.foreground == ""
    @test decoration.background == "45"
    @test decoration.underline  == StringManipulation.unchanged
    @test decoration.bold       == StringManipulation.active
    @test decoration.italic     == StringManipulation.active
    @test decoration.reversed   == StringManipulation.unchanged

    decoration = parse_decoration("\e[48;5;243;7;22;3m")

    @test decoration.foreground == ""
    @test decoration.background == "48;5;243"
    @test decoration.underline  == StringManipulation.unchanged
    @test decoration.bold       == StringManipulation.inactive
    @test decoration.italic     == StringManipulation.active
    @test decoration.reversed   == StringManipulation.active

    decoration = parse_decoration("\e[39;49;1;7;23m")

    @test decoration.foreground == "39"
    @test decoration.background == "49"
    @test decoration.underline  == StringManipulation.unchanged
    @test decoration.bold       == StringManipulation.active
    @test decoration.italic     == StringManipulation.inactive
    @test decoration.reversed   == StringManipulation.active

    decoration = parse_decoration("\e[92;103;24m")

    @test decoration.foreground == "92"
    @test decoration.background == "103"
    @test decoration.underline  == StringManipulation.inactive
    @test decoration.bold       == StringManipulation.unchanged
    @test decoration.italic     == StringManipulation.unchanged
    @test decoration.reversed   == StringManipulation.unchanged

    # Parse decorations with text in the middle.
    decoration = parse_decoration("\e[35m\e[48;5;243;3mThis text should be discarded\e[4;27m")

    @test decoration.foreground == "35"
    @test decoration.background == "48;5;243"
    @test decoration.underline  == StringManipulation.active
    @test decoration.bold       == StringManipulation.unchanged
    @test decoration.italic     == StringManipulation.active
    @test decoration.reversed   == StringManipulation.inactive

    # Unsupported escape sequences.
    decoration = parse_decoration("\e]8")
    @test decoration === Decoration()

    # True-color mode.
    decoration = parse_decoration("\e[38;2;28;101;140;48;2;216;210;203mFirst decoration")

    @test decoration.foreground == "38;2;28;101;140"
    @test decoration.background == "48;2;216;210;203"
    @test decoration.underline  == StringManipulation.unchanged
    @test decoration.bold       == StringManipulation.unchanged
    @test decoration.italic     == StringManipulation.unchanged
    @test decoration.reversed   == StringManipulation.unchanged
end

@testset "Remove Decorations" begin
    str = "Test 😅 \e[38;5;231;48;5;243;3m\e]8;;https://ronanarraes.com\e\\Test 😅 \e[38;5;201;48;5;243;23mTest\e[0m"
    expected = "Test 😅 Test 😅 Test"
    result = remove_decorations(str)
    @test expected == result

    str = "This string does not have decorations"
    result = remove_decorations(str)
    @test result == str
end

@testset "Replace the Default Background" begin
    str = "\e[35mThis is a \e[45;1mtest string with \e]8;;https://ronanarraes.com\e\\hyperlink\e]8;;\e\\ to \e[0mverify if \e[45mthe background \e[49;1mwas replaced correctly."
    exp = "\e[43m\e[35mThis is a \e[45;1mtest string with \e]8;;https://ronanarraes.com\e\\hyperlink\e]8;;\e\\ to \e[0m\e[43mverify if \e[45mthe background \e[43m\e[1mwas replaced correctly.\e[49m"
    new = replace_default_background(str, "43")

    @test new == exp
end

@testset "Update Decorations" begin

    # == Update Decorations Given a String =================================================

    decoration = Decoration()

    decoration = update_decoration(decoration, "\e[38;5;231m")
    @test decoration.foreground            == "38;5;231"
    @test decoration.background            == ""
    @test decoration.underline             == StringManipulation.unchanged
    @test decoration.bold                  == StringManipulation.unchanged
    @test decoration.italic                == StringManipulation.unchanged
    @test decoration.reversed              == StringManipulation.unchanged
    @test decoration.reset                 == false
    @test decoration.hyperlink_url         == ""
    @test decoration.hyperlink_url_changed == false

    decoration = update_decoration(decoration, "\e[48;5;243m")
    @test decoration.foreground            == "38;5;231"
    @test decoration.background            == "48;5;243"
    @test decoration.underline             == StringManipulation.unchanged
    @test decoration.bold                  == StringManipulation.unchanged
    @test decoration.italic                == StringManipulation.unchanged
    @test decoration.reversed              == StringManipulation.unchanged
    @test decoration.reset                 == false
    @test decoration.hyperlink_url         == ""
    @test decoration.hyperlink_url_changed == false

    decoration = update_decoration(decoration, "\e[4;27m")
    @test decoration.foreground            == "38;5;231"
    @test decoration.background            == "48;5;243"
    @test decoration.underline             == StringManipulation.active
    @test decoration.bold                  == StringManipulation.unchanged
    @test decoration.italic                == StringManipulation.unchanged
    @test decoration.reversed              == StringManipulation.inactive
    @test decoration.reset                 == false
    @test decoration.hyperlink_url         == ""
    @test decoration.hyperlink_url_changed == false

    decoration = update_decoration(decoration, "\e[3m")
    @test decoration.foreground            == "38;5;231"
    @test decoration.background            == "48;5;243"
    @test decoration.underline             == StringManipulation.active
    @test decoration.bold                  == StringManipulation.unchanged
    @test decoration.italic                == StringManipulation.active
    @test decoration.reversed              == StringManipulation.inactive
    @test decoration.reset                 == false
    @test decoration.hyperlink_url         == ""
    @test decoration.hyperlink_url_changed == false

    decoration = update_decoration(decoration, "\e[0m")
    @test decoration.foreground            == ""
    @test decoration.background            == ""
    @test decoration.underline             == StringManipulation.unchanged
    @test decoration.bold                  == StringManipulation.unchanged
    @test decoration.italic                == StringManipulation.unchanged
    @test decoration.reversed              == StringManipulation.unchanged
    @test decoration.reset                 == true
    @test decoration.hyperlink_url         == ""
    @test decoration.hyperlink_url_changed == false

    decoration = update_decoration(decoration, "\e[33m")
    @test decoration.foreground            == "33"
    @test decoration.background            == ""
    @test decoration.underline             == StringManipulation.unchanged
    @test decoration.bold                  == StringManipulation.unchanged
    @test decoration.italic                == StringManipulation.unchanged
    @test decoration.reversed              == StringManipulation.unchanged
    @test decoration.reset                 == false
    @test decoration.hyperlink_url         == ""
    @test decoration.hyperlink_url_changed == false

    decoration = update_decoration(decoration, "\e[3m\e]8;;https://ronanarraes.com\e\\")
    @test decoration.foreground            == "33"
    @test decoration.background            == ""
    @test decoration.underline             == StringManipulation.unchanged
    @test decoration.bold                  == StringManipulation.unchanged
    @test decoration.italic                == StringManipulation.active
    @test decoration.reversed              == StringManipulation.unchanged
    @test decoration.reset                 == false
    @test decoration.hyperlink_url         == "https://ronanarraes.com"
    @test decoration.hyperlink_url_changed == true

    decoration = update_decoration(decoration, "\e[0m")
    @test decoration.foreground            == ""
    @test decoration.background            == ""
    @test decoration.underline             == StringManipulation.unchanged
    @test decoration.bold                  == StringManipulation.unchanged
    @test decoration.italic                == StringManipulation.unchanged
    @test decoration.reversed              == StringManipulation.unchanged
    @test decoration.reset                 == true
    @test decoration.hyperlink_url         == "https://ronanarraes.com"
    @test decoration.hyperlink_url_changed == true

    decoration = update_decoration(decoration, "\e[1m\e]8;;\e\\")
    @test decoration.foreground            == ""
    @test decoration.background            == ""
    @test decoration.underline             == StringManipulation.unchanged
    @test decoration.bold                  == StringManipulation.active
    @test decoration.italic                == StringManipulation.unchanged
    @test decoration.reversed              == StringManipulation.unchanged
    @test decoration.reset                 == false
    @test decoration.hyperlink_url         == ""
    @test decoration.hyperlink_url_changed == true

    # Update decorations with text in the middle.
    decoration = Decoration()

    decoration = update_decoration(
        decoration,
        "\e[38;5;231mThis text should be discarded\e[48;5;243m"
    )
    @test decoration.foreground            == "38;5;231"
    @test decoration.background            == "48;5;243"
    @test decoration.underline             == StringManipulation.unchanged
    @test decoration.bold                  == StringManipulation.unchanged
    @test decoration.italic                == StringManipulation.unchanged
    @test decoration.reversed              == StringManipulation.unchanged
    @test decoration.reset                 == false
    @test decoration.hyperlink_url         == ""
    @test decoration.hyperlink_url_changed == false

    decoration = update_decoration(
        decoration,
        "This also should \e[23mbe discarded\e[4;27m"
    )
    @test decoration.foreground            == "38;5;231"
    @test decoration.background            == "48;5;243"
    @test decoration.underline             == StringManipulation.active
    @test decoration.bold                  == StringManipulation.unchanged
    @test decoration.italic                == StringManipulation.inactive
    @test decoration.reversed              == StringManipulation.inactive
    @test decoration.reset                 == false
    @test decoration.hyperlink_url         == ""
    @test decoration.hyperlink_url_changed == false

    # True-color mode.
    decoration = Decoration()
    decoration = update_decoration(
        decoration,
        "\e[38;2;28;101;140;48;2;216;210;203mFirst decoration"
    )

    @test decoration.foreground            == "38;2;28;101;140"
    @test decoration.background            == "48;2;216;210;203"
    @test decoration.underline             == StringManipulation.unchanged
    @test decoration.bold                  == StringManipulation.unchanged
    @test decoration.italic                == StringManipulation.unchanged
    @test decoration.reversed              == StringManipulation.unchanged
    @test decoration.hyperlink_url         == ""
    @test decoration.hyperlink_url_changed == false

    decoration = update_decoration(
        decoration,
        "\e[38;2;57;138;185;1mSecond decoration"
    )

    @test decoration.foreground            == "38;2;57;138;185"
    @test decoration.background            == "48;2;216;210;203"
    @test decoration.underline             == StringManipulation.unchanged
    @test decoration.bold                  == StringManipulation.active
    @test decoration.italic                == StringManipulation.unchanged
    @test decoration.reversed              == StringManipulation.unchanged
    @test decoration.hyperlink_url         == ""
    @test decoration.hyperlink_url_changed == false

    # == Update Decoration Using a New Decoration ==========================================

    decoration = Decoration(
        foreground = "33",
        bold       = StringManipulation.active,
        italic     = StringManipulation.inactive,
        reversed   = StringManipulation.inactive
    )

    new_decoration = Decoration(
        background = "43",
        bold       = StringManipulation.inactive
    )

    decoration = update_decoration(decoration, new_decoration)

    @test decoration.foreground            == "33"
    @test decoration.background            == "43"
    @test decoration.bold                  == StringManipulation.inactive
    @test decoration.italic                == StringManipulation.inactive
    @test decoration.underline             == StringManipulation.unchanged
    @test decoration.reset                 == false
    @test decoration.reversed              == StringManipulation.inactive
    @test decoration.hyperlink_url         == ""
    @test decoration.hyperlink_url_changed == false

    new_decoration = Decoration(
        background            = "43",
        bold                  = StringManipulation.inactive,
        hyperlink_url         = "https://ronanarraes.com",
        hyperlink_url_changed = true
    )

    decoration = update_decoration(decoration, new_decoration)

    @test decoration.foreground            == "33"
    @test decoration.background            == "43"
    @test decoration.bold                  == StringManipulation.inactive
    @test decoration.italic                == StringManipulation.inactive
    @test decoration.underline             == StringManipulation.unchanged
    @test decoration.reset                 == false
    @test decoration.reversed              == StringManipulation.inactive
    @test decoration.hyperlink_url         == "https://ronanarraes.com"
    @test decoration.hyperlink_url_changed == true
end

## Description #############################################################################
#
# Functions to crop strings.
#
############################################################################################

export crop_width_to_fit_string_in_field, left_crop, fit_string_in_field, right_crop

"""
    crop_width_to_fit_string_in_field(str::AbstractString, field_width::Int; kwargs...) -> Int

Get the number of printable characters to be cropped so that the string `str` can fit in the
field with size `field_width`.

# Keywords

- `add_continuation_char::Bool`: If `true`, a continuation character is added to the cropped
    string end. Notice that the returned string always has a printable width of
    `field_size`.
    (**Default** = `true`)
- `add_space_in_continuation_char::Bool`: If `true`, a space is added before the
    continuation character if `crop_size` is `:right`, or after the continuation character
    if `crop_side` if `:left`.
    (**Default** = `false`)
- `continuation_char::Char`: The continuation character to add if the string is cropped.
    (**Default** = `…`)
- `printable_string_width::Int`: Provide the printable string width to reduce the
    computational burden. If this parameters is lower than 0, the printable width is compute
    internally.
    (**Default** = -1)

# Extended Help

## Examples

```julia-repl
julia> crop_width_to_fit_string_in_field("This is a very long string for a very small field", 10)
40
```
"""
function crop_width_to_fit_string_in_field(
    str::AbstractString,
    field_width::Int;
    add_continuation_char::Bool = true,
    add_space_in_continuation_char::Bool = false,
    continuation_char::Char = '…',
    printable_string_width::Int = -1
)
    str_width = if printable_string_width < 0
        printable_textwidth(str)
    else
        printable_string_width
    end

    Δ = str_width - field_width

    # If the field is larger than the string, we do not need to crop.
    (Δ ≤ 0) && return 0

    # If the user is asking for the continuation char, we must crop the string to account
    # for the continuation char.
    if add_continuation_char
        cont_str_width = textwidth(continuation_char)

        if add_space_in_continuation_char
            cont_str_width += 1
        end

        Δ += cont_str_width

        # If we are left with no space, then we must crop the entire string.
        (Δ > str_width) && return str_width
    end

    return Δ
end

"""
    fit_string_in_field(str::AbstractString, field_width::Int; kwargs...) -> String

Crop the string `str` to fit within a field of width `field_width`.

# Keywords

- `add_continuation_char::Bool`: If `true`, a continuation character is added to the cropped
    string end. Notice that the returned string always has a printable width of
    `field_size`.
    (**Default** = `true`)
- `add_space_in_continuation_char::Bool`: If `true`, a space is added before the
    continuation character if `crop_size` is `:right`, or after the continuation character
    if `crop_side` if `:left`.
    (**Default** = `false`)
- `continuation_char::Char`: The continuation character to add if the string is cropped.
    (**Default** = `…`)
- `crop_side::Symbol`: Select from which side the characters must be removed to fit the
    string into the field. It can be `:right` or `:left`.
    (**Default** = `:right`)
- `field_margin::Int`: Consider an additional margin in the field if it must be cropped.
    (**Default** = 0)
- `keep_escape_seq::Bool`: If `true`, the ANSI escape sequences found in the cropped part
    will be kept.
    (**Default** = `true`)
- `printable_string_width::Int`: Provide the printable string width to reduce the
    computational burden. If this parameters is lower than 0, the printable width is compute
    internally.
    (**Default** = -1)

# Extended Help

## Examples

```julia-repl
julia> fit_string_in_field("This is a very long string for a very small field", 10)
"This is a…"

julia> fit_string_in_field("This is a very long string for a very small field", 10; crop_side = :left)
"…all field"
```
"""
function fit_string_in_field(
    str::AbstractString,
    field_width::Int;
    add_continuation_char::Bool = true,
    add_space_in_continuation_char::Bool = false,
    continuation_char::Char = '…',
    crop_side::Symbol = :right,
    field_margin::Int = 0,
    keep_escape_seq::Bool = true,
    printable_string_width::Int = -1
)
    str_width = if printable_string_width < 0
        printable_textwidth(str)
    else
        printable_string_width
    end

    crop = crop_width_to_fit_string_in_field(
        str,
        field_width - field_margin;
        add_continuation_char,
        add_space_in_continuation_char,
        continuation_char,
        printable_string_width = str_width
    )

    (crop ≤ field_margin) && return str

    cont_str = add_continuation_char ? string(continuation_char) : ""
    spc_str  = add_space_in_continuation_char ? " " : ""

    # == Crop From the Right ===============================================================

    if crop_side == :right
        cropped_str, ansi = right_crop(
            str,
            crop;
            keep_escape_seq,
            printable_string_width = str_width
        )

        add_space_in_continuation_char && return "$cropped_str $cont_str$ansi"

        return "$cropped_str$cont_str$ansi"

    # == Crop from The Left ================================================================

    else
        ansi, cropped_str = left_crop(str, crop)
        result = keep_escape_seq ? ansi : ""

        add_space_in_continuation_char && return "$result$cont_str $cropped_str"

        return "$result$cont_str$cropped_str"
    end
end

"""
    left_crop(str::AbstractString, crop_width::Int) -> String, String

Return a string obtained by cropping the left characters of `str` so that its printable
width is reduced by `crop_width` display units.

# Returns

- `String`: ANSI escape sequence (non-printable string) in the cropped part.
- `String`: Cropped string.

# Extended Help

## Examples

```julia-repl
julia> left_crop("\\e[1mPlease, crop this string.", 8)
("\\e[1m", "crop this string.")
```
"""
function left_crop(str::AbstractString, crop_width::Int)
    buf_ansi = IOBuffer()
    buf_str  = IOBuffer(sizehint = floor(Int, sizeof(str) - crop_width))
    state    = :text

    for c in str
        if crop_width ≤ 0
            write(buf_str, c)
            continue
        end

        state = _next_string_state(c, state)

        # If we are not in a text section, just write the character to the ANSI buffer.
        if state != :text
            write(buf_ansi, c)
            continue
        end

        crop_width -= textwidth(c)

        # If `crop_width` is negative, it means that we have a character that occupies
        # more than 1 character. In this case, we fill the string with space.
        if crop_width < 0
            write(buf_str, " "^(-crop_width))
            crop_width = 0
        end
    end

    return String(take!(buf_ansi)), String(take!(buf_str))
end

"""
    right_crop(str::AbstractString, crop_width::Int; kwargs...) -> String, String

Return a string obtained by cropping the right characters of `str` given a field with a
printable width of `crop_width`.

# Returns

- `String`: Cropped string.
- `String`: ANSI escape sequence (non-printable string) in the cropped part.

# Keyword

- `keep_escape_seq::Bool`: If `false`, the ANSI escape sequence in the cropped field will
    not be computed. In this case, the second argument returned is always empty.
    (**Default** = `true`)
- `printable_string_width::Int`: Provide the printable string width to reduce the
    computational burden. If this parameters is lower than 0, the printable width is compute
    internally. (**Default** = -1)

!!! warning

    If the keyword `keep_escape_seq` is set to `true`, all the string must be processed,
    which can lead to a substantial increase in computational time.

# Examples

```julia-repl
julia> right_crop("\e[1mPlease, crop this \e[0mstring.", 8)
("\e[1mPlease, crop this", "\e[0m")

julia> right_crop("\e[1mPlease, crop this \e[0mstring.", 8; keep_escape_seq = false)
("\e[1mPlease, crop this", "")
```
"""
function right_crop(
    str::AbstractString,
    crop_width::Int;
    keep_escape_seq::Bool = true,
    printable_string_width::Int = -1
)
    buf_ansi = IOBuffer()
    buf_str  = IOBuffer(sizehint = floor(Int, max(0, sizeof(str) - crop_width)))
    state    = :text

    str_width = if printable_string_width < 0
        printable_textwidth(str)
    else
        printable_string_width
    end

    remaining_chars = str_width - crop_width

    for c in str
        state = _next_string_state(c, state)

        if remaining_chars <= 0
            !keep_escape_seq && break
            state != :text && write(buf_ansi, c)
            continue
        end

        # If we are not in a text section, just write the character to the ANSI buffer.
        if state != :text
            write(buf_str, c)
            continue
        end

        Δ = textwidth(c)
        remaining_chars -= Δ

        # If `remaining_chars` is negative, it means that we have a character that
        # occupies more than 1 character. In this case, we fill the string with
        # space.
        if remaining_chars < 0
            write(buf_str, " "^(-remaining_chars))
            remaining_chars = 0
            continue
        end

        write(buf_str, c)
    end

    return String(take!(buf_str)), String(take!(buf_ansi))
end

## Description #############################################################################
#
# Functions related to ANSI escape sequences.
#
############################################################################################

export parse_ansi_string

"""
    parse_ansi_string(str::AbstractString) -> Vector{Pair{String, Decoration}}

Parse the ANSI escape sequences in `str` and return a vector of pairs where each pair
contains a substring and its corresponding `Decoration`.
"""
function parse_ansi_string(str::AbstractString)
    # Buffers to store the tokens and the ANSI escape sequences. Notice that we must use
    # `sizeof`, which is the number of bytes, instead of `length`, which is the number of
    # characters. The latter requires a full scan of the string and underestimates the
    # required size if the string is not ASCII. The buffer with the escape sequences only
    # holds a run of them, which is much shorter than the string itself.
    buf_text = IOBuffer(; sizehint = max(sizeof(str), 1))
    buf_ansi = IOBuffer(; sizehint = 64)

    # Output vector with the string parts and their decoration.
    voutput = Pair{String, Decoration}[]

    # Store the current state of the string parsing.
    state = :text

    # Indicate if we are currently capturing an ANSI escape sequence.
    capturing_ansi = false

    # Store the current decoration of the string.
    decoration = Decoration()

    @inbounds for i in eachindex(str)
        c = str[i]

        state = _next_string_state(c, state)

        if state == :text
            capturing_ansi = false
            write(buf_text, c)
            continue
        end

        # We are starting a run of escape sequences. Hence, we must close the current
        # token, which is decorated by the previous run. Notice that we test the buffers
        # instead of the index because nothing must be pushed if the string begins with an
        # escape sequence.
        if !capturing_ansi && ((position(buf_text) > 0) || (position(buf_ansi) > 0))
            token = String(take!(buf_text))

            if position(buf_ansi) > 0
                decoration = update_decoration(decoration, String(take!(buf_ansi)))
            end

            push!(voutput, token => decoration)
        end

        write(buf_ansi, c)
        capturing_ansi = true
    end

    token = String(take!(buf_text))

    if position(buf_ansi) > 0
        decoration = update_decoration(decoration, String(take!(buf_ansi)))
    end

    push!(voutput, token => decoration)

    return voutput
end

############################################################################################
#                                    Private Functions                                     #
############################################################################################

"""
    _next_sgr_parameter(
        code::AbstractString,
        i::Int,
        require_value::Bool = false
    ) -> Int, Int, Bool

Read the SGR parameter of `code` that begins at the byte index `i`.

# Arguments

- `code::AbstractString`: Parameters of an SGR sequence.
- `i::Int`: Byte index where the parameter begins.
- `require_value::Bool`: If `true`, an omitted parameter is reported as not found instead of
    taking its default value. This is required by the arguments of the extended color
    modes, which are not defined by ECMA-48 and have no default.
    (**Default** = `false`)

# Returns

- `Int`: Value of the parameter, or 0 if it was omitted.
- `Int`: Byte index where the next parameter begins. It is past the end of `code` if this
    was the last parameter.
- `Bool`: `true` if a parameter was read. It is `false` if `i` is past the end of `code` or
    if the parameter is not a valid number, in which case the caller must skip it.
"""
function _next_sgr_parameter(code::AbstractString, i::Int, require_value::Bool = false)
    last_index = ncodeunits(code)

    (i > last_index + 1) && return 0, i, false

    value      = 0
    num_digits = 0
    valid      = true

    j = i
    while j ≤ last_index
        b = codeunit(code, j)
        (b == UInt8(';')) && break

        if UInt8('0') ≤ b ≤ UInt8('9')
            value = 10 * value + (b - UInt8('0'))
            num_digits += 1
        else
            valid = false
        end

        j += 1
    end

    # If the delimiter was not found, this was the last parameter and the next one begins
    # past the end of the string, ending the loop in the caller.
    next_index = j > last_index ? last_index + 2 : j + 1

    # ECMA-48 states that an omitted parameter takes its default value, which is 0 for SGR.
    # Hence, `\e[m` is equivalent to `\e[0m`, and so is any empty parameter. A parameter
    # with more digits than we can hold is reported as invalid.
    valid &= num_digits ≤ 9
    require_value && (valid &= num_digits > 0)

    return value, next_index, valid
end

"""
    _parse_ansi_decoration_code(decoration::Decoration, code::AbstractString) -> Decoration

Parse the ANSI decoration `code`, which contains only the parameters of an SGR sequence, and
return the updated decoration given the initial `decoration`.
"""
function _parse_ansi_decoration_code(decoration::Decoration, code::AbstractString)
    # Unpack fields.
    foreground = decoration.foreground
    background = decoration.background
    bold       = decoration.bold
    italic     = decoration.italic
    underline  = decoration.underline
    reversed   = decoration.reversed

    # `reset` must not be copied to other decorations. Hence, we need to reset it here.
    reset = false

    # We walk the parameters instead of splitting the code because the latter allocates a
    # vector for every escape sequence, which is the hottest path of this package.
    pos        = firstindex(code)
    last_index = ncodeunits(code)

    while pos ≤ last_index + 1
        code_i, pos, found = _next_sgr_parameter(code, pos)
        found || continue

        if code_i == 0
            # If we have a reset, neglect all the configurations we have parsed so far,
            # except the hyperlinks. Notice that we must not stop here because the same
            # sequence can contain other codes after the reset, like in `\e[0;31m`.
            foreground = ""
            background = ""
            bold       = unchanged
            italic     = unchanged
            underline  = unchanged
            reversed   = unchanged
            reset      = true

        elseif code_i == 1
            bold = active

        elseif code_i == 3
            italic = active

        elseif code_i == 4
            underline = active

        elseif code_i == 7
            reversed = active

        elseif code_i == 22
            bold = inactive

        elseif code_i == 23
            italic = inactive

        elseif code_i == 24
            underline = inactive

        elseif code_i == 27
            reversed = inactive

        elseif (30 ≤ code_i ≤ 37) || (code_i == 39) || (90 ≤ code_i ≤ 97)
            foreground = string(code_i)

        elseif (40 ≤ code_i ≤ 47) || (code_i == 49) || (100 ≤ code_i ≤ 107)
            background = string(code_i)

            # 256-color and true-color (24-bit) support. Both the foreground (38) and the
            # background (48) use the same syntax, which takes additional parameters.
        elseif (code_i == 38) || (code_i == 48)
            is_foreground = code_i == 38

            color_type, pos, found_type = _next_sgr_parameter(code, pos, true)

            if found_type && (color_type == 5)
                # 256-color mode. In this case, we must have another parameter with the
                # color.
                color_code, pos, found_color = _next_sgr_parameter(code, pos, true)

                if found_color
                    color = string(code_i, ";5;", color_code)
                    is_foreground ? (foreground = color) : (background = color)
                end

            elseif found_type && (color_type == 2)
                # True-color (24-bit) mode. In this case, we must have another three
                # parameters with the RGB color.
                color_r, pos, found_r = _next_sgr_parameter(code, pos, true)
                color_g, pos, found_g = _next_sgr_parameter(code, pos, true)
                color_b, pos, found_b = _next_sgr_parameter(code, pos, true)

                if found_r && found_g && found_b
                    color = string(code_i, ";2;", color_r, ";", color_g, ";", color_b)
                    is_foreground ? (foreground = color) : (background = color)
                end
            end
        end
    end

    return Decoration(
        foreground,
        background,
        bold,
        italic,
        reversed,
        underline,
        reset,
        decoration.hyperlink_url,
        decoration.hyperlink_url_changed,
    )
end

## Description #############################################################################
#
# Functions related to decorations in strings.
#
############################################################################################

export drop_inactive_properties, get_decorations, get_and_remove_decorations
export parse_decoration, remove_decorations, replace_default_background, update_decoration

"""
    drop_inactive_properties(decoration::Decoration) -> Decoration

Mark the inactive properties of `decoration` as unchanged. This operation can avoid
unnecessary escape sequences after decorations are reset.
"""
function drop_inactive_properties(decoration::Decoration)
    # Unpack fields.
    foreground = decoration.foreground
    background = decoration.background
    bold       = decoration.bold
    italic     = decoration.italic
    underline  = decoration.underline
    reversed   = decoration.reversed

    # If a field is inactive or if it is a reset to a default value, drop it by returning to
    # default.
    if foreground == "39"
        foreground = ""
    end

    if background == "49"
        background = ""
    end

    if bold == inactive
        bold = unchanged
    end

    if italic == inactive
        italic = unchanged
    end

    if underline == inactive
        underline = unchanged
    end

    if reversed == inactive
        reversed = unchanged
    end

    return Decoration(
        foreground,
        background,
        bold,
        italic,
        reversed,
        underline,
        false,
        decoration.hyperlink_url,
        decoration.hyperlink_url_changed,
    )
end

"""
    get_decorations(str::AbstractString) -> String

Return a string with the decorations in `str`.

# Extended Help

## Examples

```julia
julia> get_decorations(
           "This is a \\e[1mbold string\\e[45mwith a different background\\e[0m."
       )
"\\e[1m\\e[45m\\e[0m"
```
"""
function get_decorations(str::AbstractString)
    buf = IOBuffer(; sizehint = sizeof(str))

    for m in eachmatch(_REGEX_ANSI_SEQUENCES, str)
        write(buf, m.match)
    end

    return String(take!(buf))
end

"""
    get_and_remove_decorations(str::AbstractString) -> String, String

Get and remove the decorations in `str`. The first returned string contains the decorations
whereas the second contains the plain text.
"""
function get_and_remove_decorations(str::AbstractString)
    buf_decorations = IOBuffer(; sizehint = sizeof(str))
    buf_plain_str   = IOBuffer(; sizehint = sizeof(str))

    str_i = 1

    # Loop over each match of an ANSI escape sequence.
    for m in eachmatch(_REGEX_ANSI_SEQUENCES, str)
        # Write everything from the previous match up to the last character before the
        # current match.
        if m.offset - 1 > 0
            str_f = prevind(str, m.offset)
            write(buf_plain_str, SubString(str, str_i, str_f))
        end

        write(buf_decorations, m.match)

        # `str_i` now has the index just after the current match.
        str_i = m.offset + ncodeunits(m.match)
    end

    # Write the rest of the string.
    write(buf_plain_str, SubString(str, str_i, lastindex(str)))

    return String(take!(buf_decorations)), String(take!(buf_plain_str))
end

"""
    parse_decoration(code::AbstractString) -> Decoration

Parse the decoration in `code` and return the resulting `Decoration` object.
"""
function parse_decoration(code::AbstractString)
    state = :text
    buf = IOBuffer(; sizehint = sizeof(code))
    decoration = Decoration()

    for c in code
        state = _next_string_state(c, state)

        if state == :escape_state_begin
            truncate(buf, 0)
            write(buf, c)

        elseif state == :escape_state_end
            write(buf, c)
            str = String(take!(buf))
            decoration = update_decoration(decoration, str)

        elseif state == :text
            truncate(buf, 0)

        else
            write(buf, c)
        end
    end

    return decoration
end

"""
    remove_decorations(str::AbstractString)

Remove all the decorations added by ANSI escape sequences from the string `str`.
"""
function remove_decorations(str::AbstractString)
    # After some testing, it turns out that using the ANSI regex is way faster
    # than using the string state.
    return replace(str, _REGEX_ANSI_SEQUENCES => "")
end

"""
    replace_default_background(
        str::AbstractString,
        new_background::AbstractString
    ) -> String

Replace the default background in `str` by the one in `new_background`. The latter must be
represented using a valid ANSI escape sequence that sets the background.

Internally, this function replaces the ANSI sequences that reset the decoration (`\\e[0m`)
and set the default background (`\\e[49m`) with the new background while keeping all the
other supported decorations.
"""
function replace_default_background(str::AbstractString, new_background::AbstractString)
    # Buffer to store the new string.
    buf_new_str = IOBuffer(; sizehint = sizeof(str))

    str_i = 1

    # Number of code units in the string.
    str_code_units = ncodeunits(str)

    # The first thing we need to do is to set the new background.
    write(buf_new_str, _CSI, new_background, "m")

    # Position in the buffer right after the new background was written. If we must set the
    # background again while still at this position, the sequence would be redundant
    # because nothing was written in between.
    background_set_at = position(buf_new_str)

    # This variable stores the current decoration when we split the string in each ANSI
    # escape sequence.
    current_decoration = Decoration()

    # Loop over each match of an ANSI escape sequence.
    for m in eachmatch(_REGEX_ANSI_SEQUENCES, str)
        # Write everything from the previous match up to the last character
        # before the current match.
        if m.offset - 1 > 0
            str_f = prevind(str, m.offset)
            write(buf_new_str, SubString(str, str_i, str_f))
        end

        # `str_i` now has the index just after the current match.
        str_i = m.offset + ncodeunits(m.match)

        d = parse_decoration(m.match)
        current_decoration = update_decoration(current_decoration, d)

        # We should only modify the decoration in case of a reset or if the user wants the
        # default background.
        if d.reset
            # If we are at the end of the string, we should not write the reset sequence and
            # treat it after the loop, where we will restore background to the default one.
            # Otherwise, we will have duplicated escape sequences.
            if str_i <= str_code_units
                write(buf_new_str, _CSI, "0m", _CSI, new_background, "m")
                background_set_at = position(buf_new_str)
                current_decoration = Decoration()
            end

        elseif d.background == "49"
            # If we are at the end of the string, we should not write the background
            # sequence and treat it after the loop, where we will restore background to the
            # default one. Otherwise, we will have duplicated escape sequences.
            if str_i <= str_code_units
                # If nothing was written since the background was last set, writing it
                # again would only add a redundant escape sequence.
                background = if position(buf_new_str) == background_set_at
                    ""
                else
                    new_background
                end

                new_decoration = Decoration(;
                    foreground            = d.foreground,
                    background            = background,
                    bold                  = d.bold,
                    italic                = d.italic,
                    reversed              = d.reversed,
                    underline             = d.underline,
                    reset                 = d.reset,
                    hyperlink_url         = d.hyperlink_url,
                    hyperlink_url_changed = d.hyperlink_url_changed,
                )

                write(buf_new_str, String(new_decoration))
            end

        else
            write(buf_new_str, m.match)
        end
    end

    # Write the rest of the string.
    write(buf_new_str, SubString(str, str_i, lastindex(str)))

    # If the last decoration is a reset, we should also reset everything here.
    if current_decoration.reset
        write(buf_new_str, _CSI, "0m")

        # If the last decoration is a background change, or if the background is not
        # modified, we should reset to the terminal default background.
    elseif isempty(current_decoration.background) || (current_decoration.background == "49")
        write(buf_new_str, _CSI, "49m")
    end

    return String(take!(buf_new_str))
end

"""
    _apply_hyperlink(decoration::Decoration, hyperlink_url::String) -> Decoration

Return `decoration` with its hyperlink replaced by `hyperlink_url`, marking the hyperlink
as changed. All the other properties are kept.
"""
function _apply_hyperlink(decoration::Decoration, hyperlink_url::String)
    return Decoration(
        decoration.foreground,
        decoration.background,
        decoration.bold,
        decoration.italic,
        decoration.reversed,
        decoration.underline,
        decoration.reset,
        hyperlink_url,
        true,
    )
end

"""
    update_decoration(decoration::Decoration, code::String) -> Decoration
    update_decoration(decoration::Decoration, new::Decoration) -> Decoration

Update the current `decoration` given the decorations in the string `code` or in `new`.
"""
function update_decoration(decoration::Decoration, code::String)
    state = :text
    buf = IOBuffer(; sizehint = sizeof(code))
    hyperlink = false

    for c in code
        previous_state = state
        state = _next_string_state(c, state)

        if state == :escape_state_begin
            truncate(buf, 0)

        elseif state == :escape_hyperlink_3
            # If we reached this state, the next one is the URL. Hence, we clean the buffer
            # and inform that we are processing a hyperlink.
            truncate(buf, 0)
            hyperlink = true

        elseif state == :escape_hyperlink_url
            write(buf, c)

        elseif state == :escape_hyperlink_end
            # The hyperlink was terminated by ST (`\x1b\\`). The buffer contains only the
            # new URL.
            decoration = _apply_hyperlink(decoration, String(take!(buf)))

        elseif state == :escape_state_end
            if hyperlink
                hyperlink = false

                # A hyperlink terminated by BEL (`\a`) reaches this state directly from
                # the URL state, so the URL is still in the buffer and must be applied
                # here. If it was terminated by ST, it was already applied above.
                if previous_state ∈ (:escape_hyperlink_3, :escape_hyperlink_url)
                    decoration = _apply_hyperlink(decoration, String(take!(buf)))
                end

                continue
            end

            # Only SGR sequences, *i.e.* those terminated by `m`, change the decoration.
            # Every other CSI sequence must be discarded. Otherwise, we would parse the
            # parameters of, for example, a cursor movement (`\e[1A`) or an erase
            # (`\e[0K`) as if they were decoration codes.
            sgr_code = String(take!(buf))
            (c != 'm') && continue

            decoration = _parse_ansi_decoration_code(decoration, sgr_code)

        elseif state == :text
            truncate(buf, 0)

        elseif state != :escape_state_opening
            write(buf, c)
        end
    end

    return decoration
end

function update_decoration(decoration::Decoration, new::Decoration)
    foreground = decoration.foreground
    background = decoration.background
    bold       = decoration.bold
    italic     = decoration.italic
    underline  = decoration.underline
    reset      = decoration.reset
    reversed   = decoration.reversed
    hl_url     = decoration.hyperlink_url

    hl_url_changed = new.hyperlink_url_changed

    !isempty(new.foreground) && (foreground = new.foreground)
    !isempty(new.background) && (background = new.background)
    new.bold != unchanged && (bold = new.bold)
    new.italic != unchanged && (italic = new.italic)
    new.underline != unchanged && (underline = new.underline)
    new.reset && (reset = true)
    new.reversed != unchanged && (reversed = new.reversed)
    hl_url_changed && (hl_url = new.hyperlink_url)

    return Decoration(
        foreground,
        background,
        bold,
        italic,
        reversed,
        underline,
        reset,
        hl_url,
        hl_url_changed,
    )
end

############################################################################################
#                                        Julia API                                         #
############################################################################################

# Convert `Decoration` to string.
#
# NOTE: The conversion is implemented in the `String` constructor instead of
# `Base.convert(::Type{String}, ::Decoration)` on purpose. `String` already has many
# constructor methods, so call sites like `String(x::Any)` are dynamically dispatched and
# adding one more method is harmless. On the other hand, call sites in Base and other
# packages that are inferred as `convert(::Type{String}, ::Any)` (`push!` to
# `Vector{String}`, `setindex!` to `Dict{String, ...}`, `setfield!` of `String` fields,
# ...) are union-split over the few existing methods. Hence, adding a new `convert` method
# invalidates all of them, leading to massive latency when loading other packages.
function String(d::Decoration)
    # Fast path for the most common case. It must come first so that nothing below is
    # computed for a decoration that is rendered as an empty string. Notice that comparing
    # with `===` is enough because all the empty strings are the same object.
    d === _DEFAULT_DECORATION && return ""

    # Check if we must change the hyperlink. Notice that a reset **does not** clean it.
    str_hyperlink = if d.hyperlink_url_changed
        "\x1B]8;;$(d.hyperlink_url)\x1B\\"
    else
        ""
    end

    # The reset must be written before the other properties instead of returning here
    # because the same ANSI sequence can set a decoration after resetting everything, like
    # in `\e[0;31m`.
    str_reset = d.reset ? _RESET_DECORATIONS : ""

    # TODO: Check if we can avoid adding so many `_CSI`.
    str_foreground = !isempty(d.foreground) ? "$(_CSI)$(d.foreground)m" : ""
    str_background = !isempty(d.background) ? "$(_CSI)$(d.background)m" : ""
    str_bold       = d.bold != unchanged ? "$(_CSI)$(d.bold == active ? "1" : "22")m" : ""
    str_italic     = if d.italic != unchanged
        "$(_CSI)$(d.italic == active ? "3" : "23")m"
    else
        ""
    end

    str_underline = if d.underline != unchanged
        "$(_CSI)$(d.underline == active ? "4" : "24")m"
    else
        ""
    end

    str_reversed = if d.reversed != unchanged
        "$(_CSI)$(d.reversed == active ? "7" : "27")m"
    else
        ""
    end

    return string(
        str_hyperlink,
        str_reset,
        str_foreground,
        str_background,
        str_bold,
        str_italic,
        str_underline,
        str_reversed,
    )
end

## Description #############################################################################
#
# Tests related with string searching.
#
############################################################################################

@testset "String Search" begin
    str = """
        Test 1 😅 \e[38;5;231;48;5;243mTest 2 😅 \e[38;5;201;48;5;243mTest\e[0m
        Test 1 😅 \e[38;5;231;48;5;243mTest 2 😅 \e[38;5;201;48;5;243mTest\e[0m
        """

    expected = [(11, 9), (35, 9)]
    search_result = string_search(str, r"Test 2 😅")
    @test search_result == expected

    @test string_search("one two one three one", r"one") == [(1, 3), (9, 3), (19, 3)]
end

@testset "String Search With Unicode" begin
    @test string_search("ééé", r"é") == [(1, 1), (2, 1), (3, 1)]

    # The reported column must be the one where the match begins. Hence, it must not
    # include the width of the first character of the match itself.
    @test string_search("😅😅😅", r"😅") == [(1, 2), (3, 2), (5, 2)]
    @test string_search("日本語", r"本") == [(3, 2)]

    @test string_search("é éé ééé", r"é+") == [(1, 1), (3, 2), (6, 3)]

    decorated = "\e[31méé\e[0m 😅\e[1m😅\e[0m"
    @test string_search(decorated, r"é|😅") == [(1, 1), (2, 1), (4, 2), (6, 2)]

    parent = "xxéé😅😅yy"
    substring = SubString(parent, 3, prevind(parent, lastindex(parent), 2))
    @test string_search(substring, r"😅") == [(3, 2), (5, 2)]
end

@testset "String Search With Empty Matches" begin
    # A regex that can match an empty string yields an offset one past the last byte at the
    # end of the string, which must not be treated as a valid index.
    @test string_search("abc", r"x*") == [(1, 0), (2, 0), (3, 0), (4, 0)]
    @test string_search("", r"x*") == [(1, 0)]
    @test string_search("aé", r"") == [(1, 0), (2, 0), (3, 0)]
end

@testset "String Search by Line" begin
    str = """
        Test 1 😅 \e[38;5;231;48;5;243mTest 2 😅 \e[38;5;201;48;5;243mTest\e[0m
        Test 1 😅 \e[38;5;231;48;5;243mTest 2 😅 \e[38;5;201;48;5;243mTest\e[0m
        Test 1 😅 \e[38;5;231;48;5;243mTest 2 😅 \e[38;5;201;48;5;243mTest\e[0m
        Test 1 😅 \e[38;5;231;48;5;243mTest 2 😅 \e[38;5;201;48;5;243mTest\e[0m
        Test 1 😅 \e[38;5;231;48;5;243mTest 2 😅 \e[38;5;201;48;5;243mTest\e[0m
        """

    search_result = string_search_per_line(str, r"Test 2 😅")

    @test search_result[1] == [(11, 9)]
    @test search_result[2] == [(11, 9)]
    @test search_result[3] == [(11, 9)]
    @test search_result[4] == [(11, 9)]
    @test search_result[5] == [(11, 9)]
    @test length(search_result) == 5
end

## Description #############################################################################
#
# Prepared, indexed text layouts used by `textview`.
#
############################################################################################

export TextViewLayout

############################################################################################
#                                   Types and Structures                                   #
############################################################################################

"""
    struct TextSeekCheckpoint

Store a sparse position for seeking by printable column.

# Fields

- `column::Int`: Printable column at the checkpoint.
- `byte_index::Int`: String byte index at the checkpoint.
"""
struct TextSeekCheckpoint
    column::Int
    byte_index::Int
end

"""
    struct AnsiStateTransition

Summarize how a sequence of ANSI events changes a decoration state.

# Fields

- `clear_sgr::Bool`: Whether the transition clears prior SGR attributes.
- `has_sgr::Bool`: Whether the transition contains an SGR event.
- `final_reset::Bool`: Reset state of the final SGR event.
- `foreground_changed::Bool`: Whether the foreground is overridden.
- `foreground::String`: Final foreground value.
- `background_changed::Bool`: Whether the background is overridden.
- `background::String`: Final background value.
- `bold_changed::Bool`: Whether the bold state is overridden.
- `bold::DecorationState`: Final bold state.
- `italic_changed::Bool`: Whether the italic state is overridden.
- `italic::DecorationState`: Final italic state.
- `reversed_changed::Bool`: Whether the reversed state is overridden.
- `reversed::DecorationState`: Final reversed state.
- `underline_changed::Bool`: Whether the underline state is overridden.
- `underline::DecorationState`: Final underline state.
- `hyperlink_changed::Bool`: Whether the hyperlink is overridden.
- `hyperlink_url::String`: Final hyperlink URL.
"""
struct AnsiStateTransition
    clear_sgr::Bool
    has_sgr::Bool
    final_reset::Bool
    foreground_changed::Bool
    foreground::String
    background_changed::Bool
    background::String
    bold_changed::Bool
    bold::DecorationState
    italic_changed::Bool
    italic::DecorationState
    reversed_changed::Bool
    reversed::DecorationState
    underline_changed::Bool
    underline::DecorationState
    hyperlink_changed::Bool
    hyperlink_url::String
end

"""
    struct TextAnsiEvent

Store a recognized zero-width ANSI event, its source offsets, and its parsed transition.

# Fields

- `column::Int`: Printable column preceding the event.
- `byte_start::UInt64`: First source byte index of the event.
- `byte_length::UInt32`: Number of source bytes in the event.
- `transition_index::Int32`: Index of the event's compact parsed transition.
"""
struct TextAnsiEvent
    column::Int
    byte_start::UInt64
    byte_length::UInt32
    transition_index::Int32
end

"""
    struct CompactAnsiTransition

Store parsed event state as packed flags and source-backed value ranges.

# Fields

- `flags::UInt16`: Packed transition-presence and transition-state flags.
- `decoration_states::UInt8`: Packed bold, italic, reversed, and underline states.
- `foreground_ref::UInt64`: Packed source range or fallback for the foreground value.
- `background_ref::UInt64`: Packed source range or fallback for the background value.
- `hyperlink_ref::UInt64`: Packed source range or fallback for the hyperlink URL.
"""
struct CompactAnsiTransition
    flags::UInt16
    decoration_states::UInt8
    foreground_ref::UInt64
    background_ref::UInt64
    hyperlink_ref::UInt64
end

"""
    struct TextLineMetadata

Store indexed metadata for one non-ASCII line. Use `nothing` for plain ASCII lines to avoid
allocating empty per-line metadata vectors.

# Fields

- `seek_checkpoints::Vector{TextSeekCheckpoint}`: Sparse printable-column checkpoints.
- `ansi_events::Vector{TextAnsiEvent}`: Recognized zero-width ANSI events.
- `ansi_transitions::Vector{CompactAnsiTransition}`: Interned compact transitions.
- `ansi_fallback_values::Vector{String}`: Values that cannot reference source bytes.
- `ansi_prefix_checkpoints::Vector{AnsiStateTransition}`: Cached prefix transitions.
- `ansi_suffix_checkpoints::Vector{AnsiStateTransition}`: Cached suffix transitions.
"""
struct TextLineMetadata
    seek_checkpoints::Vector{TextSeekCheckpoint}
    ansi_events::Vector{TextAnsiEvent}
    ansi_transitions::Vector{CompactAnsiTransition}
    ansi_fallback_values::Vector{String}
    ansi_prefix_checkpoints::Vector{AnsiStateTransition}
    ansi_suffix_checkpoints::Vector{AnsiStateTransition}
end

"""
    struct TextViewLayout <: AbstractVector{String}
    TextViewLayout(text::AbstractString; kwargs...) -> TextViewLayout
    TextViewLayout(
        input_lines::AbstractVector{<:AbstractString};
        kwargs...
    ) -> TextViewLayout

Represent text prepared for repeated viewport rendering with [`textview`](@ref).

The layout owns canonical `String` lines, cached printable widths, and sparse Unicode
and ANSI checkpoints. Search matches and visual overlays are intentionally not cached and
remain dynamic. Construction performs one-time linear preprocessing and retains metadata
proportional to lines, Unicode scalars at the configured stride, and recognized ANSI events.

The representation is private. A layout owns its source and is an immutable snapshot. It
provides a read-only `AbstractVector{String}` interface for indexing and iteration. Use
`collect(layout)` when a mutable copy of its lines is required.

# Fields

- `_lines::Vector{String}`: Owned canonical text lines.
- `_printable_widths::Vector{Int}`: Printable width of each line.
- `_plain_ascii::BitVector`: Whether each line contains only plain ASCII text.
- `_ansi_fallback::BitVector`: Whether each line requires generic ANSI parsing.
- `_metadata::Vector{Union{Nothing, TextLineMetadata}}`: Optional indexed line metadata.
- `_document_ansi_checkpoints::Vector{Decoration}`: ANSI state after each complete line.
- `_checkpoint_stride::Int`: Unicode seek-checkpoint stride.
- `_ansi_checkpoint_stride::Int`: ANSI event-checkpoint stride.

# Arguments

- `text::AbstractString`: Text to split into owned canonical lines.
- `input_lines::AbstractVector{<:AbstractString}`: Lines to copy into owned storage.

# Keywords

- `checkpoint_stride::Int`: Set the Unicode seek-checkpoint stride.
    (**Default**: 256)
- `ansi_checkpoint_stride::Int`: Set the ANSI event-checkpoint stride.
    (**Default**: 32)

# Returns

- `TextViewLayout`: Owned immutable snapshot with a read-only vector interface.
"""
struct TextViewLayout <: AbstractVector{String}
    _lines::Vector{String}
    _printable_widths::Vector{Int}
    _plain_ascii::BitVector
    _ansi_fallback::BitVector
    _metadata::Vector{Union{Nothing, TextLineMetadata}}
    _document_ansi_checkpoints::Vector{Decoration}
    _checkpoint_stride::Int
    _ansi_checkpoint_stride::Int

    """
        TextViewLayout(text::AbstractString; kwargs...) -> TextViewLayout

    Prepare an owned immutable layout from newline-delimited `text`.

    # Arguments

    - `text::AbstractString`: Text to split into owned canonical lines.

    # Keywords

    - `checkpoint_stride::Int`: Set the Unicode seek-checkpoint stride.
        (**Default**: 256)
    - `ansi_checkpoint_stride::Int`: Set the ANSI event-checkpoint stride.
        (**Default**: 32)

    # Returns

    - `TextViewLayout`: Prepared owned snapshot of `text`.
    """
    function TextViewLayout(
        text::AbstractString; checkpoint_stride::Int = 256, ansi_checkpoint_stride::Int = 32
    )
        return TextViewLayout(split(text, '\n'); checkpoint_stride, ansi_checkpoint_stride)
    end

    """
        TextViewLayout(
            input_lines::AbstractVector{<:AbstractString};
            kwargs...
        ) -> TextViewLayout

    Prepare an owned immutable layout from `input_lines`.

    # Arguments

    - `input_lines::AbstractVector{<:AbstractString}`: Lines to copy into owned storage.

    # Keywords

    - `checkpoint_stride::Int`: Set the Unicode seek-checkpoint stride.
        (**Default**: 256)
    - `ansi_checkpoint_stride::Int`: Set the ANSI event-checkpoint stride.
        (**Default**: 32)

    # Returns

    - `TextViewLayout`: Prepared owned snapshot of `input_lines`.
    """
    function TextViewLayout(
        input_lines::AbstractVector{<:AbstractString};
        checkpoint_stride::Int = 256,
        ansi_checkpoint_stride::Int = 32,
    )
        components = _prepare_text_view_layout(
            input_lines; checkpoint_stride, ansi_checkpoint_stride
        )

        return new(
            components.lines,
            components.printable_widths,
            components.plain_ascii,
            components.ansi_fallback,
            components.metadata,
            components.document_ansi_checkpoints,
            checkpoint_stride,
            ansi_checkpoint_stride,
        )
    end
end

"""
    Base.IndexStyle(::Type{TextViewLayout}) -> IndexLinear

Return linear indexing for [`TextViewLayout`](@ref).

# Returns

- `IndexLinear`: Linear array-indexing style.
"""
Base.IndexStyle(::Type{TextViewLayout}) = IndexLinear()

"""
    Base.size(layout::TextViewLayout) -> Tuple{Int}

Return the one-dimensional size of `layout`.

# Arguments

- `layout::TextViewLayout`: Layout to measure.

# Returns

- `Tuple{Int}`: One-element tuple containing the number of lines.
"""
Base.size(layout::TextViewLayout) = (length(layout._lines),)

"""
    Base.getindex(layout::TextViewLayout, index::Int) -> String

Return the canonical line at `index`.

# Arguments

- `layout::TextViewLayout`: Layout containing the line.
- `index::Int`: Linear line index.

# Returns

- `String`: Canonical line at `index`.
"""
Base.getindex(layout::TextViewLayout, index::Int) = layout._lines[index]

"""
    _prepare_text_view_layout(
        input_lines::AbstractVector{<:AbstractString};
        kwargs...
    ) -> NamedTuple

Prepare owned source lines for an inner [`TextViewLayout`](@ref) constructor.

# Arguments

- `input_lines::AbstractVector{<:AbstractString}`: Source lines to copy and index.

# Keywords

- `checkpoint_stride::Int`: Set the Unicode seek-checkpoint stride.
    (**Default**: 256)
- `ansi_checkpoint_stride::Int`: Set the ANSI event-checkpoint stride.
    (**Default**: 32)

# Returns

- `NamedTuple`: Owned lines and all derived layout metadata.
"""
function _prepare_text_view_layout(
    input_lines::AbstractVector{<:AbstractString};
    checkpoint_stride::Int = 256,
    ansi_checkpoint_stride::Int = 32,
)
    checkpoint_stride > 0 || throw(ArgumentError("`checkpoint_stride` must be positive."))

    ansi_checkpoint_stride > 0 ||
        throw(ArgumentError("`ansi_checkpoint_stride` must be positive."))

    lines = String[string(line) for line in input_lines]
    num_lines = length(lines)
    printable_widths = Vector{Int}(undef, num_lines)
    plain_ascii = falses(num_lines)
    ansi_fallback = falses(num_lines)
    metadata = Vector{Union{Nothing, TextLineMetadata}}(nothing, num_lines)
    document_ansi_checkpoints = Vector{Decoration}(undef, num_lines)
    document_state = Decoration()

    # Buffers reused by every line so that we do not allocate them once per line. They hold
    # the ANSI events found by the regex, which are produced in increasing byte order.
    event_starts = Int[]
    event_stops = Int[]
    event_codes = SubString{String}[]
    transition_indices = Dict{AnsiStateTransition, Int32}()
    transition_cache = AnsiStateTransition[]

    for line_number in eachindex(lines)
        line = lines[line_number]
        is_plain_ascii = _is_printable_ascii(line)
        plain_ascii[line_number] = is_plain_ascii

        if is_plain_ascii
            printable_widths[line_number] = ncodeunits(line)
            document_ansi_checkpoints[line_number] = document_state
            continue
        end

        line_metadata = TextLineMetadata(
            TextSeekCheckpoint[],
            TextAnsiEvent[],
            CompactAnsiTransition[],
            String[],
            AnsiStateTransition[],
            AnsiStateTransition[],
        )

        metadata[line_number] = line_metadata
        events = line_metadata.ansi_events

        empty!(event_starts)
        empty!(event_stops)
        empty!(event_codes)
        empty!(transition_indices)

        has_unrecognized_escape = false

        # Recognize supported ANSI sequences before scanning Unicode printable widths. A
        # line without an escape byte cannot contain any sequence, so we skip the regex
        # scan and the auxiliary structures altogether. This is the common case for text
        # that is not ASCII only because it has accented or wide characters.
        if _has_escape_byte(line)
            recognized_bytes = falses(ncodeunits(line))

            for m in eachmatch(_REGEX_ANSI_SEQUENCES, line)
                byte_start = m.offset
                byte_end = byte_start + ncodeunits(m.match) - 1

                for k in byte_start:byte_end
                    recognized_bytes[k] = true
                end

                # Notice that we keep the match itself instead of copying it to a `String`.
                # It is a substring of the line, which is owned by the layout.
                code = m.match

                if !(
                    startswith(code, "\e]8;;") ||
                    (startswith(code, "\e[") && endswith(code, 'm'))
                )
                    has_unrecognized_escape = true
                end

                push!(event_starts, byte_start)
                push!(event_stops, byte_end)
                push!(event_codes, code)
            end

            for i in eachindex(codeunits(line))
                if (codeunit(line, i) == 0x1b) && !recognized_bytes[i]
                    has_unrecognized_escape = true
                    break
                end
            end
        end

        ansi_fallback[line_number] = has_unrecognized_escape

        # Scan Unicode scalars while omitting recognized zero-width ANSI events.
        column = 0
        scalar_count = 0
        column_boundary_byte = firstindex(line)
        has_zero_width_since_boundary = false
        next_checkpoint = checkpoint_stride
        next_scalar_checkpoint = checkpoint_stride
        i = firstindex(line)

        # The events were collected in increasing byte order. Hence, we can walk them with
        # a cursor instead of hashing the index of every byte of the line.
        next_event = 1

        while i ≤ ncodeunits(line)
            if (next_event ≤ length(event_starts)) && (event_starts[next_event] == i)
                # Attach zero-width events to their current printable column.
                event_end = event_stops[next_event]
                code = event_codes[next_event]
                next_event += 1

                transition = _ansi_transition(code)
                transition_index = get(transition_indices, transition, Int32(0))

                # The compact transition must only be built when the transition was not
                # seen yet. Besides being wasted work, building it can push entries into
                # `ansi_fallback_values` that would never be referenced.
                if iszero(transition_index)
                    push!(
                        line_metadata.ansi_transitions,
                        _compact_ansi_transition(
                            transition, code, i, line_metadata.ansi_fallback_values
                        ),
                    )
                    transition_index = Int32(length(line_metadata.ansi_transitions))
                    transition_indices[transition] = transition_index
                end

                event_length = event_end - i + 1
                event_length ≤ typemax(UInt32) ||
                    throw(ArgumentError("ANSI event is too large."))
                push!(
                    events,
                    TextAnsiEvent(
                        column, UInt64(i), UInt32(event_length), transition_index
                    ),
                )

                i = event_end + 1

                if length(events) % ansi_checkpoint_stride == 0
                    checkpoint_byte =
                        has_zero_width_since_boundary ? column_boundary_byte : i
                    push!(
                        line_metadata.seek_checkpoints,
                        TextSeekCheckpoint(column, checkpoint_byte),
                    )
                end
                continue
            end

            c = line[i]

            if (column ≥ next_checkpoint) || (scalar_count ≥ next_scalar_checkpoint)
                push!(
                    line_metadata.seek_checkpoints,
                    TextSeekCheckpoint(column, column_boundary_byte),
                )
                next_checkpoint = column + checkpoint_stride
                next_scalar_checkpoint = scalar_count + checkpoint_stride
            end

            character_width = textwidth(c)
            column += character_width
            scalar_count += 1
            i = nextind(line, i)

            if character_width > 0
                column_boundary_byte = i
                has_zero_width_since_boundary = false
            else
                has_zero_width_since_boundary = true
            end
        end

        printable_widths[line_number] = column

        # Every event below is visited three times, once to build the prefix checkpoints,
        # once to build the suffix ones, and once to advance the document state. Since the
        # transitions are deduplicated, we materialize each distinct one only once here
        # instead of rebuilding it, and its three string values, at every visit.
        empty!(transition_cache)

        for transition_index in eachindex(line_metadata.ansi_transitions)
            push!(
                transition_cache,
                _compact_transition_value(line, line_metadata, transition_index),
            )
        end

        # Cache the complete ANSI state after each full event block.
        prefix = line_metadata.ansi_prefix_checkpoints
        prefix_transition = _empty_ansi_transition()

        for (event_number, event) in enumerate(events)
            prefix_transition = _compose_ansi_transitions(
                prefix_transition, transition_cache[Int(event.transition_index)]
            )
            if event_number % ansi_checkpoint_stride == 0
                push!(prefix, prefix_transition)
            end
        end

        # Summarize each suffix from its corresponding ANSI block to the line end.
        suffix = line_metadata.ansi_suffix_checkpoints
        num_blocks = cld(length(events), ansi_checkpoint_stride)
        resize!(suffix, num_blocks)
        suffix_transition = _empty_ansi_transition()

        for block in num_blocks:-1:1
            first_event = (block - 1) * ansi_checkpoint_stride + 1
            last_event = min(block * ansi_checkpoint_stride, length(events))
            block_transition = _empty_ansi_transition()

            for event_number in first_event:last_event
                block_transition = _compose_ansi_transitions(
                    block_transition,
                    transition_cache[Int(events[event_number].transition_index)],
                )
            end

            suffix_transition = _compose_ansi_transitions(
                block_transition, suffix_transition
            )
            suffix[block] = suffix_transition
        end

        for event in events
            document_state = _apply_ansi_transition(
                document_state, transition_cache[Int(event.transition_index)]
            )
        end

        document_ansi_checkpoints[line_number] = document_state
    end

    return (;
        lines,
        printable_widths,
        plain_ascii,
        ansi_fallback,
        metadata,
        document_ansi_checkpoints,
    )
end

############################################################################################
#                                    Private Functions                                     #
############################################################################################

const _ANSI_CLEAR_SGR          = UInt16(1) << 0
const _ANSI_HAS_SGR            = UInt16(1) << 1
const _ANSI_FINAL_RESET        = UInt16(1) << 2
const _ANSI_FOREGROUND_CHANGED = UInt16(1) << 3
const _ANSI_BACKGROUND_CHANGED = UInt16(1) << 4
const _ANSI_BOLD_CHANGED       = UInt16(1) << 5
const _ANSI_ITALIC_CHANGED     = UInt16(1) << 6
const _ANSI_REVERSED_CHANGED   = UInt16(1) << 7
const _ANSI_UNDERLINE_CHANGED  = UInt16(1) << 8
const _ANSI_HYPERLINK_CHANGED  = UInt16(1) << 9
const _ANSI_FALLBACK_REF       = typemax(UInt32)

"""
    _event_transition(
        line::String,
        metadata::TextLineMetadata,
        event::TextAnsiEvent
    ) -> AnsiStateTransition

Return the interned transition referenced by `event`.

# Arguments

- `line::String`: Owned source line containing the event values.
- `metadata::TextLineMetadata`: Indexed metadata containing compact transitions.
- `event::TextAnsiEvent`: Event that references the requested transition.

# Returns

- `AnsiStateTransition`: Materialized transition for `event`.
"""
function _event_transition(line::String, metadata::TextLineMetadata, event::TextAnsiEvent)
    return _compact_transition_value(line, metadata, event.transition_index)
end

"""
    _compact_transition_value(
        line::String,
        metadata::TextLineMetadata,
        transition_index::Integer
    ) -> AnsiStateTransition

Materialize the deduplicated transition of `metadata` stored at `transition_index`, reading
its values from the owned source `line`.

# Arguments

- `line::String`: Owned source line containing the source-backed values.
- `metadata::TextLineMetadata`: Indexed metadata of the line.
- `transition_index::Integer`: Index of the transition to materialize.

# Returns

- `AnsiStateTransition`: Materialized transition.
"""
function _compact_transition_value(
    line::String, metadata::TextLineMetadata, transition_index::Integer
)
    transition = metadata.ansi_transitions[Int(transition_index)]
    flags = transition.flags
    states = transition.decoration_states

    return AnsiStateTransition(
        !iszero(flags & _ANSI_CLEAR_SGR),
        !iszero(flags & _ANSI_HAS_SGR),
        !iszero(flags & _ANSI_FINAL_RESET),
        !iszero(flags & _ANSI_FOREGROUND_CHANGED),
        _ansi_source_value(line, metadata.ansi_fallback_values, transition.foreground_ref),
        !iszero(flags & _ANSI_BACKGROUND_CHANGED),
        _ansi_source_value(line, metadata.ansi_fallback_values, transition.background_ref),
        !iszero(flags & _ANSI_BOLD_CHANGED),
        DecorationState(states & 0x03),
        !iszero(flags & _ANSI_ITALIC_CHANGED),
        DecorationState((states >> 2) & 0x03),
        !iszero(flags & _ANSI_REVERSED_CHANGED),
        DecorationState((states >> 4) & 0x03),
        !iszero(flags & _ANSI_UNDERLINE_CHANGED),
        DecorationState((states >> 6) & 0x03),
        !iszero(flags & _ANSI_HYPERLINK_CHANGED),
        _ansi_source_value(line, metadata.ansi_fallback_values, transition.hyperlink_ref),
    )
end

"""
    _compact_ansi_transition(
        transition::AnsiStateTransition,
        code::AbstractString,
        byte_start::Int,
        fallback_values::Vector{String}
    ) -> CompactAnsiTransition

Pack a parsed transition using source offsets for variable string values.

# Arguments

- `transition::AnsiStateTransition`: Parsed transition to pack.
- `code::AbstractString`: Source ANSI code represented by the transition.
- `byte_start::Int`: First byte index of `code` in its source line.
- `fallback_values::Vector{String}`: Storage for values that cannot reference source bytes.

# Returns

- `CompactAnsiTransition`: Packed source-backed transition.
"""
function _compact_ansi_transition(
    transition::AnsiStateTransition,
    code::AbstractString,
    byte_start::Int,
    fallback_values::Vector{String},
)
    flags = UInt16(0)
    transition.clear_sgr && (flags |= _ANSI_CLEAR_SGR)
    transition.has_sgr && (flags |= _ANSI_HAS_SGR)
    transition.final_reset && (flags |= _ANSI_FINAL_RESET)
    transition.foreground_changed && (flags |= _ANSI_FOREGROUND_CHANGED)
    transition.background_changed && (flags |= _ANSI_BACKGROUND_CHANGED)
    transition.bold_changed && (flags |= _ANSI_BOLD_CHANGED)
    transition.italic_changed && (flags |= _ANSI_ITALIC_CHANGED)
    transition.reversed_changed && (flags |= _ANSI_REVERSED_CHANGED)
    transition.underline_changed && (flags |= _ANSI_UNDERLINE_CHANGED)
    transition.hyperlink_changed && (flags |= _ANSI_HYPERLINK_CHANGED)

    states =
        UInt8(transition.bold) | (UInt8(transition.italic) << 2) |
        (UInt8(transition.reversed) << 4) | (UInt8(transition.underline) << 6)

    return CompactAnsiTransition(
        flags,
        states,
        _ansi_source_ref(code, transition.foreground, byte_start, fallback_values),
        _ansi_source_ref(code, transition.background, byte_start, fallback_values),
        _ansi_source_ref(code, transition.hyperlink_url, byte_start, fallback_values),
    )
end

"""
    _ansi_source_ref(
        code::AbstractString,
        value::String,
        byte_start::Int,
        fallback_values::Vector{String}
    ) -> UInt64

Encode a source byte range for `value`. Retain a fallback only when normalization means that
the parsed value does not occur verbatim in the source event.

# Arguments

- `code::AbstractString`: Source ANSI code containing `value` when it can be referenced.
- `value::String`: Parsed value to reference or retain as a fallback.
- `byte_start::Int`: First byte index of `code` in its source line.
- `fallback_values::Vector{String}`: Storage for values without a source reference.

# Returns

- `UInt64`: Packed source range or fallback index.
"""
function _ansi_source_ref(
    code::AbstractString, value::String, byte_start::Int, fallback_values::Vector{String}
)
    isempty(value) && return UInt64(0)
    range = findfirst(value, code)

    if isnothing(range)
        push!(fallback_values, value)
        return (UInt64(_ANSI_FALLBACK_REF) << 32) | UInt64(length(fallback_values))
    end

    source_start = byte_start + first(range) - 1
    source_end = byte_start + last(range) - 1
    if source_end > typemax(UInt32)
        push!(fallback_values, value)
        return (UInt64(_ANSI_FALLBACK_REF) << 32) | UInt64(length(fallback_values))
    end

    return (UInt64(source_start) << 32) | UInt64(source_end)
end

"""
    _ansi_source_value(
        line::String,
        fallback_values::Vector{String},
        reference::UInt64
    ) -> String

Materialize a parsed value from its owned source line or uncommon normalized fallback.

# Arguments

- `line::String`: Owned source line containing source-backed values.
- `fallback_values::Vector{String}`: Retained normalized fallback values.
- `reference::UInt64`: Packed source range or fallback index.

# Returns

- `String`: Materialized parsed value.
"""
function _ansi_source_value(
    line::String, fallback_values::Vector{String}, reference::UInt64
)
    iszero(reference) && return ""
    source_start = UInt32(reference >> 32)
    source_end = UInt32(reference & typemax(UInt32))

    if source_start == _ANSI_FALLBACK_REF
        return fallback_values[Int(source_end)]
    end

    return String(SubString(line, Int(source_start), Int(source_end)))
end

"""
    _empty_ansi_transition() -> AnsiStateTransition

Create an ANSI transition that leaves every decoration unchanged.

# Returns

- `AnsiStateTransition`: Transition that preserves every decoration field.
"""
function _empty_ansi_transition()
    return AnsiStateTransition(
        false,
        false,
        false,
        false,
        "",
        false,
        "",
        false,
        unchanged,
        false,
        unchanged,
        false,
        unchanged,
        false,
        unchanged,
        false,
        "",
    )
end

"""
    _ansi_transition_string(transition::AnsiStateTransition) -> String

Render a transition canonically while retaining a reset that precedes later overrides.

# Arguments

- `transition::AnsiStateTransition`: Transition to render.

# Returns

- `String`: Canonical ANSI sequence for `transition`.
"""
function _ansi_transition_string(transition::AnsiStateTransition)
    decoration = Decoration(
        transition.foreground_changed ? transition.foreground : "",
        transition.background_changed ? transition.background : "",
        transition.bold_changed ? transition.bold : unchanged,
        transition.italic_changed ? transition.italic : unchanged,
        transition.reversed_changed ? transition.reversed : unchanged,
        transition.underline_changed ? transition.underline : unchanged,
        false,
        transition.hyperlink_changed ? transition.hyperlink_url : "",
        transition.hyperlink_changed,
    )
    reset = transition.clear_sgr ? "\e[0m" : ""

    return string(reset, String(decoration))
end

"""
    _ansi_transition(code::AbstractString) -> AnsiStateTransition

Summarize the decoration changes produced by ANSI sequence `code`.

# Arguments

- `code::AbstractString`: ANSI sequence to summarize.

# Returns

- `AnsiStateTransition`: Parsed state changes produced by `code`.
"""
function _ansi_transition(code::AbstractString)
    decoration = parse_decoration(code)
    is_sgr = startswith(code, "\e[") && endswith(code, 'm')
    clear_sgr = is_sgr && decoration.reset

    return AnsiStateTransition(
        clear_sgr,
        is_sgr,
        is_sgr && decoration.reset,
        is_sgr && !isempty(decoration.foreground),
        decoration.foreground,
        is_sgr && !isempty(decoration.background),
        decoration.background,
        is_sgr && (decoration.bold != unchanged),
        decoration.bold,
        is_sgr && (decoration.italic != unchanged),
        decoration.italic,
        is_sgr && (decoration.reversed != unchanged),
        decoration.reversed,
        is_sgr && (decoration.underline != unchanged),
        decoration.underline,
        decoration.hyperlink_url_changed,
        decoration.hyperlink_url,
    )
end

"""
    _apply_ansi_transition(
        decoration::Decoration,
        transition::AnsiStateTransition
    ) -> Decoration

Apply `transition` to `decoration` and return the resulting state.

# Arguments

- `decoration::Decoration`: Initial decoration state.
- `transition::AnsiStateTransition`: Summarized changes to apply.

# Returns

- `Decoration`: Decoration state after applying `transition`.
"""
function _apply_ansi_transition(decoration::Decoration, transition::AnsiStateTransition)
    # A reset clears inherited SGR attributes before later overrides are applied.
    if transition.clear_sgr
        foreground = ""
        background = ""
        bold = unchanged
        italic = unchanged
        reversed = unchanged
        underline = unchanged
    else
        foreground = decoration.foreground
        background = decoration.background
        bold = decoration.bold
        italic = decoration.italic
        reversed = decoration.reversed
        underline = decoration.underline
    end

    transition.foreground_changed && (foreground = transition.foreground)
    transition.background_changed && (background = transition.background)
    transition.bold_changed && (bold = transition.bold)
    transition.italic_changed && (italic = transition.italic)
    transition.reversed_changed && (reversed = transition.reversed)
    transition.underline_changed && (underline = transition.underline)

    reset = transition.has_sgr ? transition.final_reset : decoration.reset
    hyperlink_url =
        transition.hyperlink_changed ? transition.hyperlink_url : decoration.hyperlink_url
    hyperlink_changed = transition.hyperlink_changed || decoration.hyperlink_url_changed

    return Decoration(
        foreground,
        background,
        bold,
        italic,
        reversed,
        underline,
        reset,
        hyperlink_url,
        hyperlink_changed,
    )
end

"""
    _compose_ansi_transitions(
        first::AnsiStateTransition,
        second::AnsiStateTransition
    ) -> AnsiStateTransition

Compose sequential transitions so that `second` is applied after `first`.

# Arguments

- `first::AnsiStateTransition`: Earlier transition.
- `second::AnsiStateTransition`: Later transition.

# Returns

- `AnsiStateTransition`: Transition equivalent to applying `first` and then `second`.
"""
function _compose_ansi_transitions(first::AnsiStateTransition, second::AnsiStateTransition)
    # Later resets discard earlier SGR overrides, while later fields override earlier ones.
    second_clears = second.clear_sgr

    return AnsiStateTransition(
        first.clear_sgr || second.clear_sgr,
        first.has_sgr || second.has_sgr,
        second.has_sgr ? second.final_reset : first.final_reset,
        second.foreground_changed || (!second_clears && first.foreground_changed),
        second.foreground_changed ? second.foreground : first.foreground,
        second.background_changed || (!second_clears && first.background_changed),
        second.background_changed ? second.background : first.background,
        second.bold_changed || (!second_clears && first.bold_changed),
        second.bold_changed ? second.bold : first.bold,
        second.italic_changed || (!second_clears && first.italic_changed),
        second.italic_changed ? second.italic : first.italic,
        second.reversed_changed || (!second_clears && first.reversed_changed),
        second.reversed_changed ? second.reversed : first.reversed,
        second.underline_changed || (!second_clears && first.underline_changed),
        second.underline_changed ? second.underline : first.underline,
        second.hyperlink_changed || first.hyperlink_changed,
        second.hyperlink_changed ? second.hyperlink_url : first.hyperlink_url,
    )
end

## Description #############################################################################
#
# Internal function to keep track of string state when iterating through the characters.
#
############################################################################################

"""
    _next_string_state(c::Char, state::Symbol = :text) -> Symbol

Return the next string state given the character `c` and the current string `state`.

The following states are possible:

- `:text`: The character is part of the printable text.
- `:escape_state_begin`: Beginning of an ANSI escape sequence (`\\x1b`).
- `:escape_state_opening`: Matches the `[`.
- `:escape_state_1`: First state of an ANSI escape sequence.
- `:escape_state_2`: Second state of an ANSI escape sequence.
- `:escape_state_3`: Third state of an ANSI escape sequence.
- `:escape_hyperlink_opening`: Beginning of an ANSI hyperlink escape sequence (`]`).
- `:escape_hyperlink_1`: First state of an ANSI hyperlink escape sequence (`8`).
- `:escape_hyperlink_2`: Second state of an ANSI hyperlink escape sequence (`;`).
- `:escape_hyperlink_3`: Third state of an ANSI hyperlink escape sequence (`;`).
- `:escape_hyperlink_url`: URL in an ANSI hyperlink escape sequence.
- `:escape_hyperlink_close`: Closing of an ANSI hyperlink escape sequence (`\\x1b`).
- `:escape_state_end`: End of an ANSI escape sequence.
"""
function _next_string_state(c::Char, state::Symbol = :text)
    if state == :text
        # Here, we need to check if an escape sequence is found.
        c == '\x1B' && return :escape_state_begin

    elseif state == :escape_state_begin
        (c == '[') && return :escape_state_opening
        (c == ']') && return :escape_hyperlink_opening
        (('@' ≤ c ≤ 'Z') || ('\\' ≤ c ≤ '_')) && return :escape_state_1

    elseif state == :escape_state_opening
        return _next_string_state(c, :escape_state_1)

    elseif state == :escape_state_1
        ('0' ≤ c ≤ '?') && return :escape_state_1
        return _next_string_state(c, :escape_state_2)

    elseif state == :escape_state_2
        (' ' ≤ c ≤ '/') && return :escape_state_2
        return _next_string_state(c, :escape_state_3)

    elseif state == :escape_state_3
        ('@' ≤ c ≤ '~') && return :escape_state_end

    elseif state == :escape_hyperlink_opening
        (c == '8') && return :escape_hyperlink_1

    elseif state == :escape_hyperlink_1
        (c == ';') && return :escape_hyperlink_2

    elseif state == :escape_hyperlink_2
        (c == ';') && return :escape_hyperlink_3

    elseif state ∈ (:escape_hyperlink_3, :escape_hyperlink_url)
        (c == '\x1B') && return :escape_hyperlink_end
        return :escape_hyperlink_url

    elseif state == :escape_hyperlink_end
        (c == '\\') && return :escape_state_end

    elseif state == :escape_state_end
        # We need to recall this function because the next character can be the beginning of
        # a new ANSI escape sequence.
        return _next_string_state(c, :text)
    end

    return :text
end

## Description #############################################################################
#
# Functions to align strings.
#
############################################################################################

export align_string, align_string_per_line, padding_for_string_alignment

"""
    align_string(
        str::AbstractString,
        field_width::Int,
        alignment::Symbol;
        kwargs...
    ) -> String

Align the string `str` in the field with width `field_width` using `alignment`, which can
be:

- `:l`: Align the string to the left;
- `:c`: Align the string in the center;
- `:r`: Align the string to the right.

!!! note

    If the printable width of `str` is higher than or equal to `field_width`, nothing
    will be changed.

!!! note

    This function treats `\\n` as normal characters. To align every line, use
    the function [`align_string_per_line`](@ref).

# Keywords

- `fill::Bool`: If `true`, the string will be filled with spaces to the right so that the
    resulting string has printable width `field_width` if the initial string's printable
    width is lower than it.
    (**Default** = `false`)
- `printable_string_width::Int`: Provide the printable string width to reduce the
    computational burden. If this parameter is lower than 0, the printable width is computed
    internally.
    (**Default** = -1)

# Extended Help

## Examples

```julia-repl
julia> align_string("My String", 92, :c) |> println
                                         My String

julia> align_string("My String", 92, :l) |> println
My String

julia> align_string("My String", 92, :r) |> println
                                                                                   My String
```
"""
function align_string(
    str::AbstractString,
    field_width::Int,
    alignment::Symbol;
    fill::Bool = false,
    printable_string_width::Int = -1,
)
    padding = padding_for_string_alignment(
        str, field_width, alignment; fill, printable_string_width
    )

    isnothing(padding) && return String(str)

    lpad, rpad = padding

    return " "^lpad * str * " "^rpad
end

"""
    _write_padding(buf::IOBuffer, num_spaces::Int) -> Nothing

Write `num_spaces` spaces to `buf`, doing nothing if it is not positive.
"""
function _write_padding(buf::IOBuffer, num_spaces::Int)
    remaining = num_spaces

    # Writing the spaces in chunks from a constant lets each `write` be a bulk copy instead
    # of one call per space, and it does not allocate the padding string.
    while remaining > 0
        num_written = min(remaining, ncodeunits(_SPACES))
        write(buf, SubString(_SPACES, 1, num_written))
        remaining -= num_written
    end

    return nothing
end

"""
    align_string_per_line(
        str::AbstractString,
        field_width::Int,
        alignment::Symbol;
        kwargs...
    ) -> String

Align each line of the string `str` in the field with width `field_width` using `alignment`,
which can be:

- `:l`: Align the string to the left;
- `:c`: Align the string in the center;
- `:r`: Align the string to the right.

!!! note

    If the printable width of `str` is higher than or equal to `field_width`, nothing
    will be changed.

# Keywords

- `fill::Bool`: If `true`, the string will be filled with spaces to the right so that the
    resulting string has printable width `field_width` if the initial string's printable
    width is lower than it.
    (**Default** = `false`)

# Extended Help

## Examples

```julia-repl
julia> align_string_per_line(\"\"\"
       This is a string
       with multiple
       lines.\"\"\", 92, :c) |> println
                                      This is a string
                                       with multiple
                                           lines.

julia> align_string_per_line(\"\"\"
       This is a string
       with multiple
       lines.\"\"\", 92, :l) |> println
This is a string
with multiple
lines.

julia> align_string_per_line(\"\"\"
       This is a string
       with multiple
       lines.\"\"\", 92, :r) |> println
                                                                            This is a string
                                                                               with multiple
                                                                                      lines.
```
"""
function align_string_per_line(
    str::AbstractString, field_width::Int, alignment::Symbol; fill::Bool = false
)
    (field_width ≤ 0) && return String(str)

    # Align each line without materializing the collection of lines. The padding is written
    # directly to the buffer instead of calling `align_string`, which would allocate an
    # aligned string per line only to copy it here.
    buf = IOBuffer(; sizehint = sizeof(str) + field_width)
    first_line = true

    for line in eachsplit(str, '\n'; keepempty = true)
        first_line || write(buf, '\n')

        padding = padding_for_string_alignment(line, field_width, alignment; fill)

        if isnothing(padding)
            write(buf, line)
        else
            lpad, rpad = padding
            _write_padding(buf, lpad)
            write(buf, line)
            _write_padding(buf, rpad)
        end

        first_line = false
    end

    return String(take!(buf))
end

"""
    padding_for_string_alignment(
        str::AbstractString,
        field_width::Int,
        alignment::Symbol;
        kwargs...
    ) -> Union{Nothing, NTuple{2, Int}}

Return the left and right padding required to align the string `str` in a field with width
`field_width` using the `alignment`, which can be:

- `:l`: Align the string to the left;
- `:c`: Align the string in the center;
- `:r`: Align the string to the right.

This function can return `nothing` in the following conditions:

1. The string does not need to be modified;
2. The alignment symbol is unknown; or
3. The printable width of `str` is longer than `field_width`.

!!! note

    This function treats `\\n` as normal characters.

# Keywords

- `fill::Bool`: If `true`, the string will be filled with spaces to the right so that the
    resulting string has printable width `field_width` if the initial string's printable
    width is lower than it.
    (**Default** = `false`)
- `printable_string_width::Int`: Provide the printable string width to reduce the
    computational burden. If this parameter is lower than 0, the printable width is computed
    internally.
    (**Default** = -1)

# Extended Help

## Examples

```julia-repl
julia> padding_for_string_alignment("My string", 92, :c)
(41, 0)

julia> padding_for_string_alignment("My string", 92, :l)

julia> padding_for_string_alignment("My string", 92, :r)
(83, 0)
```
"""
function padding_for_string_alignment(
    str::AbstractString,
    field_width::Int,
    alignment::Symbol;
    fill::Bool = false,
    printable_string_width::Int = -1,
)
    str_width = if printable_string_width < 0
        printable_textwidth(str)
    else
        printable_string_width
    end

    (field_width ≤ str_width) && return nothing

    # Compute the padding given the alignment type.
    if (alignment == :l) && fill
        rpad = field_width - str_width
        return 0, rpad

    elseif alignment == :c
        lpad = div(field_width - str_width, 2)
        rpad = fill ? (field_width - str_width - lpad) : 0
        return lpad, rpad

    elseif alignment == :r
        lpad = field_width - str_width
        return lpad, 0
    end

    return nothing
end

## Description #############################################################################
#
# Tests related to the ANSI escape sequences.
#
############################################################################################

@testset "Parsing ANSI Strings" begin
    str = "Test \e[38;5;231;48;5;243mTest 😅 \e[38;5;201;48;5;243mTest\e[0m End"

    parsed = parse_ansi_string(str)

    @test length(parsed) == 4
    @test parsed[1] == ("Test " => Decoration())
    @test parsed[2] ==
        ("Test 😅 " => Decoration(; foreground = "38;5;231", background = "48;5;243"))
    @test parsed[3] ==
        ("Test" => Decoration(; foreground = "38;5;201", background = "48;5;243"))
    @test parsed[4] == (" End" => Decoration(; reset = true))

    str = "Test \e[38;5;231;48;5;243mTest 😅 \e[38;5;201;48;5;243mTest\e[0m"

    parsed = parse_ansi_string(str)

    @test length(parsed) == 4
    @test parsed[1] == ("Test " => Decoration())
    @test parsed[2] ==
        ("Test 😅 " => Decoration(; foreground = "38;5;231", background = "48;5;243"))
    @test parsed[3] ==
        ("Test" => Decoration(; foreground = "38;5;201", background = "48;5;243"))
    @test parsed[4] == ("" => Decoration(; reset = true))

    str = "\e[38;5;231;48;5;243mTest 😅 \e[38;5;201;48;5;243mTest\e[0m"

    parsed = parse_ansi_string(str)

    @test length(parsed) == 3
    @test parsed[1] ==
        ("Test 😅 " => Decoration(; foreground = "38;5;231", background = "48;5;243"))
    @test parsed[2] ==
        ("Test" => Decoration(; foreground = "38;5;201", background = "48;5;243"))
    @test parsed[3] == ("" => Decoration(; reset = true))
end

@testset "Malformed Extended ANSI Colors" begin
    parse_code(code) = StringManipulation._parse_ansi_decoration_code(Decoration(), code)

    for code in ("\e[38;?m", "\e[38;:m", "\e[38;5;:m")
        @test parse_decoration(code) == Decoration()
    end
    @test parse_decoration("\e[48;?;1m").bold == StringManipulation.active
    @test parse_decoration("\e[48;5;:;3m").italic == StringManipulation.active

    # Malformed and unsupported modes are ignored without hiding later SGR tokens.
    @test parse_code("38;invalid;1").bold == StringManipulation.active
    @test parse_code("48;;3").italic == StringManipulation.active
    @test parse_code("38;999;4").underline == StringManipulation.active

    # Malformed 256-color values are ignored for both foreground and background.
    decoration = parse_code("38;5;invalid;1;48;5;;3")
    @test decoration.foreground == ""
    @test decoration.background == ""
    @test decoration.bold == StringManipulation.active
    @test decoration.italic == StringManipulation.active

    overflow = "999999999999999999999999999999999999999999999999999999999999"
    decoration = parse_code("38;5;$overflow;4;48;5;$overflow;7")
    @test decoration.foreground == ""
    @test decoration.background == ""
    @test decoration.underline == StringManipulation.active
    @test decoration.reversed == StringManipulation.active

    # Each malformed RGB component is ignored, and parsing resumes after the RGB tuple.
    @test parse_code("38;2;bad;20;30;1").bold == StringManipulation.active
    @test parse_code("38;2;10;;30;3").italic == StringManipulation.active
    @test parse_code("48;2;10;20;bad;4").underline == StringManipulation.active
    @test parse_code("48;2;$overflow;20;30;7").reversed == StringManipulation.active

    # Missing components terminate cleanly and preserve the current decoration.
    current = Decoration(; foreground = "32", background = "44")
    for code in ("38", "38;5", "38;2;1;2", "48", "48;5", "48;2;1;2")
        @test StringManipulation._parse_ansi_decoration_code(current, code) == current
    end

    # Valid extended colors retain their existing behavior.
    decoration = parse_code("38;5;231;48;2;216;210;203")
    @test decoration.foreground == "38;5;231"
    @test decoration.background == "48;2;216;210;203"
end

@testset "SGR Parameter Scanning" begin
    parse_code(code) = StringManipulation._parse_ansi_decoration_code(Decoration(), code)

    # A parameter is only valid if it is composed of digits. Anything else must be skipped
    # without hiding the parameters that follow it.
    @test parse_code("48;5;-1").background == ""
    @test parse_code("1 ;3").italic == StringManipulation.active
    @test parse_code("38;5; 1;7").reversed == StringManipulation.active

    # Leading zeros must be handled like any other number.
    @test parse_code("007").reversed == StringManipulation.active
    @test parse_code("038;5;231").foreground == "38;5;231"

    # Scanning the parameters instead of splitting them made the amount allocated
    # independent of how many parameters the code has. Notice that we must not require zero
    # allocations here: the returned `Decoration` is not an `isbits` type, so whether its
    # allocation is elided depends on the Julia version.
    sgr_allocations(d, code) =
        @allocated StringManipulation._parse_ansi_decoration_code(d, code)

    decoration = Decoration()
    codes = ("0", "1", "22;24", "22;24;27;23;1;3;4;7")

    # Warm up so that the compilation is not measured.
    for code in codes
        sgr_allocations(decoration, code)
    end

    baseline = sgr_allocations(decoration, first(codes))

    for code in codes
        @test sgr_allocations(decoration, code) == baseline
    end
end

@testset "Reset Followed by Other Codes" begin
    # A reset must not discard the codes that follow it in the same sequence.
    @test String(parse_decoration("\e[0;31m")) == "\e[0m\e[31m"
    @test String(parse_decoration("\e[0m")) == "\e[0m"

    # A code before the reset must be discarded.
    @test String(parse_decoration("\e[1;0;4m")) == "\e[0m\e[4m"

    decoration = parse_decoration("\e[0;31m")
    @test decoration.reset
    @test decoration.foreground == "31"
end

@testset "Omitted SGR Parameters" begin
    # ECMA-48 states that an omitted parameter takes its default value, 0 for SGR.
    @test String(parse_decoration("\e[m")) == "\e[0m"
    @test parse_decoration("\e[m").reset
    @test String(parse_decoration("\e[;31m")) == "\e[0m\e[31m"
end

@testset "Non-SGR CSI Sequences" begin
    # Only the sequences terminated by `m` change the decoration.
    for code in ("\e[1A", "\e[0K", "\e[2J", "\e[3J", "\e[1;1H", "\e[4G", "\e[K")
        decoration = parse_decoration(code)
        @test decoration == Decoration()
        @test String(decoration) == ""
    end

    # A cursor movement between two SGR sequences must not disturb them.
    @test parse_decoration("\e[1m\e[1A\e[31m").bold == StringManipulation.active
    @test parse_decoration("\e[1m\e[1A\e[31m").foreground == "31"

    # They also must not be counted as printable text.
    @test printable_textwidth("a\e[1Ab\e[0Kc") == 3
end

@testset "Hyperlink Terminators" begin
    # An OSC 8 hyperlink can be terminated by either ST or BEL.
    bel = "\e]8;;http://a\aX\e]8;;\a"
    st  = "\e]8;;http://a\e\\X\e]8;;\e\\"

    @test remove_decorations(bel) == "X"
    @test remove_decorations(st) == "X"
    @test printable_textwidth(bel) == 1
    @test printable_textwidth(st) == 1

    @test parse_decoration("\e]8;;http://a\a").hyperlink_url == "http://a"
    @test parse_decoration("\e]8;;http://a\e\\").hyperlink_url == "http://a"
    @test parse_decoration("\e]8;;http://a\a").hyperlink_url_changed
    @test parse_decoration("\e]8;;\a").hyperlink_url == ""

    @test first(first(parse_ansi_string(bel))) == "X"
    @test first(first(parse_ansi_string(st))) == "X"

    # An unterminated hyperlink must not consume the following lines.
    @test occursin(
        "rest of text", join(first.(parse_ansi_string("\e]8;;bad\nrest of text")))
    )
end

using BenchmarkTools
using StringManipulation

const QUICK = "--quick" in ARGS
const BENCHMARK_SAMPLES = QUICK ? 3 : 20
const BENCHMARK_SECONDS = QUICK ? 0.2 : 2.0

"""
    reset_buffer!(buffer::IOBuffer) -> IOBuffer

Reset `buffer` for another benchmark evaluation.

# Arguments

- `buffer::IOBuffer`: Output buffer to truncate and rewind.

# Returns

- `IOBuffer`: Reset output buffer.
"""
function reset_buffer!(buffer::IOBuffer)
    truncate(buffer, 0)
    seekstart(buffer)
    return buffer
end

"""
    render!(
        buffer::IOBuffer,
        source::Union{Vector{<:AbstractString}, TextViewLayout},
        view::NTuple{4, Int};
        kwargs...
    ) -> Nothing

Render `source` into `buffer` for one benchmark evaluation.

# Arguments

- `buffer::IOBuffer`: Output buffer receiving the rendered view.
- `source::Union{Vector{<:AbstractString}, TextViewLayout}`: Source to render.
- `view::NTuple{4, Int}`: Viewport configuration.

# Keywords

- `kwargs...`: Forward all rendering options to [`textview`](@ref).

# Returns

- `Nothing`: This function returns no value.
"""
function render!(
    buffer::IOBuffer,
    source::Union{Vector{<:AbstractString}, TextViewLayout},
    view::NTuple{4, Int};
    kwargs...,
)
    textview(buffer, source, view; kwargs...)
    return nothing
end

"""
    report(
        name::AbstractString,
        trial::BenchmarkTools.Trial
    ) -> BenchmarkTools.TrialEstimate

Print the median timing and allocation estimate for `trial`.

# Arguments

- `name::AbstractString`: Label for the benchmark result.
- `trial::BenchmarkTools.Trial`: Completed benchmark trial.

# Returns

- `BenchmarkTools.TrialEstimate`: Median estimate for `trial`.
"""
function report(name::AbstractString, trial::BenchmarkTools.Trial)
    estimate = median(trial)
    println(
        rpad(name, 48),
        lpad(round(estimate.time / 1e6; digits = 3), 10),
        " ms, ",
        lpad(estimate.memory, 12),
        " warmed bytes",
    )
    return estimate
end

"""
    construction_trial(lines::Vector{String}) -> BenchmarkTools.Trial

Benchmark construction of a [`TextViewLayout`](@ref) for `lines`.

# Arguments

- `lines::Vector{String}`: Source lines to prepare during each evaluation.

# Returns

- `BenchmarkTools.Trial`: Completed construction benchmark.
"""
function construction_trial(lines::Vector{String})
    benchmark = @benchmarkable TextViewLayout($lines)
    return run(
        benchmark; samples = BENCHMARK_SAMPLES, seconds = BENCHMARK_SECONDS, evals = 1
    )
end

"""
    render_trial(
        buffer::IOBuffer,
        source::Union{Vector{<:AbstractString}, TextViewLayout},
        view::NTuple{4, Int};
        kwargs...
    ) -> BenchmarkTools.Trial

Benchmark warmed rendering of `source` into `buffer`.

# Arguments

- `buffer::IOBuffer`: Reusable output buffer.
- `source::Union{Vector{<:AbstractString}, TextViewLayout}`: Source to render.
- `view::NTuple{4, Int}`: Viewport configuration.

# Keywords

- `kwargs...`: Forward all rendering options to [`textview`](@ref).

# Returns

- `BenchmarkTools.Trial`: Completed warmed-rendering benchmark.
"""
function render_trial(
    buffer::IOBuffer,
    source::Union{Vector{<:AbstractString}, TextViewLayout},
    view::NTuple{4, Int};
    kwargs...,
)
    options = (; kwargs...)
    # Compile this exact rendering path before BenchmarkTools records warmed evaluations.
    reset_buffer!(buffer)
    render!(buffer, source, view; options...)
    benchmark = @benchmarkable render!($buffer, $source, $view; $options...) setup = (reset_buffer!(
        $buffer
    ))
    return run(
        benchmark; samples = BENCHMARK_SAMPLES, seconds = BENCHMARK_SECONDS, evals = 1
    )
end

"""
    search_trial(
        source::Union{Vector{<:AbstractString}, TextViewLayout},
        regex::Regex
    ) -> BenchmarkTools.Trial

Benchmark per-line searching of `source` with `regex`.

# Arguments

- `source::Union{Vector{<:AbstractString}, TextViewLayout}`: Source to search.
- `regex::Regex`: Regular expression to match.

# Returns

- `BenchmarkTools.Trial`: Completed search benchmark.
"""
function search_trial(source::Union{Vector{<:AbstractString}, TextViewLayout}, regex::Regex)
    string_search_per_line(source, regex)
    benchmark = @benchmarkable string_search_per_line($source, $regex)
    return run(
        benchmark; samples = BENCHMARK_SAMPLES, seconds = BENCHMARK_SECONDS, evals = 1
    )
end

"""
    break_even(
        name::AbstractString,
        construction::BenchmarkTools.TrialEstimate,
        raw_render::BenchmarkTools.TrialEstimate,
        prepared_render::BenchmarkTools.TrialEstimate
    ) -> Nothing

Print the estimated render count required to amortize preparation.

# Arguments

- `name::AbstractString`: Label for the compared workload.
- `construction::BenchmarkTools.TrialEstimate`: Median construction estimate.
- `raw_render::BenchmarkTools.TrialEstimate`: Median raw-render estimate.
- `prepared_render::BenchmarkTools.TrialEstimate`: Median prepared-render estimate.

# Returns

- `Nothing`: This function returns no value.
"""
function break_even(
    name::AbstractString,
    construction::BenchmarkTools.TrialEstimate,
    raw_render::BenchmarkTools.TrialEstimate,
    prepared_render::BenchmarkTools.TrialEstimate,
)
    saved_time = raw_render.time - prepared_render.time
    if saved_time > 0
        renders = construction.time / saved_time
        println(name, ": ", round(renders; digits = 2), " renders (median estimate)")
    else
        println(
            name,
            ": not available; prepared rendering was not faster in this run (median delta ",
            round(saved_time / 1e6; digits = 3),
            " ms)",
        )
    end
end

"""
    report_retained(
        name::AbstractString,
        source::Vector{String},
        layout::TextViewLayout
    ) -> Nothing

Print retained source and prepared-layout sizes.

# Arguments

- `name::AbstractString`: Label for the retained-size result.
- `source::Vector{String}`: Original source lines.
- `layout::TextViewLayout`: Prepared layout for `source`.

# Returns

- `Nothing`: This function returns no value.
"""
function report_retained(
    name::AbstractString, source::Vector{String}, layout::TextViewLayout
)
    source_size = Base.summarysize(source)
    layout_size = Base.summarysize(layout)
    return println(
        name,
        ": source = ",
        source_size,
        " bytes, layout = ",
        layout_size,
        " bytes, layout/source = ",
        round(layout_size / max(source_size, 1); digits = 3),
    )
end

println("StringManipulation benchmarks (", QUICK ? "quick smoke" : "full", " mode)")
println(
    "BenchmarkTools settings: samples = ",
    BENCHMARK_SAMPLES,
    ", seconds = ",
    BENCHMARK_SECONDS,
    ", evals = 1",
)

# Representative viewport workloads. Each pair uses the same source, view, and output
# buffer.
ascii_lines = fill(repeat("0123456789", 4_000), 12)
unicode_lines = fill(repeat("α你😃e\u0301", 5_000), 12)
ansi_lines = fill(repeat("\e[31mred\e[0m plain ", 4_000), 12)
representative = [
    ("ASCII", ascii_lines, (1, 12, 20_000, 100)),
    ("Unicode wide/combining", unicode_lines, (1, 12, 15_000, 100)),
    ("ANSI", ansi_lines, (1, 12, 15_000, 100)),
]

buffer = IOBuffer()
break_even_inputs = []

println("\n== Representative construction and paired rendering ==")
for (name, lines, view) in representative
    layout = TextViewLayout(lines)
    construction = report("construct / $name", construction_trial(lines))
    raw = report("render raw / $name", render_trial(buffer, lines, view))
    prepared = report("render prepared warmed / $name", render_trial(buffer, layout, view))
    report_retained("retained / $name", lines, layout)
    push!(break_even_inputs, (name, construction, raw, prepared))
end

println("\n== Construction break-even ==")
for (name, construction, raw, prepared) in break_even_inputs
    break_even(name, construction, raw, prepared)
end

# Search remains dynamic: preparation owns text/layout metadata, not search results.
search_lines = fill("prefix needle suffix "^2_000, 24)
search_layout = TextViewLayout(search_lines)
println("\n== Paired search ==")
report("search raw lines", search_trial(search_lines, r"needle"))
report("search prepared layout", search_trial(search_layout, r"needle"))

# Compare repeated transitions with unique OSC-8 transitions. These report construction,
# warmed rendering, and retained size without inspecting the opaque layout representation.
"""
    repeated_ansi(event_count::Int) -> Vector{String}

Create one line containing `event_count` repeated SGR transitions.

# Arguments

- `event_count::Int`: Number of transitions to generate.

# Returns

- `Vector{String}`: Single-line repeated-transition source.
"""
function repeated_ansi(event_count::Int)
    return [repeat("\e[31mx", event_count)]
end

"""
    high_cardinality_ansi(event_count::Int) -> Vector{String}

Create one line containing `event_count` distinct OSC-8 transitions.

# Arguments

- `event_count::Int`: Number of distinct transitions to generate.

# Returns

- `Vector{String}`: Single-line high-cardinality source.
"""
function high_cardinality_ansi(event_count::Int)
    return [join("\e]8;;https://example.com/$i\e\\x\e]8;;\e\\" for i in 1:event_count)]
end

println("\n== ANSI event-cardinality scaling ==")
ansi_event_counts = QUICK ? (1_000, 10_000) : (1_000, 100_000)
for count in ansi_event_counts
    for (kind, make_source) in
        (("repeated", repeated_ansi), ("high-cardinality", high_cardinality_ansi))
        lines = make_source(count)
        layout = TextViewLayout(lines)
        report("construct ANSI $kind / $count", construction_trial(lines))
        report(
            "render ANSI $kind / $count",
            render_trial(buffer, layout, (1, 1, max(count - 9, 1), 10)),
        )
        report_retained("retained ANSI $kind / $count", lines, layout)
    end
end

println("\n== Many short lines ==")
many_short_lines = ["line $i" for i in 1:100_000]
many_short_layout = TextViewLayout(many_short_lines)
report("construct / 100k short lines", construction_trial(many_short_lines))
report(
    "render prepared / 100k short lines",
    render_trial(buffer, many_short_layout, (99_950, 24, 1, 20)),
)
short_source_size = Base.summarysize(many_short_lines)
short_layout_size = Base.summarysize(many_short_layout)
println(
    "retained / 100k short lines: source = ",
    short_source_size,
    " bytes, layout = ",
    short_layout_size,
    " bytes, layout bytes/line = ",
    round(short_layout_size / length(many_short_lines); digits = 2),
)

# The only match is sparse and near the end. Global active_match must resolve its ordinal;
# active_match_location supplies the prepared line and within-line match directly.
println("\n== Sparse active-match scaling ==")
for line_count in (1_000, 10_000, 100_000)
    sparse_lines = fill("ordinary line", line_count)
    sparse_lines[end - 1] = "ordinary sparse-needle line"
    sparse_layout = TextViewLayout(sparse_lines)
    sparse_matches = string_search_per_line(sparse_layout, r"sparse-needle")
    view = (line_count - 10, 10, 1, 40)
    report(
        "active_match global / $line_count lines",
        render_trial(
            buffer, sparse_layout, view; search_matches = sparse_matches, active_match = 1
        ),
    )
    report(
        "active_match_location / $line_count lines",
        render_trial(
            buffer,
            sparse_layout,
            view;
            search_matches = sparse_matches,
            active_match_location = (line_count - 1, 1),
        ),
    )
end

## Description #############################################################################
#
# Tests related to the string alignment.
#
############################################################################################

@testset "Alignment to the Right" begin
    str = "Test 😃 \e[38;5;231;48;5;243mTest \e[0m😅 Test"

    expected = "                    Test 😃 \e[38;5;231;48;5;243mTest \e[0m😅 Test"
    aligned_str = align_string(str, 40, :r)

    @test aligned_str === expected
    @test printable_textwidth(aligned_str) == 40

    aligned_str = align_string(str, 40, :r; fill = true)

    @test aligned_str === expected
    @test printable_textwidth(aligned_str) == 40

    aligned_str = align_string(str, 10, :r)
    @test str == aligned_str
end

@testset "Alignment to the Center" begin
    str = "Test 😃 \e[38;5;231;48;5;243mTest \e[0m😅 Test"
    expected = "          Test 😃 \e[38;5;231;48;5;243mTest \e[0m😅 Test"
    aligned_str = align_string(str, 40, :c)

    @test aligned_str === expected
    @test printable_textwidth(aligned_str) == 30

    expected = "          Test 😃 \e[38;5;231;48;5;243mTest \e[0m😅 Test          "
    aligned_str = align_string(str, 40, :c; fill = true)

    @test aligned_str === expected
    @test printable_textwidth(aligned_str) == 40

    aligned_str = align_string(str, 10, :c)
    @test str == aligned_str
end

@testset "Alignment to the Left" begin
    str = "Test 😃 \e[38;5;231;48;5;243mTest \e[0m😅 Test"
    aligned_str = align_string(str, 40, :l)

    @test aligned_str === str
    @test printable_textwidth(aligned_str) == 20

    expected = "Test 😃 \e[38;5;231;48;5;243mTest \e[0m😅 Test                    "
    aligned_str = align_string(str, 40, :l; fill = true)

    @test aligned_str == expected
    @test printable_textwidth(aligned_str) == 40

    aligned_str = align_string(str, 10, :l)
    @test str == aligned_str
end

@testset "Multiple Lines Alignment" begin
    str = """
    We have \e[38;5;231;48;5;243mhere\e[0m 😅😃 the first line
    We now have the 😊 \e[38;5;231;48;5;243msecond\e[0m 😃 line"""

    expected_str = "                  We have \e[38;5;231;48;5;243mhere\e[0m 😅😃 the first line\n                 We now have the 😊 \e[38;5;231;48;5;243msecond\e[0m 😃 line"
    aligned_str = align_string_per_line(str, 50, :r)

    @test aligned_str == expected_str
end

@testset "Per-Line Alignment Preservation" begin
    @test align_string_per_line("", 4, :l) == ""
    @test align_string_per_line("", 4, :l; fill = true) == "    "
    @test align_string_per_line("\n", 4, :r) == "    \n    "
    @test align_string_per_line("\n\n", 4, :l) == "\n\n"
    @test align_string_per_line("a\n\n", 4, :r) == "   a\n    \n    "
    @test align_string_per_line("a\n\nb\n", 4, :l) == "a\n\nb\n"

    cases = (
        (:l, false, "a\nbb"),
        (:l, true, "a   \nbb  "),
        (:c, false, " a\n bb"),
        (:c, true, " a  \n bb "),
        (:r, false, "   a\n  bb"),
        (:r, true, "   a\n  bb"),
    )

    for (alignment, fill, expected) in cases
        @test align_string_per_line("a\nbb", 4, alignment; fill) == expected
    end

    ansi = "\e[31mA\e[0m\n\e[1mB\e[0m"
    @test align_string_per_line(ansi, 3, :r) == "  \e[31mA\e[0m\n  \e[1mB\e[0m"

    unicode = "界\né"
    @test align_string_per_line(unicode, 4, :r) == "  界\n   é"
    @test align_string_per_line("a\n\nb", 4, :invalid; fill = true) == "a\n\nb"

    parent = "prefix:a\nβ:suffix"
    substring = SubString(parent, 8, 10)
    aligned_substring = align_string_per_line(substring, 4, :r)
    @test aligned_substring == "   a\n   β"
    @test aligned_substring isa String

    # The early-return paths must also return a `String`, as documented, instead of
    # propagating the input type.
    @test align_string_per_line(substring, 0, :r) == substring
    @test align_string_per_line(substring, 0, :r) isa String
    @test align_string_per_line(substring, -1, :r; fill = true) == substring
    @test align_string_per_line(substring, -1, :r; fill = true) isa String

    @test align_string(substring, 0, :r) isa String
    @test fit_string_in_field(substring, 50) isa String
    @test highlight_search(substring, Tuple{Int, Int}[]) isa String

    @test Base.return_types(align_string, (SubString{String}, Int, Symbol)) == [String]
    @test Base.return_types(align_string_per_line, (SubString{String}, Int, Symbol)) ==
        [String]
end

@testset "Corner Cases" begin
    str = """
    We have \e[38;5;231;48;5;243mhere\e[0m 😅😃 the first line
    We now have the 😊 \e[38;5;231;48;5;243msecond\e[0m 😃 line"""

    aligned_str = align_string_per_line(str, -1, :l)

    @test aligned_str == str
end

## Description #############################################################################
#
# Precompilation.
#
############################################################################################

import PrecompileTools

PrecompileTools.@compile_workload begin
    # == Alignment =========================================================================

    align_string("Test", 40, :r)
    align_string_per_line("Test\nTest", 40, :r)

    # == ANSI Parsing ======================================================================

    parse_ansi_string("Test \e[38;5;231;48;5;243mTest 😅 \e[38;5;201;48;5;243mTest\e[0m End")

    # == Crop ==============================================================================

    left_crop("Test", 2)
    fit_string_in_field("Test Test Test Test Test", 10; crop_side = :left)
    fit_string_in_field("Test Test Test Test Test", 10; crop_side = :right)
    right_crop("Test", 2)

    # == Decorations =======================================================================

    drop_inactive_properties(Decoration())
    get_decorations("This is a \\e[1mbold string\\e[45mwith a different background\\e[0m.")
    get_and_remove_decorations("This is a \\e[1mbold string\\e[45mwith a different background\\e[0m.")
    parse_decoration("\\e[1;45m")
    remove_decorations("This is a \\e[1mbold string\\e[45mwith a different background\\e[0m.")
    replace_default_background(
        "\e[35mThis is a \e[45;1mtest string to \e[0mverify if \e[45mthe background \e[49;1mwas replaced correctly.",
        "43"
    )
    update_decoration(Decoration(), "\\e[1;45m")
    convert(String, Decoration(bold = StringManipulation.active))

    # == Highlight =========================================================================

    highlight_search("Test high\e[1mlight\e[0m in a string with no underlines.", r"highlight")
    highlight_search([
        "Test \e[7mhighlight\e[0m\e[0m in a string with no underlines.",
        "Test \e[7mhighlight\e[0m\e[4m in a string with underlines\e[0m.",
        "Test another \e[7mhighlight\e[0m\e[33m with colors.",
        "This is the last line."
    ], r"highlight")

    # == String Search =====================================================================

    string_search(
        """
        Test 1 😅 \e[38;5;231;48;5;243mTest 2 😅 \e[38;5;201;48;5;243mTest\e[0m
        Test 1 😅 \e[38;5;231;48;5;243mTest 2 😅 \e[38;5;201;48;5;243mTest\e[0m
        """,
        r"Test 2 😅"
    )

    string_search_per_line(
        """
        Test 1 😅 \e[38;5;231;48;5;243mTest 2 😅 \e[38;5;201;48;5;243mTest\e[0m
        Test 1 😅 \e[38;5;231;48;5;243mTest 2 😅 \e[38;5;201;48;5;243mTest\e[0m
        """,
        r"Test 2 😅"
    )

    # == Split =============================================================================

    split_string("Test 😅 \e[38;5;231;48;5;243mTest 😅 \e[38;5;201;48;5;243mTest\e[0m", 8)

    # == Text View =========================================================================

    str = """
         Lorem ipsum dolor sit amet, consectetur adipiscing elit. Pellentesque tempor
         risus vel diam ultrices volutpat. Nullam id tortor ut dolor rutrum cursus
         aliquam sed \e[34;1mlorem. Donec interdum, risus eu scelerisque posuere, purus magna
         auctor purus, in faucibus nisi quam ac erat. Nulla facilisi. Aenean et augue
         augue. Donec ut sem posuere, venenatis est quis, ultrices elit. Vivamus elit
         sapien, ullamcorper quis dui ut, \e[0msuscipit varius nibh. Duis varius arcu id
         ipsum egestas aliquam. Pellentesque eget sem ornare turpis fringilla fringilla
         id ac turpis.
        """

    textview(str, (0, 6, 10, 19))

    # == Text Width ========================================================================

    printable_textwidth("\e[1m😃\e[0m\e[4m😅\e[0m\e[7m🥳\e[0m")

    printable_textwidth_per_line("""
        \e[38;5;231;48;5;243mTes\e[3mt Test\e[1m Test\e[0m
        \e[38;5;231;48;5;243m😃\e[3m😄\e[1m😊\e[0m
        \e[1m😃\e[0m\e[4m😅\e[0m\e[7m🥳\e[0m
        \u001b[30;1m A \u001b[31;1m B \u001b[32;1m C \u001b[33;1m D \u001b[0m
        \u001b[44;1m A \u001b[45;1m B \u001b[46;1m C \u001b[47;1m D \u001b[0m
        \u001b[1m BOLD \u001b[0m\u001b[4m Underline \u001b[0m\u001b[7m Reversed \u001b[0m
        \u001b[1m\u001b[4m\u001b[7m BOLD Underline Reversed \u001b[0m"""
    )
end

## Description #############################################################################
#
# Tests related with text views.
#
############################################################################################

@testset "Text View" begin
    # We will use a hard-coded string instead of the output from the markdown rendering
    # function because breaking changes in the output would make this test fail. For more
    # information, see:
    #
    #   https://github.com/ronisbr/StringManipulation.jl/issues/4

    # md_str = md"""
    #     # Si distentae
    #
    #     ## Carpitur devorat
    #
    #     Lorem markdownum ipsi Emathion Neoptolemum et moenia **viveret spumantis**
    #     namque. Iam excepi ignis turbamve, *cruorem quo nubes* aevi; sensit esse
    #     animantis, Chironis infelix *stabantque*. Ruit et iuvenemque longo; ut at iugis,
    #     venit adventus molle adpropera?
    #
    #     Putat quibus Phaethon manet sanguine elige, orbem palearia iuvenum age prior
    #     mollibat *Pallas* est fera curru naribus. Constituis priore orbae generosque
    #     insidiaeque umbra patulas Laurentes denique senior?
    #
    #     ```julia
    #     # Compute recursively `sin(m*ϕ)` and `cos(m*ϕ)`.
    #     sin_mϕ = 2cos_ϕ * sin_m_1ϕ - sin_m_2ϕ
    #     cos_mϕ = 2cos_ϕ * cos_m_1ϕ - cos_m_2ϕ
    #     ```
    #
    #     ## Et carus quo inceptaque urbem quibus loqui
    #
    #     Perspicuus *bello*, rates siqua profatur tumulumque Taygetenque cauda multas ut
    #     enixa. Cum aenea est exhibuere procubuere terraeque virgo decimum victorem
    #     silvis dumque cunctatus excidit [piget](http://ea.org/pecorumquemunera) nam, tu.
    #     Suo quod ab funesta atque Thessalus idem trabe et **quamvis** lacrimis rerum sed
    #     erat per.
    #
    #     > Nec male regia, et tela, videns vultibus ut faciem plangore versantem. Obscena
    #     > admoveam nominis pater *est confundas decimo* humus indigenae aquae absit. Nos
    #     > nox acta videt animae, Phineus caput nec.
    #     """
    #
    # # Render the markdown with decorations.
    # buf = IOBuffer()
    # io  = IOContext(buf, :color => true, :displaysize => (100, 80))
    # show(io, MIME("text/plain"), md_str)
    # str = String(take!(buf))

    str = """
\e[1m  Si distentae\e[22m
\e[1m  ≡≡≡≡≡≡≡≡≡≡≡≡\e[22m

\e[1m  Carpitur devorat\e[22m
\e[1m  ================\e[22m

  Lorem markdownum ipsi Emathion Neoptolemum et moenia \e[1mviveret spumantis\e[22m
  namque. Iam excepi ignis turbamve, \e[4mcruorem quo nubes\e[24m aevi; sensit esse
  animantis, Chironis infelix \e[4mstabantque\e[24m. Ruit et iuvenemque longo; ut at
  iugis, venit adventus molle adpropera?

  Putat quibus Phaethon manet sanguine elige, orbem palearia iuvenum age prior
  mollibat \e[4mPallas\e[24m est fera curru naribus. Constituis priore orbae generosque
  insidiaeque umbra patulas Laurentes denique senior?

\e[36m  # Compute recursively `sin(m*ϕ)` and `cos(m*ϕ)`.\e[39m
\e[36m  sin_mϕ = 2cos_ϕ * sin_m_1ϕ - sin_m_2ϕ\e[39m
\e[36m  cos_mϕ = 2cos_ϕ * cos_m_1ϕ - cos_m_2ϕ\e[39m

\e[1m  Et carus quo inceptaque urbem quibus loqui\e[22m
\e[1m  ==========================================\e[22m

  Perspicuus \e[4mbello\e[24m, rates siqua profatur tumulumque Taygetenque cauda multas
  ut enixa. Cum aenea est exhibuere procubuere terraeque virgo decimum
  victorem silvis dumque cunctatus excidit piget
  (http://ea.org/pecorumquemunera) nam, tu. Suo quod ab funesta atque
  Thessalus idem trabe et \e[1mquamvis\e[22m lacrimis rerum sed erat per.

  │  Nec male regia, et tela, videns vultibus ut faciem plangore
  │  versantem. Obscena admoveam nominis pater \e[4mest confundas decimo\e[24m
  │  humus indigenae aquae absit. Nos nox acta videt animae, Phineus
  │  caput nec."""

    # == Without Frozen Lines or Columns ===================================================

    expected = """
        e\e[30;43mqu\e[0me umbra patulas Laurentes de

        \e[36mte recursively `sin(m*ϕ)` and `\e[39m
        \e[36m= 2cos_ϕ * sin_m_1ϕ - sin_m_2ϕ\e[39m
        \e[36m= 2cos_ϕ * cos_m_1ϕ - cos_m_2ϕ\e[39m

        \e[1ms \e[7mqu\e[0m\e[1mo incepta\e[7mqu\e[0m\e[1me urbem \e[7mqu\e[0m\e[1mibus l\e[22m
        \e[1m===============================\e[22m"""

    vstr, num_cropped_lines_at_end, max_cropped_chars = textview(
        str, (14, 8, 10, 31); active_match = 7, search_regex = r"qu"
    )

    @test vstr == expected
    @test num_cropped_lines_at_end == 11
    @test max_cropped_chars == 13

    # == With Frozen Lines or Columns ======================================================

    expected = """
        \e[1m  \e[0m\e[1m\e[7mentae\e[0m\e[22m
        \e[1m  \e[0m\e[1m≡≡≡≡≡\e[22m
        \e[0m
        \e[1m  \e[0m\e[1mr devorat\e[22m\e[0m
          \e[0me\e[30;43mqu\e[0me umbra patulas Laurentes de
        \e[0m
        \e[36m  \e[0m\e[36mte recursively `sin(m*ϕ)` and `\e[39m
        \e[36m  \e[0m\e[36m= 2cos_ϕ * sin_m_1ϕ - sin_m_2ϕ\e[39m
        \e[36m  \e[0m\e[36m= 2cos_ϕ * cos_m_1ϕ - cos_m_2ϕ\e[39m
        \e[0m
        \e[1m  \e[0m\e[1ms \e[7mqu\e[0m\e[1mo incepta\e[7mqu\e[0m\e[1me urbem \e[7mqu\e[0m\e[1mibus l\e[22m
        \e[1m  \e[0m\e[1m===============================\e[22m"""

    vstr, num_cropped_lines, max_cropped_chars = textview(
        str,
        (14, 8, 10, 31);
        active_match = 8,
        frozen_lines_at_beginning = 4,
        frozen_columns_at_beginning = 2,
        search_regex = r"qu|Si distentae",
    )

    @test vstr == expected
    @test num_cropped_lines == 11
    @test max_cropped_chars == 13

    # == View The Entire Text without Any Modification =====================================

    vstr, num_cropped_lines_at_end, max_cropped_chars = textview(str, (-1, -1, -1, -1))
    @test vstr == str
    @test num_cropped_lines_at_end == 0
    @test max_cropped_chars == 0

    # == Maximum Number of Lines and Columns ===============================================

    expected = """
        eque umbra patulas Laure

        \e[36mte recursively `sin(m*ϕ)\e[39m
        \e[36m= 2cos_ϕ * sin_m_1ϕ - si\e[39m
        \e[36m= 2cos_ϕ * cos_m_1ϕ - co\e[39m
        """

    vstr, num_cropped_lines_at_end, max_cropped_chars = textview(
        str, (14, 8, 10, 31); maximum_number_of_lines = 6, maximum_number_of_columns = 24
    )

    @test vstr == expected
    @test num_cropped_lines_at_end == 13
    @test max_cropped_chars == 20

    expected = """
        \e[1m  Si distentae\e[22m\e[0m\e[22m
        \e[1m  ≡≡≡≡≡≡≡≡≡≡≡≡\e[22m\e[0m\e[22m
        \e[0m
        \e[1m  Carpitur devorat\e[22m\e[0m\e[22m
        \e[1m  ================\e[22m\e[0m\e[22m
        \e[0m
          Lorem markdownum i\e[0m\e[22m
          namque. Iam excepi\e[0m\e[24m\e[0m"""

    vstr, num_cropped_lines_at_end, max_cropped_chars = textview(
        str,
        (14, 8, 10, 31);
        frozen_columns_at_beginning = 30,
        frozen_lines_at_beginning = 10,
        maximum_number_of_columns = 20,
        maximum_number_of_lines = 8,
    )

    @test vstr == expected
    @test num_cropped_lines_at_end == 0
    @test max_cropped_chars == 0

    expected = """
      \e[0markdownum ipsi Ema\e[22m
      \e[0m Iam excepi ignis \e[24m
      \e[0mis, Chironis infel\e[24m
      \e[0mvenit adventus mol
    \e[0m
      \e[0muibus Phaethon man
      \e[0mt \e[4mPallas\e[24m est fera 
      \e[0meque umbra patulas"""

    vstr, num_cropped_lines_at_end, max_cropped_chars = textview(
        str, (7, 8, 10, -1); frozen_columns_at_beginning = 2, maximum_number_of_columns = 20
    )

    @test vstr == expected
    @test num_cropped_lines_at_end == 18
    @test max_cropped_chars == 51

    # == Test Related to Multiple Dispatch =================================================

    lines = split(str, '\n')
    search_matches = string_search_per_line(lines, r"qu")

    expected = """
        e\e[30;43mqu\e[0me umbra patulas Laurentes de

        \e[36mte recursively `sin(m*ϕ)` and `\e[39m
        \e[36m= 2cos_ϕ * sin_m_1ϕ - sin_m_2ϕ\e[39m
        \e[36m= 2cos_ϕ * cos_m_1ϕ - cos_m_2ϕ\e[39m

        \e[1ms \e[7mqu\e[0m\e[1mo incepta\e[7mqu\e[0m\e[1me urbem \e[7mqu\e[0m\e[1mibus l\e[22m
        \e[1m===============================\e[22m"""

    vstr, num_cropped_lines_at_end, max_cropped_chars = textview(
        lines, (14, 8, 10, 31); active_match = 7, search_matches = search_matches
    )

    @test vstr == expected
    @test num_cropped_lines_at_end == 11
    @test max_cropped_chars == 13

    # == Ruler =============================================================================

    expected = """
        \e[90m  1 │\e[0m\e[1m  \e[0m\e[1m\e[7mentae\e[0m\e[22m
        \e[90m  2 │\e[0m\e[1m  \e[0m\e[1m≡≡≡≡≡\e[22m
        \e[90m  3 │\e[0m\e[0m
        \e[90m  4 │\e[0m\e[1m  \e[0m\e[1mr devorat\e[22m\e[0m
        \e[90m 14 │\e[0m  \e[0me\e[30;43mqu\e[0me umbra patulas Laurentes de
        \e[90m 15 │\e[0m\e[0m
        \e[90m 16 │\e[0m\e[36m  \e[0m\e[36mte recursively `sin(m*ϕ)` and `\e[39m
        \e[90m 17 │\e[0m\e[36m  \e[0m\e[36m= 2cos_ϕ * sin_m_1ϕ - sin_m_2ϕ\e[39m
        \e[90m 18 │\e[0m\e[36m  \e[0m\e[36m= 2cos_ϕ * cos_m_1ϕ - cos_m_2ϕ\e[39m
        \e[90m 19 │\e[0m\e[0m
        \e[90m 20 │\e[0m\e[1m  \e[0m\e[1ms \e[7mqu\e[0m\e[1mo incepta\e[7mqu\e[0m\e[1me urbem \e[7mqu\e[0m\e[1mibus l\e[22m
        \e[90m 21 │\e[0m\e[1m  \e[0m\e[1m===============================\e[22m"""

    vstr, num_cropped_lines, max_cropped_chars = textview(
        str,
        (14, 8, 10, 31);
        active_match = 8,
        frozen_lines_at_beginning = 4,
        frozen_columns_at_beginning = 2,
        search_regex = r"qu|Si distentae",
        show_ruler = true,
    )

    @test vstr == expected
    @test num_cropped_lines == 11
    @test max_cropped_chars == 13

    # == Title Lines =======================================================================

    expected = """
        \e[1m  Si distentae\e[22m\e[0m\e[1m\e[22m
        \e[1m  \e[0m\e[1m≡≡≡≡≡\e[22m\e[0m
          \e[0meque umbra patulas Laurentes de
        \e[0m
        \e[36m  \e[0m\e[36mte recursively `sin(m*ϕ)` and `\e[39m
        \e[36m  \e[0m\e[36m= 2cos_ϕ * sin_m_1ϕ - sin_m_2ϕ\e[39m
        \e[36m  \e[0m\e[36m= 2cos_ϕ * cos_m_1ϕ - cos_m_2ϕ\e[39m
        \e[0m
        \e[1m  \e[0m\e[1ms quo inceptaque urbem quibus l\e[22m
        \e[1m  \e[0m\e[1m===============================\e[22m"""

    vstr, num_cropped_lines_at_end, max_cropped_chars = textview(
        lines,
        (14, 8, 10, 31);
        frozen_columns_at_beginning = 2,
        frozen_lines_at_beginning = 2,
        title_lines = 1,
    )

    @test vstr == expected
    @test num_cropped_lines_at_end == 11
    @test max_cropped_chars == 13

    vstr, ~, ~ = textview(
        lines,
        (14, 8, 10, 31);
        frozen_columns_at_beginning = 0,
        frozen_lines_at_beginning = 2,
        title_lines = 1,
    )

    @test occursin("Si distentae", vstr)

    vstr, num_cropped_lines_at_end, max_cropped_chars = textview(
        lines,
        (14, 8, 10, 31);
        frozen_columns_at_beginning = 2,
        frozen_lines_at_beginning = 2,
        hide_title_lines = true,
        title_lines = 1,
    )

    @test !occursin("Si distentae", vstr)
    @test startswith(vstr, "\e[1m  \e[0m\e[1m≡≡≡≡≡\e[22m\e[0m\n")
    @test length(split(vstr, '\n')) == 10
    @test num_cropped_lines_at_end == 10
    @test max_cropped_chars == 13

    vstr_1, num_cropped_lines_at_end_1, max_cropped_chars_1 = textview(
        lines,
        (14, 8, 10, 31);
        frozen_columns_at_beginning = 2,
        frozen_lines_at_beginning = 2,
        hide_title_lines = true,
        title_lines = 10,
    )

    vstr_2, num_cropped_lines_at_end_2, max_cropped_chars_2 = textview(
        lines,
        (14, 8, 10, 31);
        frozen_columns_at_beginning = 2,
        frozen_lines_at_beginning = 2,
        hide_title_lines = true,
        title_lines = 2,
    )

    @test vstr_1 == vstr_2
    @test num_cropped_lines_at_end_1 == num_cropped_lines_at_end_2
    @test max_cropped_chars_1 == max_cropped_chars_2

    edge_vstr, edge_num_cropped_lines_at_end, edge_max_cropped_chars = textview(
        ["a", "b"], (-1, -1, -1, 10); frozen_lines_at_beginning = 10, title_lines = 10
    )

    @test occursin("a", edge_vstr)
    @test occursin("b", edge_vstr)
    @test edge_num_cropped_lines_at_end == 0
    @test edge_max_cropped_chars == 0

    edge_vstr, edge_num_cropped_lines_at_end, edge_max_cropped_chars = textview(
        ["a", "b"], (-1, -1, -1, -1); frozen_lines_at_beginning = 1, title_lines = 1
    )

    @test occursin("a", edge_vstr)
    @test occursin("b", edge_vstr)
    @test edge_num_cropped_lines_at_end == 0
    @test edge_max_cropped_chars == 0

    edge_vstr, edge_num_cropped_lines_at_end, edge_max_cropped_chars = textview(
        String[], (-1, -1, -1, 10); frozen_lines_at_beginning = 10, title_lines = 10
    )

    @test edge_vstr == ""
    @test edge_num_cropped_lines_at_end == 0
    @test edge_max_cropped_chars == 0

    # == Visual Lines ======================================================================

    expected = """
        \e[1m  Si distentae\e[22m
        \e[1m  ≡≡≡≡≡≡≡≡≡≡≡≡\e[22m
        \e[44m                                                 \e[49m
        \e[1m  Carpitur devorat\e[22m
        \e[1m  ================\e[22m

        \e[45m  Lorem markdownum ipsi Emathion Neoptolemum et m\e[22m\e[49m
          namque. Iam excepi ignis turbamve, \e[4mcruorem quo \e[24m
          animantis, Chironis infelix \e[4mstabantque\e[24m. Ruit et
          iugis, venit adventus molle adpropera?"""

    vstr, ~ = textview(
        str, (0, 10, 0, 49); visual_lines = [3, 7], visual_line_backgrounds = ["44", "45"]
    )

    @test vstr == expected

    expected = """
        \e[1m  Si diste\e[0m\e[22m
        \e[1m  ≡≡≡≡≡≡≡≡\e[0m\e[22m
        \e[44m          \e[49m\e[0m\e[44m                                                 \e[49m
        \e[1m  Carpitur\e[0m\e[22m
        \e[1m  ========\e[0m\e[22m
        \e[0m
        \e[45m  Lorem ma\e[49m\e[0m\e[45m ipsi Emathion Neoptolemum et moenia \e[1mviveret spum\e[22m\e[49m
          namque. \e[0mpi ignis turbamve, \e[4mcruorem quo nubes\e[24m aevi; sensit
          animanti\e[0mnis infelix \e[4mstabantque\e[24m. Ruit et iuvenemque longo;
          iugis, v\e[0mentus molle adpropera?"""

    vstr, ~ = textview(
        str,
        (0, 10, 19, 49);
        frozen_columns_at_beginning = 10,
        visual_lines = [3, 7],
        visual_line_backgrounds = ["44", "45"],
    )

    @test vstr == expected

    expected = """
        \e[1m  Si distentae\e[22m
        \e[1m  ≡≡≡≡≡≡≡≡≡≡≡≡\e[22m
        \e[44m                                                 \e[49m
        \e[1m  Carpitur devorat\e[22m
        \e[1m  ================\e[22m

        \e[44m  Lorem markdownum ipsi Emathion Neoptolemum et m\e[22m\e[49m
          namque. Iam excepi ignis turbamve, \e[4mcruorem quo \e[24m
          animantis, Chironis infelix \e[4mstabantque\e[24m. Ruit et
          iugis, venit adventus molle adpropera?"""

    vstr, ~ = textview(str, (0, 10, 0, 49); visual_lines = [3, 7])

    @test vstr == expected

    scalar_vstr, ~ = textview(
        ["one", "two", "three"],
        (1, -1, 1, 5);
        visual_lines = [2],
        visual_line_backgrounds = "45",
    )

    @test scalar_vstr == "one\n\e[45mtwo  \e[49m\nthree"

    indexed_vstr, ~ = textview(
        ["one", "two", "three"],
        (1, -1, 1, 5);
        visual_lines = [3, 2, 2, 0, 9],
        visual_line_backgrounds = ["46", "45", "44", "41", "42"],
    )

    @test indexed_vstr == "one\n\e[45mtwo  \e[49m\n\e[46mthree\e[49m"

    # == Consider Decorations in Hidden Lines ==============================================

    str = """
         Lorem ipsum dolor sit amet, consectetur adipiscing elit. Pellentesque tempor
         risus vel diam ultrices volutpat. Nullam id tortor ut dolor rutrum cursus
         aliquam sed \e[34;1mlorem. Donec interdum, risus eu scelerisque posuere, purus magna
         auctor purus, in faucibus nisi quam ac erat. Nulla facilisi. Aenean et augue
         augue. Donec ut sem posuere, venenatis est quis, ultrices elit. Vivamus elit
         sapien, ullamcorper quis dui ut, \e[0msuscipit varius nibh. Duis varius arcu id
         ipsum egestas aliquam. Pellentesque eget sem ornare turpis fringilla fringilla
         id ac turpis.
         """

    expected = """
        Lorem ipsum dolor sit amet, consectetur adipisc\e[7ming\e[0m elit. Pellentesque tempor\e[0m
        auctor purus, in faucibus nisi quam ac erat. Nulla facilisi. Aenean et augue
        augue. Donec ut sem posuere, venenatis est quis, ultrices elit. Vivamus elit
        sapien, ullamcorper quis dui ut, \e[0msuscipit varius nibh. Duis varius arcu id
        ipsum egestas aliquam. Pellentesque eget sem ornare turpis fr\e[7ming\e[0milla fr\e[30;43ming\e[0milla
        id ac turpis.
        """

    vstr, max_cropped_char = textview(
        str,
        (4, -1, -1, -1);
        active_match = 3,
        frozen_lines_at_beginning = 1,
        search_regex = r"ing",
    )

    @test vstr == expected

    expected = """
        Lorem ipsum dolor sit amet, consectetur adipisc\e[7ming\e[0m elit. Pellentesque tempor\e[0m
        \e[34m\e[1mauctor purus, in faucibus nisi quam ac erat. Nulla facilisi. Aenean et augue
        augue. Donec ut sem posuere, venenatis est quis, ultrices elit. Vivamus elit
        sapien, ullamcorper quis dui ut, \e[0msuscipit varius nibh. Duis varius arcu id
        ipsum egestas aliquam. Pellentesque eget sem ornare turpis fr\e[7ming\e[0milla fr\e[30;43ming\e[0milla
        id ac turpis.
        """

    vstr, max_cropped_char = textview(
        str,
        (4, -1, -1, -1);
        active_match = 3,
        frozen_lines_at_beginning = 1,
        parse_decorations_before_view = true,
        search_regex = r"ing",
    )

    @test vstr == expected

    no_decoration_vstr, ~ = textview(
        ["hidden", "shown"], (2, 1, 1, -1); parse_decorations_before_view = true
    )
    @test no_decoration_vstr == "shown"

    decoration_vstr, ~ = textview(
        ["\e[31mcolor", "\e]8;;https://example.com\e\\link", "shown"],
        (3, 1, 1, -1);
        parse_decorations_before_view = true,
    )
    @test decoration_vstr == "\e]8;;https://example.com\e\\\e[31mshown"

    reset_vstr, ~ = textview(
        ["\e[31mcolor", "\e]8;;https://example.com\e\\link", "\e[0mreset", "shown"],
        (4, 1, 1, -1);
        parse_decorations_before_view = true,
    )
    @test reset_vstr == "shown"

    frozen_vstr, ~ = textview(
        ["\e[31mfrozen", "\e[1mhidden", "shown"],
        (3, 1, 1, -1);
        frozen_lines_at_beginning = 1,
        parse_decorations_before_view = true,
    )
    @test frozen_vstr == "\e[31mfrozen\e[0m\n\e[31m\e[1mshown"

    hidden_title_vstr, ~ = textview(
        ["\e[31mtitle", "\e[1mfrozen", "shown"],
        (3, 1, 1, -1);
        frozen_lines_at_beginning = 2,
        hide_title_lines = true,
        parse_decorations_before_view = true,
        title_lines = 1,
    )
    @test hidden_title_vstr == "\e[1mfrozen\e[0m\n\e[31m\e[1mshown"
end

@testset "Text View [Errors]" begin
    error = try
        textview(
            "Test",
            (-1, -1, -1, -1);
            visual_lines = [1, 2],
            visual_line_backgrounds = ["44", "45", "46"],
        )
        nothing
    catch exception
        exception
    end
    @test error isa ArgumentError
    @test error.msg ==
        "The length of `visual_lines` must equal the length of `visual_line_backgrounds`."

    lines = ["one one", "two"]
    layout = TextViewLayout(lines)
    matches = Dict(1 => [(1, 3)])
    invalid_locations = (
        ((0, 1), matches),
        ((1, 0), matches),
        ((-1, 1), matches),
        ((1, -1), matches),
        ((3, 1), matches),
        ((2, 1), matches),
        ((1, 2), matches),
        ((1, 1), nothing),
    )
    for source in (lines, layout), (location, search_matches) in invalid_locations
        @test_throws ArgumentError textview(
            source, (1, -1, 1, -1); active_match_location = location, search_matches
        )
    end

    for source in (lines, layout)
        valid = textview(
            source, (1, -1, 1, -1); active_match_location = (1, 1), search_matches = matches
        )
        @test occursin("\e[30;43mone\e[0m", valid[1])
    end
end

@testset "Issue - Wrong Decoration With Visual Mode" begin
    expected = "\e[44m\e[1mThis is a \e[0m"
    a = "\e[1mThis is a test string that will be cropped.\e[0m"
    vstr, ~, ~ = textview(a, (-1, -1, 0, 10); visual_lines = [1])
    @test vstr == expected
end

@testset "Search Highlighting With Unbounded Width" begin
    # A negative `num_columns` means "use all the available columns". It must not be used
    # in plain arithmetic to compute the maximum column, otherwise every match is discarded
    # whenever `start_column` is greater than 1.
    lines = ["aaa bbb match ccc"]
    expected = "bbb \e[7mmatch\e[0m ccc"

    search_matches = string_search_per_line(lines, r"match")
    @test textview(lines, (1, -1, 5, -1); search_matches)[1] == expected

    layout = TextViewLayout(lines)
    search_matches = string_search_per_line(layout, r"match")
    @test textview(layout, (1, -1, 5, -1); search_matches)[1] == expected

    # The same must hold for the layout with ANSI escape sequences, which uses the indexed
    # rendering path.
    layout = TextViewLayout(["aaa \e[1mbbb\e[0m match ccc"])
    search_matches = string_search_per_line(layout, r"match")
    @test occursin("\e[7mmatch", textview(layout, (1, -1, 5, -1); search_matches)[1])
end

@testset "Title With Unbounded Width and Frozen Columns" begin
    lines = ["TITLE-LINE-VERY-LONG", "aaaaaaaaaaaaaaaaaaaa", "bbbb"]

    # The title spans the entire width of the view. When the width is unbounded, the title
    # must not be cropped by the number of frozen columns.
    result = textview(
        lines,
        (2, -1, 1, -1);
        frozen_lines_at_beginning = 1,
        title_lines = 1,
        frozen_columns_at_beginning = 5,
    )[1]

    @test startswith(result, "TITLE-LINE-VERY-LONG")

    # When the width is bounded, the title still spans the frozen columns plus the
    # remaining ones.
    result = textview(
        lines,
        (2, -1, 1, 10);
        frozen_lines_at_beginning = 1,
        title_lines = 1,
        frozen_columns_at_beginning = 5,
    )[1]

    @test startswith(result, "TITLE-LINE-VERY")
end

module StringManipulation

import Base: convert, String, @kwdef

############################################################################################
#                                        Constants                                         #
############################################################################################

const _CSI = "\x1b["

# This regex matches all the ANSI escape sequences that defines decorations.
const _REGEX_ANSI_SEQUENCES =
    r"\x1B(?:]8;;[^\x1B]*\x1B\\|[@-Z\\-_]|\[[0-?]*[ -/]*[@-~])"

# Escape sequence that reset all decorations.
const _RESET_DECORATIONS = _CSI * "0m"

############################################################################################
#                                        Structures                                        #
############################################################################################

# Enumeration to store the state in `Decoration`.
@enum DecorationState begin
    inactive  = 0
    active    = 1
    unchanged = 2
end

export Decoration

"""
    struct Decoration

Structure to hold the current decoration of a string.
"""
@kwdef struct Decoration
    foreground::String          = ""
    background::String          = ""
    bold::DecorationState       = unchanged
    italic::DecorationState     = unchanged
    reversed::DecorationState   = unchanged
    underline::DecorationState  = unchanged
    reset::Bool                 = false
    hyperlink_url::String       = ""
    hyperlink_url_changed::Bool = false
end

const _DEFAULT_DECORATION = Decoration()
const _RESET_DECORATION = Decoration(reset = true)

############################################################################################
#                                         Includes                                         #
############################################################################################

include("./alignment.jl")
include("./ansi.jl")
include("./crop.jl")
include("./decorations.jl")
include("./highlighting.jl")
include("./search.jl")
include("./state.jl")
include("./split.jl")
include("./view.jl")
include("./width.jl")

include("./precompilation.jl")

end # module

using Test
using StringManipulation
using Markdown

@testset "Alignment" verbose = true begin
    include("./alignment.jl")
end

@testset "ANSI Parsing" verbose = true begin
    include("./ansi.jl")
end

@testset "Cropping" verbose = true begin
    include("./crop.jl")
end

@testset "Decorations" verbose = true begin
    include("./decorations.jl")
end

@testset "Highlighting" verbose = true begin
    include("./highlighting.jl")
end

@testset "Prepared Layout" verbose = true begin
    include("./layout.jl")
end

@testset "Search" verbose = true begin
    include("./search.jl")
end

@testset "Splitting" verbose = true begin
    include("./split.jl")
end

@testset "View" verbose = true begin
    include("./view.jl")
end

@testset "Width" verbose = true begin
    include("./width.jl")
end

## Description #############################################################################
#
# Tests for prepared text layouts.
#
############################################################################################

"""
    _ansi_character_trace(str::String) -> Vector{Pair{Char, Decoration}}

Convert `str` into visible characters paired with their effective decorations.

# Arguments

- `str::String`: Decorated string to trace.

# Returns

- `Vector{Pair{Char, Decoration}}`: Visible-character decoration trace.
"""
function _ansi_character_trace(str::String)
    trace = Pair{Char, Decoration}[]
    for (token, decoration) in parse_ansi_string(str), character in token
        push!(trace, character => decoration)
    end
    return trace
end

"""
    _terminal_decoration_state(str::String) -> Decoration

Return the final terminal decoration state produced by `str`.

# Arguments

- `str::String`: Decorated string to summarize.

# Returns

- `Decoration`: Final decoration state.
"""
function _terminal_decoration_state(str::String)
    return parse_decoration(get_decorations(str))
end

@testset "Prepared Text Layout" begin
    lines = [
        "",
        "plain ASCII text",
        "αβγδé",
        "你a好b😃c",
        "a\u0301b\u0301c",
        "\e[31mred\e[39m default \e[1mbold\e[22m",
        "\e[38;5;201mindexed\e[48;2;1;2;3m true color\e[0m",
        "\e]8;;https://example.com\e\\link\e]8;;\e\\ tail",
        "",
    ]
    layout = TextViewLayout(lines; checkpoint_stride = 2, ansi_checkpoint_stride = 2)

    @test string_search_per_line(layout, r"a|red") ==
        string_search_per_line(lines, r"a|red")
    @test textview(TextViewLayout("a\n"), (1, -1, 1, -1)) ==
        textview(["a", ""], (1, -1, 1, -1))

    owned_lines = ["before", "snapshot"]
    owned_layout = TextViewLayout(owned_lines)
    expected_snapshot = textview(owned_layout, (1, -1, 1, -1))
    owned_lines[1] = "after"
    push!(owned_lines, "new")

    @test textview(owned_layout, (1, -1, 1, -1)) == expected_snapshot
    @test !applicable(
        TextViewLayout,
        owned_layout._lines,
        owned_layout._printable_widths,
        owned_layout._plain_ascii,
        owned_layout._ansi_fallback,
        owned_layout._metadata,
        owned_layout._document_ansi_checkpoints,
        owned_layout._checkpoint_stride,
        owned_layout._ansi_checkpoint_stride,
    )
    @test length(methods(TextViewLayout)) == 2
    @test !isdefined(StringManipulation, :TextViewLayoutConstructionToken)

    views = (
        (1, -1, 1, -1),
        (1, 9, 1, 0),
        (1, 9, 1, 1),
        (2, 6, 2, 4),
        (3, 5, 4, 5),
        (8, 20, 20, 4),
    )

    options = (
        (;),
        (; frozen_columns_at_beginning = 2),
        (; frozen_lines_at_beginning = 2, title_lines = 1),
        (; frozen_lines_at_beginning = 2, title_lines = 1, hide_title_lines = true),
        (; show_ruler = true),
        (; maximum_number_of_lines = 4, maximum_number_of_columns = 5),
        (; visual_lines = [2, 4], visual_line_backgrounds = ["44", "45"]),
        (; parse_decorations_before_view = true),
    )

    for view in views, kwargs in options
        @test textview(layout, view; kwargs...) == textview(lines, view; kwargs...)

        prepared_buffer = IOBuffer()
        raw_buffer = IOBuffer()
        prepared_result = textview(prepared_buffer, layout, view; kwargs...)
        raw_result = textview(raw_buffer, lines, view; kwargs...)
        @test prepared_result == raw_result
        @test String(take!(prepared_buffer)) == String(take!(raw_buffer))
    end

    matches = string_search_per_line(layout, r"a|red|link")
    for view in views
        @test textview(layout, view; search_matches = matches, active_match = 3) ==
            textview(lines, view; search_matches = matches, active_match = 3)
    end

    global_active = textview(
        layout, (1, -1, 1, -1); search_matches = matches, active_match = 1
    )

    located_active = textview(
        layout,
        (1, -1, 1, -1);
        search_matches = matches,
        active_match = 1,
        active_match_location = (6, 1),
    )

    expected_location = textview(
        lines, (1, -1, 1, -1); search_matches = matches, active_match = 4
    )

    @test located_active == expected_location
    @test located_active != global_active

    @test textview(
        layout, (9, 1, 1, 5); frozen_lines_at_beginning = 9, maximum_number_of_lines = 3
    ) == textview(
        lines, (9, 1, 1, 5); frozen_lines_at_beginning = 9, maximum_number_of_lines = 3
    )

    hidden_ansi_lines = [
        "\e[31mred",
        "\e[0m\e[38;2;1;2;3m\e]8;;https://example.com\e\\hidden",
        "visible\e]8;;\e\\",
    ]

    hidden_ansi_layout = TextViewLayout(hidden_ansi_lines; ansi_checkpoint_stride = 1)

    @test textview(
        hidden_ansi_layout, (3, 1, 1, 7); parse_decorations_before_view = true
    ) == textview(hidden_ansi_lines, (3, 1, 1, 7); parse_decorations_before_view = true)

    deep_lines = [i == 900 ? "\e[34mneedle" : "line $i" for i in 1:1000]
    deep_layout = TextViewLayout(deep_lines)
    deep_matches = string_search_per_line(deep_layout, r"needle")

    @test textview(
        deep_layout,
        (900, 1, 1, 6);
        search_matches = deep_matches,
        active_match_location = (900, 1),
        parse_decorations_before_view = true,
    ) == textview(
        deep_lines,
        (900, 1, 1, 6);
        search_matches = deep_matches,
        active_match = 1,
        parse_decorations_before_view = true,
    )

    sparse_lines = [i in (1, 2, 500, 900) ? "match $i" : "line $i" for i in 1:1000]
    sparse_layout = TextViewLayout(sparse_lines)
    sparse_matches = string_search_per_line(sparse_lines, r"match")
    sparse_options = (
        (; active_match = 4),
        (; active_match = 4, frozen_lines_at_beginning = 3),
        (;
            active_match = 4,
            frozen_lines_at_beginning = 3,
            title_lines = 2,
            hide_title_lines = true,
        ),
    )

    for kwargs in sparse_options
        @test textview(
            sparse_layout, (900, 1, 1, -1); search_matches = sparse_matches, kwargs...
        ) == textview(
            sparse_lines, (900, 1, 1, -1); search_matches = sparse_matches, kwargs...
        )
    end

    malformed = ["before\e[31unterminated after"]
    malformed_layout = TextViewLayout(malformed)
    @test textview(malformed_layout, (1, 1, 2, 8)) == textview(malformed, (1, 1, 2, 8))
end

@testset "Prepared Constructor Validation" begin
    for stride in (0, -1)
        @test_throws ArgumentError TextViewLayout(["text"]; checkpoint_stride = stride)
        @test_throws ArgumentError TextViewLayout(["text"]; ansi_checkpoint_stride = stride)
    end

    @test textview(TextViewLayout(""), (1, -1, 1, -1)) == ("", 0, 0)
    @test textview(TextViewLayout(String[]), (1, -1, 1, -1)) == ("", 0, 0)
end

@testset "Prepared Read-Only Vector Interface" begin
    input_lines = ["first", "α你", "\e[31mred\e[0m"]
    layout = TextViewLayout(input_lines)

    @test TextViewLayout <: AbstractVector{String}
    @test eltype(TextViewLayout) === String
    @test eltype(layout) === String
    @test Base.IndexStyle(TextViewLayout) === IndexLinear()
    @test size(layout) == (3,)
    @test length(layout) == 3
    @test axes(layout) == (Base.OneTo(3),)
    @test eachindex(layout) == Base.OneTo(3)
    @test firstindex(layout) == 1
    @test lastindex(layout) == 3
    @test (@inferred layout[1]) == "first"
    @test layout[2:3] == ["α你", "\e[31mred\e[0m"]
    first_iteration = @inferred Union{Nothing, Tuple{String, Tuple{Base.OneTo{Int}, Int}}} iterate(
        layout
    )
    @test first_iteration[1] == "first"
    second_iteration = @inferred Union{Nothing, Tuple{String, Tuple{Base.OneTo{Int}, Int}}} iterate(
        layout, first_iteration[2]
    )
    @test second_iteration[1] == "α你"
    @test collect(layout) == input_lines

    mutable_copy = collect(layout)
    mutable_copy[1] = "changed"
    push!(mutable_copy, "new")
    @test layout[1] == "first"
    @test length(layout) == 3

    input_lines[1] = "source changed"
    push!(input_lines, "source added")
    @test collect(layout) == ["first", "α你", "\e[31mred\e[0m"]
    @test !hasproperty(layout, :lines)
    @test_throws BoundsError layout[0]
    @test_throws BoundsError layout[4]
    @test_throws Base.CanonicalIndexError setindex!(layout, "changed", 1)
    @test_throws MethodError push!(layout, "new")
    @test which(setindex!, (TextViewLayout, String, Int)).module === Base
    @test which(push!, (TextViewLayout, String)).module === Base

    empty_layout = TextViewLayout(String[])
    @test size(empty_layout) == (0,)
    @test length(empty_layout) == 0
    @test axes(empty_layout) == (Base.OneTo(0),)
    @test eachindex(empty_layout) == Base.OneTo(0)
    @test iterate(empty_layout) === nothing
    @test collect(empty_layout) == String[]
    @test_throws BoundsError empty_layout[1]
    @test collect(TextViewLayout("")) == [""]

    @test which(textview, (TextViewLayout, NTuple{4, Int})).sig.parameters[2] ===
        TextViewLayout
    @test which(string_search_per_line, (TextViewLayout, Regex)).sig.parameters[2] ===
        TextViewLayout
    @test textview(layout, (1, -1, 1, -1)) == textview(collect(layout), (1, -1, 1, -1))
    @test string_search_per_line(layout, r"red") ==
        string_search_per_line(collect(layout), r"red")
end

@testset "Prepared Differential Corpus" begin
    open_url = "\e]8;;https://example.com\e\\"
    close_url = "\e]8;;\e\\"
    corpus = (
        "你a\u0301\e[31mB\e[0m",
        "X\e[31m\e[0m\e[1mY",
        "你$(open_url)e\u0301$(close_url)Z",
        "a\u0301\e[38;2;1;2;3m你\e[0m$(open_url)b$(close_url)",
    )
    boundary_views = ((1, 1, 1, 0), (1, 1, 1, 1), (1, 1, 2, 1), (1, 1, 3, 2), (1, 1, 5, 1))

    for line in corpus, stride in (1, 2, 3, 32)
        layout = TextViewLayout(
            [line]; checkpoint_stride = stride, ansi_checkpoint_stride = stride
        )
        @test textview(layout, (1, 1, 1, -1)) == textview([line], (1, 1, 1, -1))

        for view in boundary_views
            prepared = textview(layout, view)
            raw = textview([line], view)
            @test _ansi_character_trace(prepared[1]) == _ansi_character_trace(raw[1])
            @test _terminal_decoration_state(prepared[1]) ==
                _terminal_decoration_state(raw[1])
            @test prepared[2:3] == raw[2:3]
        end
    end

    linked_then_unlinked = "$(open_url)A$(close_url)B"
    red_then_default = "\e[31mA\e[0mB"
    state_cases = (linked_then_unlinked, red_then_default)
    state_views = ((1, 1, 1, -1), (1, 1, 1, 1), (1, 1, 2, 1))

    for line in state_cases, stride in (1, 2, 3, 32), view in state_views
        raw = textview([line], view)
        prepared = textview(TextViewLayout([line]; ansi_checkpoint_stride = stride), view)
        @test _ansi_character_trace(prepared[1]) == _ansi_character_trace(raw[1])
        @test _terminal_decoration_state(prepared[1]) == _terminal_decoration_state(raw[1])
        @test prepared[2:3] == raw[2:3]
        view[4] < 0 && (@test prepared == raw)
    end

    linked_trace = _ansi_character_trace(textview([linked_then_unlinked], (1, 1, 1, -1))[1])
    @test first(linked_trace).second.hyperlink_url == "https://example.com"
    @test last(linked_trace).second.hyperlink_url == ""
    red_trace = _ansi_character_trace(textview([red_then_default], (1, 1, 1, -1))[1])
    @test first(red_trace).second.foreground == "31"
    @test last(red_trace).second.reset
end

@testset "Prepared Inference" begin
    lines = ["title", "α你e\u0301", "\e[31mred\e[0m", "plain red"]
    layout = @inferred TextViewLayout(
        lines; checkpoint_stride = 2, ansi_checkpoint_stride = 1
    )
    matches = @inferred string_search_per_line(layout, r"red")
    @test matches == Dict(3 => [(1, 3)], 4 => [(7, 3)])

    basic_buffer = IOBuffer()
    basic_result = @inferred textview(basic_buffer, layout, (2, 2, 1, 4))
    @test basic_result isa Tuple{Int, Int}

    overlay_buffer = IOBuffer()
    overlay_result = @inferred textview(
        overlay_buffer,
        layout,
        (3, 2, 2, 5);
        frozen_columns_at_beginning = 1,
        frozen_lines_at_beginning = 1,
        maximum_number_of_columns = 10,
        maximum_number_of_lines = 3,
        search_matches = matches,
        show_ruler = true,
        title_lines = 1,
        visual_line_backgrounds = ["44"],
        visual_lines = [4],
    )
    @test overlay_result isa Tuple{Int, Int}
end

@testset "Prepared Metadata Bounds" begin
    short_ascii = TextViewLayout(fill("x"^100, 24))
    wide_ascii = TextViewLayout(fill("x"^100_000, 24))
    @test all(isnothing, short_ascii._metadata)
    @test all(isnothing, wide_ascii._metadata)
    @test count(wide_ascii._plain_ascii) == 24

    unicode_line = repeat("α\u0301你", 1000)
    unicode_layout = TextViewLayout([unicode_line]; checkpoint_stride = 64)
    unicode_metadata = unicode_layout._metadata[1]
    @test length(unicode_metadata.seek_checkpoints) ≤ cld(length(unicode_line), 64) + 1

    ansi_line = join(("\e[$(30 + i % 8)mX" for i in 1:100)) * "\e[0m"
    ansi_layout = TextViewLayout([ansi_line]; ansi_checkpoint_stride = 16)
    ansi_metadata = ansi_layout._metadata[1]
    @test length(ansi_metadata.ansi_events) == 101
    @test length(ansi_metadata.ansi_prefix_checkpoints) == 101 ÷ 16
    @test length(ansi_metadata.ansi_suffix_checkpoints) == cld(101, 16)
    prepared_ansi = textview(ansi_layout, (1, 1, 40, 10))
    raw_ansi = textview([ansi_line], (1, 1, 40, 10))
    @test remove_decorations(prepared_ansi[1]) == remove_decorations(raw_ansi[1])
    @test parse_decoration(get_decorations(prepared_ansi[1])) ==
        parse_decoration(get_decorations(raw_ansi[1]))
    @test prepared_ansi[2:3] == raw_ansi[2:3]
end

@testset "Prepared ANSI Boundaries and Transitions" begin
    terminal_equivalent = function (prepared::String, raw::String)
        return remove_decorations(prepared) == remove_decorations(raw) &&
               parse_decoration(get_decorations(prepared)) ==
               parse_decoration(get_decorations(raw))
    end

    wide_line = "你\e[31mX\e[0m"
    wide_prepared = textview(TextViewLayout([wide_line]), (1, 1, 1, 1))
    wide_raw = textview([wide_line], (1, 1, 1, 1))
    @test terminal_equivalent(wide_prepared[1], wide_raw[1])
    @test wide_prepared[2:3] == wide_raw[2:3]
    @test textview(TextViewLayout([wide_line]), (1, 1, 2, 1)) == ("\e[31m \e[0m", 0, 1)
    wide_matches = string_search_per_line([wide_line], r"X")
    wide_options = (
        (;),
        (; frozen_columns_at_beginning = 1),
        (; visual_lines = [1]),
        (; search_matches = wide_matches, active_match = 1),
        (; frozen_columns_at_beginning = 1, visual_lines = [1]),
        (;
            frozen_columns_at_beginning = 1, search_matches = wide_matches, active_match = 1
        ),
    )
    for view in ((1, 1, 1, 1), (1, 1, 2, 1), (1, 1, 3, 1)), kwargs in wide_options
        raw = textview([wide_line], view; kwargs...)
        for stride in (1, 2, 32)
            prepared = textview(
                TextViewLayout([wide_line]; ansi_checkpoint_stride = stride),
                view;
                kwargs...,
            )
            @test terminal_equivalent(prepared[1], raw[1])
            @test prepared[2:3] == raw[2:3]
        end
    end

    open_url = "\e]8;;url\e\\"
    close_url = "\e]8;;\e\\"
    transition_sequences = (
        "\e[0m" * open_url,
        open_url * "\e[31m",
        "\e[0m" * open_url * "\e[31m",
        open_url * "\e[0m",
        close_url * open_url,
        "\e[39m\e[49m",
        "\e[38;2;1;2;3m\e[48;5;201m",
        "\e[1m\e[3m\e[4m\e[7m\e[22m\e[23m\e[24m\e[27m",
    )
    oracle_lines = ("AB\e[0m$(open_url)C", "AB\e[0m$(open_url)\e[31mC")
    for line in
        (oracle_lines..., ("AB" * sequence * "C" for sequence in transition_sequences)...)
        raw = textview([line], (1, 1, 1, 1))
        for stride in (1, 2, 32)
            layout = TextViewLayout([line]; ansi_checkpoint_stride = stride)
            prepared = textview(layout, (1, 1, 1, 1))
            @test terminal_equivalent(prepared[1], raw[1])
            @test prepared[2:3] == raw[2:3]
        end
    end

    zero_width_ansi = "a\u0301" * repeat("\e[31m", 40) * "b"
    for stride in (1, 2, 32)
        @test textview(
            TextViewLayout([zero_width_ansi]; ansi_checkpoint_stride = stride), (1, 1, 2, 1)
        ) == textview([zero_width_ansi], (1, 1, 2, 1))
    end

    boundary_line = "X" * repeat("\e[31m", 100_000) * "Y"
    boundary_view = textview(TextViewLayout([boundary_line]), (1, 1, 1, 1))
    @test boundary_view == ("X\e[31m", 0, 1)
    @test ncodeunits(boundary_view[1]) < 32

    reset_line = "\e[31mX\e[0m\e[1mY"
    reset_and_links = (
        "\e[0m\e[1m$(open_url)",
        "$(open_url)\e[0m\e[1m",
        "\e[0m$(open_url)$(close_url)\e[1m",
        "$(open_url)\e[0m\e[1m$(close_url)",
    )
    for stride in (1, 2, 32)
        reset_output = textview(
            TextViewLayout([reset_line]; ansi_checkpoint_stride = stride), (1, 1, 1, 1)
        )[1]
        reset_state = parse_decoration(get_decorations(reset_output))
        @test remove_decorations(reset_output) == "X"
        @test reset_output == "\e[31mX\e[0m\e[1m"
        @test reset_state.bold == StringManipulation.active
        @test isempty(reset_state.foreground)

        for sequence in reset_and_links
            line = "X" * sequence * "Y"
            prepared = textview(
                TextViewLayout([line]; ansi_checkpoint_stride = stride), (1, 1, 1, 1)
            )[1]
            raw = textview([line], (1, 1, 1, 1))[1]
            @test remove_decorations(prepared) == remove_decorations(raw)
            @test parse_decoration(get_decorations(prepared)) ==
                parse_decoration(get_decorations(raw))
        end
    end

    wide_dense_cases = (
        (repeat("\e[31m", 100_000), " \e[31m"),
        (repeat(open_url, 100_000), " " * open_url),
        (repeat("\e[0m\e[1m", 50_000), " \e[0m\e[1m"),
    )
    for (events, expected) in wide_dense_cases
        output = textview(TextViewLayout(["你" * events * "X"]), (1, 1, 1, 1))[1]
        @test output == expected
        @test ncodeunits(output) < 64
    end
end

@testset "Dense ANSI Seek Checkpoints" begin
    event_count = 100_000
    stride = 32
    dense_events = repeat("\e[31m", event_count)
    cases = (
        (dense_events * "X", (1, 1, 2, 1)),
        ("X" * dense_events * "Y", (1, 1, 2, 1)),
        (dense_events, (1, 1, 2, 1)),
    )
    for (line, view) in cases
        layout = TextViewLayout([line]; ansi_checkpoint_stride = stride)
        metadata = layout._metadata[1]
        @test length(metadata.ansi_events) == event_count
        @test length(metadata.seek_checkpoints) ≥ event_count ÷ stride
        @test textview(layout, view) == textview([line], view)

        buffer = IOBuffer()
        textview(buffer, layout, view)
        truncate(buffer, 0)
        seekstart(buffer)
        allocated = @allocated textview(buffer, layout, view)
        @test allocated < 64_000
    end

    compact_layout = TextViewLayout([dense_events * "X"]; ansi_checkpoint_stride = stride)
    compact_metadata = compact_layout._metadata[1]
    @test isbitstype(eltype(compact_metadata.ansi_events))
    @test sizeof(eltype(compact_metadata.ansi_events)) ≤ 32
    @test length(compact_metadata.ansi_transitions) == 1
    @test Base.summarysize(compact_layout) ≤ 6_120_000
end

@testset "High-Cardinality ANSI Metadata" begin
    event_count = 10_000
    unique_osc = "X" * join("\e]8;;url$(i)\e\\" for i in 1:event_count) * "Y"
    osc_layout = TextViewLayout([unique_osc])
    osc_metadata = osc_layout._metadata[1]
    @test length(osc_metadata.ansi_events) == event_count
    @test length(osc_metadata.ansi_transitions) == event_count
    @test isempty(osc_metadata.ansi_fallback_values)
    @test sizeof(eltype(osc_metadata.ansi_transitions)) ≤ 32
    @test Base.summarysize(osc_metadata.ansi_transitions) ≤ 48event_count + 1024
    osc_output = textview(osc_layout, (1, 1, 1, 1))[1]
    @test parse_decoration(get_decorations(osc_output)).hyperlink_url == "url10000"

    unique_colors =
        "X" *
        join(
            "\e[38;2;$(i % 256);$((i ÷ 256) % 256);$(i ÷ 65536)m" for
            i in 0:(event_count - 1)
        ) *
        "Y"
    color_layout = TextViewLayout([unique_colors])
    color_metadata = color_layout._metadata[1]
    @test length(color_metadata.ansi_events) == event_count
    @test length(color_metadata.ansi_transitions) == event_count
    @test isempty(color_metadata.ansi_fallback_values)
    @test Base.summarysize(color_metadata.ansi_transitions) ≤ 48event_count + 1024
    prepared = textview(color_layout, (1, 1, 1, 1))[1]
    raw = textview([unique_colors], (1, 1, 1, 1))[1]
    @test remove_decorations(prepared) == remove_decorations(raw)
    @test parse_decoration(get_decorations(prepared)) ==
        parse_decoration(get_decorations(raw))
end

## Description #############################################################################
#
# Tests related to the string cropping.
#
############################################################################################

@testset "Left Cropping" begin
    str = "Test 😅 \e[38;5;231;48;5;243mTest 😅 \e[38;5;201;48;5;243mTest\e[0m"

    expected = "😅 \e[38;5;231;48;5;243mTest 😅 \e[38;5;201;48;5;243mTest\e[0m"
    cropped_str = *(left_crop(str, 5)...)
    @test cropped_str == expected

    expected = "  \e[38;5;231;48;5;243mTest 😅 \e[38;5;201;48;5;243mTest\e[0m"
    cropped_str = *(left_crop(str, 6)...)
    @test cropped_str == expected

    expected = "\e[38;5;231;48;5;243mst 😅 \e[38;5;201;48;5;243mTest\e[0m"
    cropped_str = *(left_crop(str, 10)...)
    @test cropped_str == expected

    expected = "\e[38;5;231;48;5;243m\e[38;5;201;48;5;243mest\e[0m"
    cropped_str = *(left_crop(str, 17)...)
    @test cropped_str == expected

    ansi_escape_seq, ~ = left_crop(str, 17)
    @test ansi_escape_seq == "\e[38;5;231;48;5;243m\e[38;5;201;48;5;243m"

    # == Hyperlinks (OSC 8) ================================================================

    str = "\e]8;;https://ronanarraes.com\e\\My Website\e]8;;\e\\ Test Test"

    expected_left = "\e]8;;https://ronanarraes.com\e\\"
    expected_right = "y Website\e]8;;\e\\ Test Test"
    r = left_crop(str, 1)

    @test first(r) == expected_left
    @test last(r) == expected_right

    str = "\e]8;;https://ronanarraes.com\e\\My Website\e]8;;\e\\ Test Test"

    expected_left = "\e]8;;https://ronanarraes.com\e\\\e]8;;\e\\"
    expected_right = "est Test"
    r = left_crop(str, 12)

    @test first(r) == expected_left
    @test last(r) == expected_right

    str = "Test \e]8;;https://ronanarraes.com\e\\My Website\e]8;;\e\\ Test Test"

    expected_left = ""
    expected_right = "t \e]8;;https://ronanarraes.com\e\\My Website\e]8;;\e\\ Test Test"
    r = left_crop(str, 3)

    @test first(r) == expected_left
    @test last(r) == expected_right
end

@testset "Fit Field" begin
    str = "Test 😅 \e[38;5;231;48;5;243mTest 😅 \e[38;5;201;48;5;243mTest\e[0m"
    printable_string_width = printable_textwidth(str)

    # Cropping from The Right
    # ======================================================================================

    cropped_str = fit_string_in_field(str, 8)
    expected = "Test 😅…\e[38;5;231;48;5;243m\e[38;5;201;48;5;243m\e[0m"
    @test cropped_str == expected

    cropped_str = fit_string_in_field(str, 8; printable_string_width)
    expected = "Test 😅…\e[38;5;231;48;5;243m\e[38;5;201;48;5;243m\e[0m"
    @test cropped_str == expected

    cropped_str = fit_string_in_field(str, 8; add_space_in_continuation_char = true)
    expected = "Test   …\e[38;5;231;48;5;243m\e[38;5;201;48;5;243m\e[0m"
    @test cropped_str == expected

    cropped_str = fit_string_in_field(
        str, 8; add_space_in_continuation_char = true, keep_escape_seq = false
    )
    expected = "Test   …"
    @test cropped_str == expected

    # Cropping from The Left
    # ======================================================================================

    cropped_str = fit_string_in_field(str, 8; crop_side = :left)
    expected = "\e[38;5;231;48;5;243m…😅 \e[38;5;201;48;5;243mTest\e[0m"
    @test cropped_str == expected

    cropped_str = fit_string_in_field(str, 8; crop_side = :left, printable_string_width)
    expected = "\e[38;5;231;48;5;243m…😅 \e[38;5;201;48;5;243mTest\e[0m"
    @test cropped_str == expected

    cropped_str = fit_string_in_field(
        str, 8; add_space_in_continuation_char = true, crop_side = :left
    )
    expected = "\e[38;5;231;48;5;243m…   \e[38;5;201;48;5;243mTest\e[0m"
    @test cropped_str == expected

    # == Hyperlinks (OSC 8) ================================================================

    str = "\e]8;;https://ronanarraes.com\e\\My Website\e]8;;\e\\ Test Test"

    expected = "\e]8;;https://ronanarraes.com\e\\My W …\e]8;;\e\\"
    cropped_str = fit_string_in_field(
        str, 6; add_space_in_continuation_char = true, crop_side = :right
    )

    @test cropped_str == expected

    expected = "\e]8;;https://ronanarraes.com\e\\My Website\e]8;;\e\\ T …"

    cropped_str = fit_string_in_field(
        str, 14; add_space_in_continuation_char = true, crop_side = :right
    )

    @test cropped_str == expected

    expected = "\e]8;;https://ronanarraes.com\e\\\e]8;;\e\\… Test"

    cropped_str = fit_string_in_field(
        str, 6; add_space_in_continuation_char = true, crop_side = :left
    )

    @test cropped_str == expected

    expected = "\e]8;;https://ronanarraes.com\e\\… e\e]8;;\e\\ Test Test"

    cropped_str = fit_string_in_field(
        str, 13; add_space_in_continuation_char = true, crop_side = :left
    )

    @test cropped_str == expected
end

@testset "Right Cropping" begin
    str = "Test 😅 \e[38;5;231;48;5;243mTest 😅 \e[38;5;201;48;5;243mTest\e[0m"

    expected = "Test 😅 \e[38;5;231;48;5;243mTest 😅\e[38;5;201;48;5;243m\e[0m"
    cropped_str = *(right_crop(str, 5)...)
    @test cropped_str == expected

    expected = "Test 😅 \e[38;5;231;48;5;243mTest  \e[38;5;201;48;5;243m\e[0m"
    cropped_str = *(right_crop(str, 6)...)
    @test cropped_str == expected

    expected = "Test 😅\e[38;5;231;48;5;243m\e[38;5;201;48;5;243m\e[0m"
    cropped_str = *(right_crop(str, 13)...)
    @test cropped_str == expected

    expected = "Test  \e[38;5;231;48;5;243m\e[38;5;201;48;5;243m\e[0m"
    cropped_str = *(right_crop(str, 14)...)
    @test cropped_str == expected

    ~, ansi_escape_seq = right_crop(str, 14)
    @test ansi_escape_seq == "\e[38;5;231;48;5;243m\e[38;5;201;48;5;243m\e[0m"

    # Test passing the string printable width.
    printable_string_width = printable_textwidth(str)
    expected = "Test 😅 \e[38;5;231;48;5;243mTest 😅\e[38;5;201;48;5;243m\e[0m"
    cropped_str = *(right_crop(str, 5; printable_string_width)...)
    @test cropped_str == expected

    # == Hyperlinks (OSC 8) ================================================================

    str = "\e]8;;https://ronanarraes.com\e\\My Website\e]8;;\e\\ Test Test"

    expected_left = "\e]8;;https://ronanarraes.com\e\\My Website\e]8;;\e\\ Test"
    expected_right = ""
    r = right_crop(str, 5)

    @test first(r) == expected_left
    @test last(r) == expected_right

    str = "\e]8;;https://ronanarraes.com\e\\My Website\e]8;;\e\\ Test Test"

    expected_left = "\e]8;;https://ronanarraes.com\e\\My Websi"
    expected_right = "\e]8;;\e\\"
    r = right_crop(str, 12)

    @test first(r) == expected_left
    @test last(r) == expected_right

    r = right_crop(str, 12; keep_escape_seq = false)
    @test first(r) == expected_left
    @test last(r) == ""

    str = "Test \e]8;;https://ronanarraes.com\e\\My Website\e]8;;\e\\ Test Test"

    expected_left = "Test"
    expected_right = "\e]8;;https://ronanarraes.com\e\\\e]8;;\e\\"
    r = right_crop(str, 21)

    @test first(r) == expected_left
    @test last(r) == expected_right
end

@testset "Corner Cases" begin
    str = "Test 😅 \e[38;5;231;48;5;243mTest 😅 \e[38;5;201;48;5;243mTest\e[0m"
    cropped_str = fit_string_in_field(str, 25)
    @test cropped_str == str

    # A field with no width cannot hold the continuation character. Only the ANSI escape
    # sequences, which have no printable width, can be kept.
    expected = "\e[38;5;231;48;5;243m\e[38;5;201;48;5;243m\e[0m"
    cropped_str = fit_string_in_field(str, 0)
    @test cropped_str == expected

    expected = ""
    cropped_str = fit_string_in_field(str, 0; keep_escape_seq = false)
    @test cropped_str == expected

    # An invalid `crop_side` must be rejected instead of silently cropping from the left.
    @test_throws ArgumentError fit_string_in_field("abcdef", 3; crop_side = :rigth)

    # The result must never be wider than the field.
    for field_width in -3:5
        for kwargs in (
            (;),
            (; crop_side = :left),
            (; add_space_in_continuation_char = true),
            (; continuation_char = '…', add_space_in_continuation_char = true),
        )
            result = fit_string_in_field("Test 😅 string", field_width; kwargs...)
            @test printable_textwidth(result) ≤ max(field_width, 0)
        end
    end
end

## Description #############################################################################
#
# Functions to perform searches in strings.
#
############################################################################################

export string_search, string_search_per_line

"""
    string_search(str::AbstractString, r::Regex) -> Vector{Tuple{Int, Int}}

Search for the pattern in regex `r` in the string `str`. The result will be a vector of
`Tuple{Int, Int}` with the one-based printable column where the match begins and the
printable width of the match. Both values consider only the printable characters, *i.e.*
the ANSI escape sequences are discarded.
"""
function string_search(str::AbstractString, r::Regex)
    # Remove the decorations so that we can search by regex.
    undecorated_str = remove_decorations(str)

    # Vector with the match tuples.
    search_result = Tuple{Int, Int}[]

    # Find all matches.
    # We track the current byte offset and accumulated text width so that each match only
    # scans the delta from the previous one, giving O(n) total work instead of O(n * k) when
    # there are k matches.
    prev_offset       = firstindex(undecorated_str)
    accumulated_width = 0

    @views for m in eachmatch(r, undecorated_str)
        # Advance the accumulated width only from the previous offset to the character
        # right before this match, avoiding a full rescan from byte 1 each time. Notice
        # that `m.offset` can be `ncodeunits(undecorated_str) + 1` if the regex matches an
        # empty string at the end, which is why we must stop at `prevind`.
        last_offset_before_match = prevind(undecorated_str, m.offset)
        accumulated_width += textwidth(
            undecorated_str[prev_offset:last_offset_before_match]
        )
        prev_offset = m.offset

        push!(search_result, (accumulated_width + 1, textwidth(m.match)))
    end

    return search_result
end

"""
    string_search_per_line(
        str::AbstractString,
        r::Regex
    ) -> Dict{Int, Vector{Tuple{Int, Int}}}
    string_search_per_line(
        lines::AbstractVector{T},
        r::Regex
    ) -> Dict{Int, Vector{Tuple{Int, Int}}} where {T <: AbstractString}
    string_search_per_line(
        layout::TextViewLayout,
        r::Regex
    ) -> Dict{Int, Vector{Tuple{Int, Int}}}

Search each source line for regex `r`. Map matching line numbers to tuples containing the
printable-column beginning and printable width of each match.

# Arguments

- `str::AbstractString`: Newline-delimited text to search.
- `lines::AbstractVector{T}`: String lines to search.
- `layout::TextViewLayout`: Prepared layout to search.
- `r::Regex`: Regular expression to match.

# Returns

- `Dict{Int, Vector{Tuple{Int, Int}}}`: Matches grouped by one-based line number.
"""
function string_search_per_line(str::AbstractString, r::Regex)
    return _internal__string_search_per_line(eachsplit(str, '\n'), r)
end

function string_search_per_line(
    lines::AbstractVector{T}, r::Regex
) where {T <: AbstractString}
    return _internal__string_search_per_line(lines, r)
end

function string_search_per_line(layout::TextViewLayout, r::Regex)
    return _internal__string_search_per_line(layout._lines, r)
end

function _internal__string_search_per_line(it, r::Regex)
    search_results = Dict{Int, Vector{Tuple{Int, Int}}}()

    # Find the matches in each line.
    for (i, line) in enumerate(it)
        search_results_l = string_search(line, r)
        isempty(search_results_l) && continue
        search_results[i] = search_results_l
    end

    return search_results
end

## Description #############################################################################
#
# Functions to obtain a view of a text.
#
############################################################################################

export textview

############################################################################################
#                                   Types and Structures                                   #
############################################################################################

"""
    abstract type TextViewSource

Represent a source of lines rendered by the shared text-view implementation.
"""
abstract type TextViewSource end

"""
    struct RawTextViewSource{T <: AbstractString} <: TextViewSource

Wrap raw lines for text-view rendering.

# Fields

- `lines::Vector{T}`: Raw lines to render.
"""
struct RawTextViewSource{T <: AbstractString} <: TextViewSource
    lines::Vector{T}
end

"""
    struct PreparedTextViewSource <: TextViewSource

Wrap a prepared layout for text-view rendering.

# Fields

- `layout::TextViewLayout`: Prepared layout to render.
"""
struct PreparedTextViewSource <: TextViewSource
    layout::TextViewLayout
end

############################################################################################
#                                     Public Functions                                     #
############################################################################################

"""
    textview(
        text::AbstractString,
        view::NTuple{4, Int};
        kwargs...
    ) -> Tuple{String, Int, Int}
    textview(
        io::IO,
        text::AbstractString,
        view::NTuple{4, Int};
        kwargs...
    ) -> Tuple{Int, Int}
    textview(
        lines::Vector{T},
        view::NTuple{4, Int};
        kwargs...
    ) -> Tuple{String, Int, Int} where {T <: AbstractString}
    textview(
        io::IO,
        lines::Vector{T},
        view::NTuple{4, Int};
        kwargs...
    ) -> Tuple{Int, Int} where {T <: AbstractString}
    textview(
        layout::TextViewLayout,
        view::NTuple{4, Int};
        kwargs...
    ) -> Tuple{String, Int, Int}
    textview(
        io::IO,
        layout::TextViewLayout,
        view::NTuple{4, Int};
        kwargs...
    ) -> Tuple{Int, Int}

Create a view of `text` or `lines` considering a `view` configuration. The latter is a tuple
with four integers that has the following meaning:

- Top line;
- Number of lines;
- Left column; and
- Number of columns.

If a value equal or lower than 0 is passed to any of those options, its extreme value is
used.

A [`TextViewLayout`](@ref) can be constructed once and reused to render multiple viewports.
Prepared layouts keep indexed widths, Unicode boundaries, and ANSI state while search and
visual overlays remain dynamic.

# Keywords

- `active_highlight::String`: Set the ANSI decoration for the active highlight.
    (**Default**: `\\e[30;43m`)
- `active_match::Int`: Select the active match and decorate it with `active_highlight`.
    (**Default**: 0)
- `active_match_location::NTuple{2, Int}`: Select a match as
    `(line, within_line_index)` for raw strings, raw line vectors, or prepared layouts. Both
    coordinates must be positive and identify a corresponding match supplied through
    `search_matches` or generated from `search_regex`. Use a nonzero location to take
    precedence over `active_match`.
    (**Default**: `(0, 0)`)
- `frozen_columns_at_beginning::Int`: Keep this many leading columns visible.
    (**Default**: 0)
- `frozen_lines_at_beginning::Int`: Keep this many leading lines visible.
    (**Default**: 0)
- `highlight::String`: Set the ANSI decoration for regular highlights.
    (**Default**: `\\e[7m`)
- `hide_title_lines::Bool`: Hide title lines from the frozen block and fill the view with
    remaining lines when `true`.
    (**Default**: `false`)
- `maximum_number_of_columns::Int`: Limit the number of columns regardless of the view
    width. Use -1 to retain the entire view width.
    (**Default**: -1)
- `maximum_number_of_lines::Int`: Limit the number of lines regardless of the view height.
    Use -1 to retain the entire view height.
    (**Default**: -1)
- `parse_decorations_before_view::Bool`: Scan decorations before the view and restore their
    state when `true`. Use `false` to discard them, which can produce incorrect decorations
    but avoids processing preceding input.
    (**Default**: `false`)
- `ruler_decoration::String`: Set the ANSI decoration for the ruler.
    (**Default**: `\\e[90m`)
- `show_ruler::Bool`: Show a line-number ruler to the left of the view when `true`.
    (**Default**: `false`)
- `visual_lines::Union{Nothing, Vector{Int}}`: Select lines for visual highlighting. Use
    `nothing` to leave all lines unchanged.
    (**Default**: `nothing`)
- `visual_line_backgrounds::Union{String, Vector{String}}`: Set one ANSI background for all
    visual lines or provide one background per line.
    (**Default**: "44")
- `title_lines::Int`: Treat this many leading lines as static titles.
    (**Default**: 0)

If `text::AbstractString` is passed, the following keyword is available:

- `search_regex::Union{Nothing, Regex}`: Highlight text matching this regular expression.
    (**Default**: `nothing`)

If `lines::Vector{T}` where `T <: AbstractString` is passed, the following keyword is
available:

- `search_matches::Union{Nothing, Dict{Int, Vector{Tuple{Int, Int}}}}`: Highlight these
    matches by line. Create the dictionary with [`string_search_per_line`](@ref).
    (**Default**: `nothing`)

# Returns

If `io` is passed, the view is written to it and the function returns a tuple containing:

- `Int`: Number of cropped lines at the end.
- `Int`: Maximum number of cropped characters in a row.

If `io` is not passed, the function returns a tuple containing:

- `String`: Text view.
- `Int`: Number of cropped lines at the end.
- `Int`: Maximum number of cropped characters in a row.

!!! note

    If only frozen lines are printed, the second returned value is set to 0.

    If only frozen columns are printed, the third returned value is set to 0.
"""
function textview(text::AbstractString, view::NTuple{4, Int}; kwargs...)
    buf = IOBuffer()
    num_cropped_lines, max_cropped_chars = textview(buf, text, view; kwargs...)
    return String(take!(buf)), num_cropped_lines, max_cropped_chars
end

function textview(
    buf::IO,
    text::AbstractString,
    view::NTuple{4, Int};
    search_regex::Union{Nothing, Regex} = nothing,
    kwargs...,
)
    lines = split(text, '\n')

    search_matches = if !isnothing(search_regex)
        string_search_per_line(lines, search_regex)
    else
        nothing
    end

    return textview(buf, lines, view; search_matches, kwargs...)
end

function textview(
    lines::Vector{T}, view::NTuple{4, Int}; kwargs...
) where {T <: AbstractString}
    buf = IOBuffer()
    num_cropped_lines, max_cropped_chars = textview(buf, lines, view; kwargs...)
    return String(take!(buf)), num_cropped_lines, max_cropped_chars
end

function textview(layout::TextViewLayout, view::NTuple{4, Int}; kwargs...)
    buf = IOBuffer()
    num_cropped_lines, max_cropped_chars = textview(buf, layout, view; kwargs...)
    return String(take!(buf)), num_cropped_lines, max_cropped_chars
end

function textview(
    buf::IO, lines::Vector{T}, view::NTuple{4, Int}; kwargs...
) where {T <: AbstractString}
    return _textview(buf, RawTextViewSource(lines), view; kwargs...)
end

function textview(
    buf::IO,
    layout::TextViewLayout,
    view::NTuple{4, Int};
    active_match_location::NTuple{2, Int} = (0, 0),
    kwargs...,
)
    return _textview(
        buf, PreparedTextViewSource(layout), view; active_match_location, kwargs...
    )
end

"""
    _textview(
        buf::IO,
        source::TextViewSource,
        view::NTuple{4, Int};
        kwargs...
    ) -> Tuple{Int, Int}

Render a viewport from `source` into `buf` and return its cropping measurements.

# Arguments

- `buf::IO`: Write the rendered viewport to this output buffer.
- `source::TextViewSource`: Provide the raw or prepared lines to render.
- `view::NTuple{4, Int}`: Set the top line, height, left column, and width.

# Keywords

- `active_highlight::String`: Set the active-match ANSI decoration.
    (**Default**: `\\e[30;43m`)
- `active_match::Int`: Select the globally active search match.
    (**Default**: 0)
- `frozen_columns_at_beginning::Int`: Keep this many leading columns visible.
    (**Default**: 0)
- `frozen_lines_at_beginning::Int`: Keep this many leading lines visible.
    (**Default**: 0)
- `highlight::String`: Set the regular-match ANSI decoration.
    (**Default**: `\\e[7m`)
- `hide_title_lines::Bool`: Hide title lines from the frozen block.
    (**Default**: `false`)
- `maximum_number_of_columns::Int`: Limit the rendered viewport width.
    (**Default**: -1)
- `maximum_number_of_lines::Int`: Limit the rendered viewport height.
    (**Default**: -1)
- `parse_decorations_before_view::Bool`: Restore ANSI state from preceding lines.
    (**Default**: `false`)
- `ruler_decoration::String`: Set the ruler ANSI decoration.
    (**Default**: `\\e[90m`)
- `search_matches::Union{Nothing, Dict{Int, Vector{Tuple{Int, Int}}}}`: Provide matches by
    line.
    (**Default**: `nothing`)
- `show_ruler::Bool`: Show line numbers beside the viewport.
    (**Default**: `false`)
- `visual_lines::Union{Nothing, Vector{Int}}`: Select lines for visual highlighting.
    (**Default**: `nothing`)
- `visual_line_backgrounds::Union{String, Vector{String}}`: Set visual-line backgrounds.
    (**Default**: "44")
- `title_lines::Int`: Treat this many leading lines as titles.
    (**Default**: 0)
- `active_match_location::NTuple{2, Int}`: Select a match by positive line and match indices
    present in `search_matches`.
    (**Default**: `(0, 0)`)

# Returns

- `Tuple{Int, Int}`: Cropped-line count and maximum cropped printable width.
"""
function _textview(
    buf::IO,
    source::TextViewSource,
    view::NTuple{4, Int};
    active_highlight::String = _CSI * "30;43m",
    active_match::Int = 0,
    frozen_columns_at_beginning::Int = 0,
    frozen_lines_at_beginning::Int = 0,
    highlight::String = _CSI * "7m",
    hide_title_lines::Bool = false,
    maximum_number_of_columns::Int = -1,
    maximum_number_of_lines::Int = -1,
    parse_decorations_before_view::Bool = false,
    ruler_decoration::String = _CSI * "90m",
    search_matches::Union{Nothing, Dict{Int, Vector{Tuple{Int, Int}}}} = nothing,
    show_ruler::Bool = false,
    visual_lines::Union{Nothing, Vector{Int}} = nothing,
    visual_line_backgrounds::Union{String, Vector{String}} = "44",
    title_lines::Int = 0,
    active_match_location::NTuple{2, Int} = (0, 0),
)

    # == Verification of the Input Parameters ==============================================

    start_line  = view[1]
    num_lines   = view[2]
    total_lines = _source_length(source)

    if active_match_location != (0, 0)
        match_line, match_index = active_match_location
        (match_line > 0) && (match_index > 0) || throw(
            ArgumentError("Both coordinates in `active_match_location` must be positive."),
        )
        match_line ≤ total_lines || throw(
            ArgumentError(
                "The line in `active_match_location` does not exist in the source."
            ),
        )
        isnothing(search_matches) && throw(
            ArgumentError(
                "`search_matches` must be supplied with `active_match_location`."
            ),
        )
        haskey(search_matches, match_line) || throw(
            ArgumentError(
                "`search_matches` does not contain the line in `active_match_location`."
            ),
        )
        match_index ≤ length(search_matches[match_line]) || throw(
            ArgumentError("The match index in `active_match_location` does not exist.")
        )
    end

    total_lines == 0 && return 0, 0

    frozen_lines_at_beginning = clamp(frozen_lines_at_beginning, 0, total_lines)
    title_lines = clamp(title_lines, 0, frozen_lines_at_beginning)

    start_line = clamp(start_line, 1, total_lines)

    if frozen_lines_at_beginning > 0
        first_non_frozen_line = frozen_lines_at_beginning + 1

        start_line = if first_non_frozen_line > total_lines
            total_lines + 1
        else
            clamp(start_line, first_non_frozen_line, total_lines)
        end
    end

    available_lines = max(total_lines - start_line + 1, 0)
    num_lines = num_lines ≥ 0 ? clamp(num_lines, 0, available_lines) : available_lines

    start_column = max(view[3], 1)

    num_columns = view[4]

    if (frozen_columns_at_beginning > 0) && (start_column ≤ frozen_columns_at_beginning)
        start_column = frozen_columns_at_beginning + 1
    end

    # If the user wants a ruler, compute the required size here.
    ruler_spacing = 0

    if show_ruler
        ruler_spacing = ndigits(total_lines)

        # If the user selected a maximum number of columns, we need to decrease it to take
        # into account the ruler.
        if maximum_number_of_columns ≥ 0
            maximum_number_of_columns = max(
                maximum_number_of_columns - ruler_spacing - 3, 0
            )
        end
    end

    visual_line_backgrounds_by_line = nothing

    if !isnothing(visual_lines)
        if visual_line_backgrounds isa AbstractVector
            (length(visual_lines) != length(visual_line_backgrounds)) && throw(
                ArgumentError(
                    "The length of `visual_lines` must equal the length of " *
                    "`visual_line_backgrounds`.",
                ),
            )
        end

        visual_line_backgrounds_by_line = _visual_line_backgrounds_by_line(
            visual_lines, visual_line_backgrounds
        )
    end

    # == Internal Variables ================================================================

    hidden_title_lines = hide_title_lines ? title_lines : 0
    visible_frozen_lines_at_beginning = frozen_lines_at_beginning - hidden_title_lines

    if hidden_title_lines > 0
        num_lines = clamp(num_lines + hidden_title_lines, 0, total_lines - start_line + 1)
    end

    # Prepared layouts can count sparse matches by dictionary entry instead of probing every
    # hidden line. Hidden title lines are accounted for up front.
    indexed_match_counting =
        (source isa PreparedTextViewSource) &&
        (active_match_location == (0, 0)) &&
        !isnothing(search_matches)
    num_matches = if indexed_match_counting && (hidden_title_lines > 0)
        _count_search_matches(search_matches, 1, hidden_title_lines)
    else
        0
    end

    # Variable to store the maximum number of cropped lines at the end.
    num_cropped_lines_at_end = 0

    # Variable to compute the maximum number of characters cropped in the right.
    max_cropped_chars = 0

    # Variable to store the decorations before the view, including those in the frozen
    # lines. It is only written to if the option `parse_decorations_before_view` is `true`,
    # but we always allocate it so that its type is concrete. Otherwise, every `write` in
    # the line loops below would be a dynamic dispatch.
    pre_decorations = IOBuffer()

    # Check if we have a maximum number of lines.
    if maximum_number_of_lines ≥ 0
        if visible_frozen_lines_at_beginning ≥ maximum_number_of_lines
            frozen_lines_at_beginning = hidden_title_lines + maximum_number_of_lines
            num_lines = 0

        else
            if num_lines > maximum_number_of_lines - visible_frozen_lines_at_beginning
                num_lines = maximum_number_of_lines - visible_frozen_lines_at_beginning
            end

            num_cropped_lines_at_end = total_lines - start_line - (num_lines - 1)
        end
    else
        num_cropped_lines_at_end = total_lines - start_line - (num_lines - 1)
    end

    # Check if we have a maximum number of columns.
    if maximum_number_of_columns ≥ 0
        # Check if we can only draw the frozen columns.
        if frozen_columns_at_beginning ≥ maximum_number_of_columns
            frozen_columns_at_beginning = maximum_number_of_columns
            start_column = frozen_columns_at_beginning + 1
            num_columns = 0

        else
            if num_columns < 0
                num_columns = maximum_number_of_columns - frozen_columns_at_beginning
            else
                num_columns = clamp(
                    num_columns, -1, maximum_number_of_columns - frozen_columns_at_beginning
                )
            end
        end
    end

    # == Frozen Lines ======================================================================

    for l in 1:frozen_lines_at_beginning
        line_search_matches = if !isnothing(search_matches) && haskey(search_matches, l)
            search_matches[l]
        else
            nothing
        end

        if hide_title_lines && (l ≤ title_lines)
            if !indexed_match_counting && !isnothing(line_search_matches)
                num_matches += length(line_search_matches)
            end

            if parse_decorations_before_view && (source isa RawTextViewSource)
                write(pre_decorations, _source_decorations(source, l))
            end

            continue
        end

        line_active_match = _line_active_match(
            active_match_location, l, active_match - num_matches
        )

        if show_ruler
            line_number_str = lpad(l, ruler_spacing)
            write(buf, ruler_decoration, " ")
            write(buf, line_number_str, " │")
            write(buf, _CSI, "0m")
        end

        cropped_chars_in_line = 0

        if l ≤ title_lines
            # A title line is never split into frozen and scrolled parts. Hence, we render
            # it as a single frozen block that spans the entire width of the view. Notice
            # that a negative `num_columns` means that the width is unbounded, in which
            # case the title must be unbounded as well.
            if num_columns < 0
                title_num_columns = -1
                title_frozen_columns_at_beginning = 0
            else
                title_num_columns = 0
                title_frozen_columns_at_beginning =
                    num_columns + frozen_columns_at_beginning
            end

            _draw_source_line_view!(
                buf,
                source,
                l,
                line_search_matches,
                line_active_match,
                highlight,
                active_highlight,
                1,
                title_num_columns,
                title_frozen_columns_at_beginning,
            )

        else
            cropped_chars_in_line = _draw_source_line_view!(
                buf,
                source,
                l,
                line_search_matches,
                line_active_match,
                highlight,
                active_highlight,
                start_column,
                num_columns,
                frozen_columns_at_beginning,
            )
        end

        # We should not compute the number of cropped chars if we are only printing frozen
        # columns.
        if frozen_columns_at_beginning != maximum_number_of_columns
            max_cropped_chars = max(max_cropped_chars, cropped_chars_in_line)
        end

        # At the last frozen line, we must reset all the decorations.
        if l != frozen_lines_at_beginning
            write(buf, '\n')
        else
            write(buf, _CSI, "0m")
            num_lines > 0 && write(buf, '\n')
        end

        if !isnothing(line_search_matches)
            num_matches += length(line_search_matches)
        end

        # If the user wants, we need to accumulate all the decorations from the beginning of
        # the text up to the first line in the view. Here, we accumulate those related to
        # the frozen lines.
        if parse_decorations_before_view && (source isa RawTextViewSource)
            write(pre_decorations, _source_decorations(source, l))
        end
    end

    first_hidden_line = frozen_lines_at_beginning + 1
    last_hidden_line = start_line - 1
    if indexed_match_counting
        num_matches += _count_search_matches(
            search_matches, first_hidden_line, last_hidden_line
        )
    elseif source isa RawTextViewSource
        for l in first_hidden_line:last_hidden_line
            # Raw rendering retains its existing line-by-line match and decoration scan.
            if (active_match_location == (0, 0)) &&
                !isnothing(search_matches) &&
                haskey(search_matches, l)
                num_matches += length(search_matches[l])
            end

            if parse_decorations_before_view
                write(pre_decorations, _source_decorations(source, l))
            end
        end
    end

    if parse_decorations_before_view
        d = if source isa PreparedTextViewSource
            start_line == 1 ? Decoration() :
            source.layout._document_ansi_checkpoints[start_line - 1]
        else
            parse_decoration(String(take!(pre_decorations)))
        end

        # If the pre_decoration is a reset, we just need to reinitialize it since the reset
        # escape sequence was already written to the buffer.
        !d.reset && write(buf, d |> String)
    end

    # == Line Views ========================================================================

    for k in 1:num_lines
        # Get the current line number.
        l = start_line + (k - 1)

        line_active_match = _line_active_match(
            active_match_location, l, active_match - num_matches
        )

        if !isnothing(search_matches) && haskey(search_matches, l)
            line_search_matches = search_matches[l]
        else
            line_search_matches = nothing
        end

        if show_ruler
            line_number_str = lpad(l, ruler_spacing)
            write(buf, ruler_decoration, " ")
            write(buf, line_number_str, " │")
            write(buf, _CSI, "0m")
        end

        visual_line_background = if isnothing(visual_line_backgrounds_by_line)
            nothing
        else
            get(visual_line_backgrounds_by_line, l, nothing)
        end

        if !isnothing(visual_line_background)
            is_visual_line = true
        else
            is_visual_line = false
            visual_line_background = ""
        end

        cropped_chars_in_line = _draw_source_line_view!(
            buf,
            source,
            l,
            line_search_matches,
            line_active_match,
            highlight,
            active_highlight,
            start_column,
            num_columns,
            frozen_columns_at_beginning,
            is_visual_line,
            visual_line_background,
        )

        # We should not compute the number of cropped chars if we are only printing frozen
        # columns.
        if frozen_columns_at_beginning != maximum_number_of_columns
            max_cropped_chars = max(max_cropped_chars, cropped_chars_in_line)
        end

        k != num_lines && write(buf, '\n')

        if !isnothing(line_search_matches)
            num_matches += length(line_search_matches)
        end
    end

    return num_cropped_lines_at_end, max_cropped_chars
end

############################################################################################
#                                    Private Functions                                     #
############################################################################################

"""
    _visual_line_backgrounds_by_line(
        visual_lines,
        visual_line_backgrounds
    ) -> Dict{Int, String}

Map each line in `visual_lines` to its background. `visual_line_backgrounds` can be either a
vector with one background per visual line or a single background applied to all of them. If
a line is repeated, the first background wins.

Notice that this function is split into two methods, one per kind of
`visual_line_backgrounds`, so that the loop is specialized and no abstract iterator is
created.

# Arguments

- `visual_lines`: Lines that must be rendered with a background.
- `visual_line_backgrounds`: Background of each visual line, or a single background for all
    of them.

# Returns

- `Dict{Int, String}`: Background of each visual line, indexed by the line number.
"""
function _visual_line_backgrounds_by_line(
    visual_lines, visual_line_backgrounds::AbstractVector
)
    backgrounds_by_line = Dict{Int, String}()
    sizehint!(backgrounds_by_line, length(visual_lines))

    for (line, background) in zip(visual_lines, visual_line_backgrounds)
        get!(backgrounds_by_line, line, background)
    end

    return backgrounds_by_line
end

function _visual_line_backgrounds_by_line(visual_lines, visual_line_background)
    backgrounds_by_line = Dict{Int, String}()
    sizehint!(backgrounds_by_line, length(visual_lines))

    for line in visual_lines
        get!(backgrounds_by_line, line, visual_line_background)
    end

    return backgrounds_by_line
end

"""
    _source_length(source::RawTextViewSource) -> Int

Return the number of raw lines in `source`.

# Arguments

- `source::RawTextViewSource`: Raw source to measure.
"""
_source_length(source::RawTextViewSource) = length(source.lines)

"""
    _source_length(source::PreparedTextViewSource) -> Int

Return the number of prepared lines in `source`.

# Arguments

- `source::PreparedTextViewSource`: Prepared source to measure.

# Returns

- `Int`: Number of prepared lines.
"""
_source_length(source::PreparedTextViewSource) = length(source.layout._lines)

"""
    _source_decorations(source::RawTextViewSource, line_number::Int) -> String

Collect the ANSI decorations from one raw source line.

# Arguments

- `source::RawTextViewSource`: Raw source containing the line.
- `line_number::Int`: One-based line number.
"""
function _source_decorations(source::RawTextViewSource, line_number::Int)
    return get_decorations(source.lines[line_number])
end

"""
    _line_active_match(
        active_match_location::NTuple{2, Int},
        line_number::Int,
        global_line_active_match::Int
    ) -> Int

Resolve the active match index for `line_number`.

# Arguments

- `active_match_location::NTuple{2, Int}`: Explicit line and within-line match index.
- `line_number::Int`: Current one-based line number.
- `global_line_active_match::Int`: Match index computed from the global selection.
"""
function _line_active_match(
    active_match_location::NTuple{2, Int}, line_number::Int, global_line_active_match::Int
)
    if active_match_location != (0, 0)
        return active_match_location[1] == line_number ? active_match_location[2] : 0
    end

    return global_line_active_match
end

"""
    _count_search_matches(
        search_matches::Dict{Int, Vector{Tuple{Int, Int}}},
        first_line::Int,
        last_line::Int
    ) -> Int

Count matches in an inclusive line range using the smaller of the line range and dictionary
entry domains.

# Arguments

- `search_matches::Dict{Int, Vector{Tuple{Int, Int}}}`: Matches grouped by line.
- `first_line::Int`: First line in the inclusive range.
- `last_line::Int`: Last line in the inclusive range.

# Returns

- `Int`: Number of matches in the line range.
"""
function _count_search_matches(
    search_matches::Dict{Int, Vector{Tuple{Int, Int}}}, first_line::Int, last_line::Int
)
    first_line > last_line && return 0
    range_length = last_line - first_line + 1
    count = 0

    if length(search_matches) < range_length
        for (line, matches) in search_matches
            first_line ≤ line ≤ last_line && (count += length(matches))
        end
    else
        for line in first_line:last_line
            matches = get(search_matches, line, nothing)
            !isnothing(matches) && (count += length(matches))
        end
    end

    return count
end

"""
    _draw_source_line_view!(
        buf::IO,
        source::RawTextViewSource,
        line_number::Int,
        args...
    ) -> Int

Draw one raw source line using the generic line renderer.

# Arguments

- `buf::IO`: Output buffer.
- `source::RawTextViewSource`: Raw source containing the line.
- `line_number::Int`: One-based line number.
- `args...`: Remaining line-rendering arguments.
"""
function _draw_source_line_view!(
    buf::IO, source::RawTextViewSource, line_number::Int, args...
)
    return _draw_line_view!(buf, source.lines[line_number], args...)
end

"""
    _draw_source_line_view!(
        buf::IO,
        source::PreparedTextViewSource,
        line_number::Int,
        args::Vararg
    ) -> Int

Draw one prepared source line using its fastest compatible renderer.

# Arguments

- `buf::IO`: Output buffer.
- `source::PreparedTextViewSource`: Prepared source containing the line.
- `line_number::Int`: One-based line number.
- `args...`: Remaining line-rendering arguments.

# Returns

- `Int`: Number of printable characters cropped from the right.
"""
function _draw_source_line_view!(
    buf::IO, source::PreparedTextViewSource, line_number::Int, args...
)
    layout = source.layout
    if layout._plain_ascii[line_number]
        return _draw_ascii_line_view!(buf, layout, line_number, args...)
    end

    if layout._ansi_fallback[line_number]
        return _draw_line_view!(buf, layout._lines[line_number], args...)
    end

    return _draw_indexed_line_view!(buf, layout, line_number, args...)
end

"""
    _draw_indexed_line_view!(
        buf::IO,
        layout::TextViewLayout,
        line_number::Int,
        line_search_matches::Union{Nothing, Vector{Tuple{Int, Int}}},
        line_active_match::Int,
        highlight::String,
        active_highlight::String,
        start_column::Int,
        num_columns::Int,
        frozen_columns_at_beginning::Int,
        visual_line::Bool = false,
        visual_line_background::String = ""
    ) -> Int

Draw one indexed prepared line and return its cropped printable width.

# Arguments

- `buf::IO`: Output buffer.
- `layout::TextViewLayout`: Prepared layout containing the line.
- `line_number::Int`: One-based line number.
- `line_search_matches::Union{Nothing, Vector{Tuple{Int, Int}}}`: Search matches.
- `line_active_match::Int`: Active match within the line.
- `highlight::String`: Regular-match decoration.
- `active_highlight::String`: Active-match decoration.
- `start_column::Int`: First printable viewport column.
- `num_columns::Int`: Number of printable columns to draw.
- `frozen_columns_at_beginning::Int`: Number of frozen columns.
- `visual_line::Bool`: Whether to apply a visual background.
- `visual_line_background::String`: Visual background decoration.

# Returns

- `Int`: Number of printable characters cropped from the right.
"""
function _draw_indexed_line_view!(
    buf::IO,
    layout::TextViewLayout,
    line_number::Int,
    line_search_matches::Union{Nothing, Vector{Tuple{Int, Int}}},
    line_active_match::Int,
    highlight::String,
    active_highlight::String,
    start_column::Int,
    num_columns::Int,
    frozen_columns_at_beginning::Int,
    visual_line::Bool = false,
    visual_line_background::String = "",
)
    if frozen_columns_at_beginning > 0
        left, frozen_width = _prepared_line_segment(
            layout, line_number, 1, frozen_columns_at_beginning; preserve_end_state = false
        )

        if visual_line
            if frozen_width < frozen_columns_at_beginning
                left *= " "^(frozen_columns_at_beginning - frozen_width)
            end

            left = replace_default_background(left, visual_line_background)
        end

        if !isnothing(line_search_matches)
            left = highlight_search(
                left,
                line_search_matches;
                active_highlight,
                active_match = line_active_match,
                highlight,
                min_column = 1,
                max_column = frozen_columns_at_beginning,
                start_column = 1,
            )
        end

        write(buf, left, _RESET_DECORATIONS)
    end

    line_str, visible_width = _prepared_line_segment(
        layout, line_number, start_column, num_columns
    )

    available_width = max(layout._printable_widths[line_number] - start_column + 1, 0)

    if (num_columns ≥ 0) && visual_line && (visible_width < num_columns)
        line_str *= " "^(num_columns - visible_width)
    end

    cropped_chars = num_columns < 0 ? 0 : max(available_width - num_columns, 0)

    if visual_line && (num_columns ≥ 0)
        line_str = replace_default_background(line_str, visual_line_background)
    end

    if !isnothing(line_search_matches)
        line_str = highlight_search(
            line_str,
            line_search_matches;
            active_highlight,
            active_match = line_active_match,
            highlight,
            start_column,
            min_column = start_column,
            max_column = num_columns < 0 ? 0 : start_column + num_columns - 1,
        )
    end

    write(buf, line_str)

    return cropped_chars
end

"""
    _prepared_line_segment(
        layout::TextViewLayout,
        line_number::Int,
        start_column::Int,
        num_columns::Int;
        kwargs...
    ) -> Tuple{String, Int}

Extract a printable-width segment while preserving its ANSI state.

# Arguments

- `layout::TextViewLayout`: Prepared layout containing the line.
- `line_number::Int`: One-based line number.
- `start_column::Int`: First printable column to include.
- `num_columns::Int`: Number of printable columns to include.

# Keywords

- `preserve_end_state::Bool`: Append the state after the viewport when `true`.
    (**Default**: `true`)

# Returns

- `Tuple{String, Int}`: Rendered segment and its visible printable width.
"""
function _prepared_line_segment(
    layout::TextViewLayout,
    line_number::Int,
    start_column::Int,
    num_columns::Int;
    preserve_end_state::Bool = true,
)
    line = layout._lines[line_number]
    total_width = layout._printable_widths[line_number]
    start_size = max(start_column - 1, 0)
    start_seek = _prepared_seek(layout, line_number, start_size)
    start_byte = start_seek.byte_index
    start_padding = start_seek.right_padding
    available_width = max(total_width - start_size, 0)

    prefix_transition = _ansi_summary_before(layout, line_number, start_byte)
    prefix = _ansi_transition_string(prefix_transition)
    if num_columns < 0
        body = start_byte > ncodeunits(line) ? "" : String(SubString(line, start_byte))

        return string(prefix, " "^start_padding, body), available_width
    end

    end_seek = if num_columns == 0
        PreparedSeekResult(start_byte, start_byte, 0, 0, "")
    else
        _prepared_seek(layout, line_number, start_size + num_columns; right_boundary = false)
    end

    end_byte = end_seek.byte_index
    end_padding = end_seek.left_padding
    body = if start_byte ≥ end_byte
        ""
    else
        String(SubString(line, start_byte, prevind(line, end_byte)))
    end
    suffix = if preserve_end_state
        _ansi_transition_string(
            _ansi_summary_after(layout, line_number, end_seek.state_byte_index)
        )
    else
        ""
    end

    width = min(num_columns, available_width)
    visible_start_padding = min(start_padding, num_columns)

    return (
        string(
            prefix,
            " "^visible_start_padding,
            body,
            " "^end_padding,
            end_seek.attached_ansi,
            suffix,
        ),
        width,
    )
end

"""
    struct PreparedSeekResult

Store the byte boundary, padding, and ANSI data produced by a prepared seek.

# Fields

- `byte_index::Int`: Byte index selected for slicing.
- `state_byte_index::Int`: Byte index selected for ANSI state reconstruction.
- `left_padding::Int`: Spaces required to the left of a split wide character.
- `right_padding::Int`: Spaces required to the right of a split wide character.
- `attached_ansi::String`: ANSI events attached to the selected boundary.
"""
struct PreparedSeekResult
    byte_index::Int
    state_byte_index::Int
    left_padding::Int
    right_padding::Int
    attached_ansi::String
end

"""
    _prepared_seek(
        layout::TextViewLayout,
        line_number::Int,
        size::Int;
        kwargs...
    ) -> PreparedSeekResult

Seek `size` printable columns into a prepared line from a sparse checkpoint.

# Arguments

- `layout::TextViewLayout`: Prepared layout containing the line.
- `line_number::Int`: One-based line number.
- `size::Int`: Printable width to seek.

# Keywords

- `right_boundary::Bool`: Assign a split wide character to the right side when `true`.
    (**Default**: `true`)

# Returns

- `PreparedSeekResult`: Indexed viewport boundary and required padding.
"""
function _prepared_seek(
    layout::TextViewLayout, line_number::Int, size::Int; right_boundary::Bool = true
)
    metadata = layout._metadata[line_number]::TextLineMetadata
    checkpoints = metadata.seek_checkpoints
    checkpoint_column = 0
    checkpoint_byte = 1
    low = 1
    high = length(checkpoints)

    # Locate the last sparse checkpoint not beyond the requested printable column.
    while low ≤ high
        middle = (low + high) >>> 1
        checkpoint = checkpoints[middle]
        # A right-edge seek must start before checkpoints attached to the exact boundary so
        # that zero-width events there can be summarized rather than copied into the body.
        if (checkpoint.column < size) || (right_boundary && checkpoint.column == size)
            checkpoint_column = checkpoint.column
            checkpoint_byte = checkpoint.byte_index
            low = middle + 1
        else
            high = middle - 1
        end
    end

    return _prepared_seek_from(
        layout, line_number, checkpoint_byte, size - checkpoint_column; right_boundary
    )
end

"""
    _prepared_seek_from(
        layout::TextViewLayout,
        line_number::Int,
        byte_index::Int,
        size::Int;
        kwargs...
    ) -> PreparedSeekResult

Seek a printable width from a known byte checkpoint.

# Arguments

- `layout::TextViewLayout`: Prepared layout containing the line.
- `line_number::Int`: One-based line number.
- `byte_index::Int`: Byte index at which to begin scanning.
- `size::Int`: Remaining printable width to seek.

# Keywords

- `right_boundary::Bool`: Assign a split wide character to the right side when `true`.
    (**Default**: `true`)

# Returns

- `PreparedSeekResult`: Indexed viewport boundary and required padding.
"""
function _prepared_seek_from(
    layout::TextViewLayout,
    line_number::Int,
    byte_index::Int,
    size::Int;
    right_boundary::Bool = true,
)
    line = layout._lines[line_number]
    metadata = layout._metadata[line_number]::TextLineMetadata
    events = metadata.ansi_events
    event_number = _first_event_at_or_after(events, byte_index)
    remaining = size
    i = byte_index

    # Scan printable widths, skipping zero-width ANSI events at each byte boundary.
    while i ≤ ncodeunits(line)
        # At a right viewport boundary, leave attached zero-width events out of the body.
        # `_ansi_summary_after` emits their terminal-equivalent final state in bounded
        # space.
        if !right_boundary && (remaining ≤ 0)
            return PreparedSeekResult(i, i, 0, 0, "")
        end

        if (event_number ≤ length(events)) && (events[event_number].byte_start == i)
            event = events[event_number]
            i = Int(event.byte_start) + Int(event.byte_length)
            event_number += 1
            continue
        end

        remaining ≤ 0 && return PreparedSeekResult(i, i, 0, 0, "")
        character_byte = i
        c = line[i]
        character_width = textwidth(c)
        remaining -= character_width
        i = nextind(line, i)

        if remaining < 0
            # Replace the hidden portion of a split wide character with viewport padding.
            ansi_begin = i

            # Keep ANSI events attached immediately after the split character boundary.
            while (event_number ≤ length(events)) && (events[event_number].byte_start == i)
                event = events[event_number]
                i = Int(event.byte_start) + Int(event.byte_length)
                event_number += 1
            end

            if right_boundary
                return PreparedSeekResult(i, i, -remaining, character_width + remaining, "")
            end

            return PreparedSeekResult(
                character_byte, ansi_begin, -remaining, character_width + remaining, ""
            )
        end
    end

    end_byte = ncodeunits(line) + 1

    return PreparedSeekResult(end_byte, end_byte, 0, 0, "")
end

"""
    _first_event_at_or_after(
        events::Vector{TextAnsiEvent},
        byte_index::Int
    ) -> Int

Find the first ANSI event whose start is not before `byte_index`.

# Arguments

- `events::Vector{TextAnsiEvent}`: Byte-ordered ANSI events.
- `byte_index::Int`: Byte boundary to locate.

# Returns

- `Int`: One-based event-vector index at or after `byte_index`.
"""
function _first_event_at_or_after(events::Vector{TextAnsiEvent}, byte_index::Int)
    low = 1
    high = length(events)

    while low ≤ high
        middle = (low + high) >>> 1
        if events[middle].byte_start < byte_index
            low = middle + 1
        else
            high = middle - 1
        end
    end

    return low
end

"""
    _ansi_summary_before(
        layout::TextViewLayout,
        line_number::Int,
        byte_index::Int
    ) -> AnsiStateTransition

Reconstruct the ANSI state immediately before a viewport boundary.

# Arguments

- `layout::TextViewLayout`: Prepared layout containing the line.
- `line_number::Int`: One-based line number.
- `byte_index::Int`: Viewport start byte index.

# Returns

- `AnsiStateTransition`: ANSI state immediately before the boundary.
"""
function _ansi_summary_before(layout::TextViewLayout, line_number::Int, byte_index::Int)
    line = layout._lines[line_number]
    metadata = layout._metadata[line_number]::TextLineMetadata
    events = metadata.ansi_events
    event_count = _first_event_at_or_after(events, byte_index) - 1
    stride = layout._ansi_checkpoint_stride
    full_blocks = event_count ÷ stride

    # Restore the nearest prefix transition, then compose only its trailing local events.
    transition =
        full_blocks == 0 ? _empty_ansi_transition() :
        metadata.ansi_prefix_checkpoints[full_blocks]
    for event_number in (full_blocks * stride + 1):event_count
        transition = _compose_ansi_transitions(
            transition, _event_transition(line, metadata, events[event_number])
        )
    end

    return transition
end

"""
    _ansi_summary_after(
        layout::TextViewLayout,
        line_number::Int,
        byte_index::Int
    ) -> AnsiStateTransition

Reconstruct the ANSI state produced after a viewport boundary.

# Arguments

- `layout::TextViewLayout`: Prepared layout containing the line.
- `line_number::Int`: One-based line number.
- `byte_index::Int`: Viewport end byte index.

# Returns

- `AnsiStateTransition`: ANSI state produced after the boundary.
"""
function _ansi_summary_after(layout::TextViewLayout, line_number::Int, byte_index::Int)
    line = layout._lines[line_number]
    metadata = layout._metadata[line_number]::TextLineMetadata
    events = metadata.ansi_events
    first_event = _first_event_at_or_after(events, byte_index)
    first_event > length(events) && return _empty_ansi_transition()
    stride = layout._ansi_checkpoint_stride
    current_block = cld(first_event, stride)
    first_event_in_block = (current_block - 1) * stride + 1
    suffix = metadata.ansi_suffix_checkpoints

    # A boundary aligned with an ANSI block can use its complete cached suffix directly.
    first_event == first_event_in_block && return suffix[current_block]

    next_block = current_block + 1
    last_local_event = min((next_block - 1) * stride, length(events))
    transition = _empty_ansi_transition()

    # Replay through the next block boundary, then apply its cached suffix transition.
    for event_number in first_event:last_local_event
        transition = _compose_ansi_transitions(
            transition, _event_transition(line, metadata, events[event_number])
        )
    end

    if next_block ≤ length(suffix)
        transition = _compose_ansi_transitions(transition, suffix[next_block])
    end

    return transition
end

"""
    _draw_ascii_line_view!(
        buf::IO,
        layout::TextViewLayout,
        line_number::Int,
        line_search_matches::Union{Nothing, Vector{Tuple{Int, Int}}},
        line_active_match::Int,
        highlight::String,
        active_highlight::String,
        start_column::Int,
        num_columns::Int,
        frozen_columns_at_beginning::Int,
        visual_line::Bool = false,
        visual_line_background::String = ""
    ) -> Int

Draw one plain ASCII prepared line and return its cropped width.

# Arguments

- `buf::IO`: Output buffer.
- `layout::TextViewLayout`: Prepared layout containing the line.
- `line_number::Int`: One-based line number.
- `line_search_matches::Union{Nothing, Vector{Tuple{Int, Int}}}`: Search matches.
- `line_active_match::Int`: Active match within the line.
- `highlight::String`: Regular-match decoration.
- `active_highlight::String`: Active-match decoration.
- `start_column::Int`: First viewport column.
- `num_columns::Int`: Number of columns to draw.
- `frozen_columns_at_beginning::Int`: Number of frozen columns.
- `visual_line::Bool`: Whether to apply a visual background.
- `visual_line_background::String`: Visual background decoration.

# Returns

- `Int`: Number of printable characters cropped from the right.
"""
function _draw_ascii_line_view!(
    buf::IO,
    layout::TextViewLayout,
    line_number::Int,
    line_search_matches::Union{Nothing, Vector{Tuple{Int, Int}}},
    line_active_match::Int,
    highlight::String,
    active_highlight::String,
    start_column::Int,
    num_columns::Int,
    frozen_columns_at_beginning::Int,
    visual_line::Bool = false,
    visual_line_background::String = "",
)
    line = layout._lines[line_number]
    width = layout._printable_widths[line_number]

    if frozen_columns_at_beginning > 0
        frozen_width = min(frozen_columns_at_beginning, width)
        left = frozen_width == 0 ? "" : String(SubString(line, 1, frozen_width))

        if visual_line
            if frozen_width < frozen_columns_at_beginning
                left *= " "^(frozen_columns_at_beginning - frozen_width)
            end
            left = replace_default_background(left, visual_line_background)
        end

        if !isnothing(line_search_matches)
            left = highlight_search(
                left,
                line_search_matches;
                active_highlight,
                active_match = line_active_match,
                highlight,
                min_column = 1,
                max_column = frozen_columns_at_beginning,
                start_column = 1,
            )
        end

        write(buf, left, _RESET_DECORATIONS)
    end

    first_visible = min(start_column, width + 1)
    available_width = max(width - first_visible + 1, 0)
    visible_width = num_columns < 0 ? available_width : min(num_columns, available_width)
    line_str = if visible_width == 0
        ""
    else
        String(SubString(line, first_visible, first_visible + visible_width - 1))
    end

    if (num_columns ≥ 0) && visual_line && (visible_width < num_columns)
        line_str *= " "^(num_columns - visible_width)
    end

    cropped_chars = num_columns < 0 ? 0 : max(available_width - num_columns, 0)

    if visual_line && (num_columns ≥ 0)
        line_str = replace_default_background(line_str, visual_line_background)
    end

    if !isnothing(line_search_matches)
        line_str = highlight_search(
            line_str,
            line_search_matches;
            active_highlight,
            active_match = line_active_match,
            highlight,
            start_column,
            min_column = start_column,
            max_column = num_columns < 0 ? 0 : start_column + num_columns - 1,
        )
    end

    write(buf, line_str)

    return cropped_chars
end

"""
    _draw_line_view!(
        buf::IO,
        line::AbstractString,
        line_search_matches::Union{Nothing, Vector{Tuple{Int, Int}}},
        line_active_match::Int,
        highlight::String,
        active_highlight::String,
        start_column::Int,
        num_columns::Int,
        frozen_columns_at_beginning::Int,
        visual_line::Bool = false,
        visual_line_background::String = ""
    )

Draw a line view to the provided IO buffer `buf` with syntax highlighting and search match
indicators.

# Arguments
- `buf::IO`: The output buffer to write the formatted line view to.
- `line::AbstractString`: The line content to be displayed.
- `line_search_matches::Union{Nothing, Vector{Tuple{Int, Int}}}`: Vector of tuples
    indicating the start and length of search matches, or `nothing` if there are no matches.
- `line_active_match::Int`: Index of the currently active/selected match to highlight
    differently.
- `highlight::String`: ANSI color code string for regular search match highlighting.
- `active_highlight::String`: ANSI color code string for the active match highlighting.
- `start_column::Int`: The column index where the view should begin (for horizontal
    scrolling).
- `num_columns::Int`: The number of columns to display in the view.
- `frozen_columns_at_beginning::Int`: Number of columns to keep frozen/always visible at the
    start.
- `visual_line::Bool`: Whether to apply visual line mode styling.
    (**Default**: `false`)
- `visual_line_background::String`: ANSI color code for visual line background.
    (**Default**: `""`)
"""
function _draw_line_view!(
    buf::IO,
    line::AbstractString,
    line_search_matches::Union{Nothing, Vector{Tuple{Int, Int}}},
    line_active_match::Int,
    highlight::String,
    active_highlight::String,
    start_column::Int,
    num_columns::Int,
    frozen_columns_at_beginning::Int,
    visual_line::Bool = false,
    visual_line_background::String = "",
)
    line_str = string(line)

    # Frozen columns.
    if frozen_columns_at_beginning > 0
        left, _ = split_string(line_str, frozen_columns_at_beginning)

        # If this is a visual line, we must ensure that the frozen row has the minimum
        # number of characters to fill the frozen space.
        if visual_line
            w = printable_textwidth(left)
            if w < frozen_columns_at_beginning
                left = string(left, " "^(frozen_columns_at_beginning - w))
            end
            left = replace_default_background(left, visual_line_background)
        end

        # If we have matches, we should highlight those in the frozen columns.
        if !isnothing(line_search_matches)
            left = highlight_search(
                left,
                line_search_matches;
                active_highlight,
                active_match = line_active_match,
                highlight,
                min_column = 1,
                max_column = frozen_columns_at_beginning,
                start_column = 1,
            )
        end

        write(buf, left, _RESET_DECORATIONS)
    end

    left_ansi  = ""
    right_ansi = ""

    if start_column > 0
        # TODO: Can we improve this?
        # Maybe we can improve performance by creating a function that removes a certain
        # number of characters from the left/right and also returns the ANSI escape
        # sequence.
        left, line_str = split_string(line_str, start_column - 1)

        # Here we simplify the decorations to avoid too many escape sequences.
        left_ansi = get_decorations(left) |> parse_decoration |> String
    end

    if num_columns ≥ 0
        # If this is a visual line, we change the default background.
        if visual_line
            w = printable_textwidth(line_str)

            if w < num_columns
                line_str = line_str * " "^(num_columns - w)
            end
        end

        line_str, right = split_string(line_str, num_columns)

        # Here we simplify the decorations to avoid too many escape sequences.
        right_ansi = get_decorations(right) |> parse_decoration |> String

        # Compute the amount of printable cropped characters in the right string.
        cropped_chars = printable_textwidth(right)

        # Compute the complete line for this view.
        line_str = string(left_ansi, line_str, right_ansi)

        if visual_line
            # If this is a visual line, let's change its background.
            line_str = replace_default_background(line_str, visual_line_background)
        end
    else
        cropped_chars = 0
        line_str = string(left_ansi, line_str)
    end

    # Now that we have what we will print to the buffer, we can highlight the matches if
    # they exist in the visible area.
    if !isnothing(line_search_matches)
        line_str = highlight_search(
            line_str,
            line_search_matches;
            active_highlight,
            active_match = line_active_match,
            highlight,
            start_column = start_column,
            min_column = start_column,
            max_column = num_columns < 0 ? 0 : start_column + num_columns - 1,
        )
    end

    write(buf, line_str)

    return cropped_chars
end

## Description #############################################################################
#
# Functions to split strings.
#
############################################################################################

export split_string

"""
    split_string(str::AbstractString, size::Int) -> String, String

Split the string `str` after a number of characters that have a specific printable `size`.
This function returns two strings: before and after the split point.

The algorithm ensures that the printable width of the first returned string will always be
equal to `size`, unless `size` is negative or larger than the printable size of `str`. In
the first case, the first string is empty, whereas, in the second case, the first string is
equal to `str`.

!!! note

    If the character at the split point needs more than one column to be printed (like some
    UTF-8 characters), it is replaced by spaces on both sides so that the printable width of
    each returned string is preserved.
"""
function split_string(str::AbstractString, size::Int)
    # Buffers with the string before and after the split point. Notice that we hint them
    # with a number of bytes, so we must use `sizeof` and not `length`, which counts the
    # characters and requires a full scan of the string. We also clamp the hints to the size
    # of the string because `size` is a printable width given by the caller and can be
    # arbitrarily large.
    string_size = sizeof(str)
    buf₀ = IOBuffer(; sizehint = clamp(size, 1, max(string_size, 1)))
    buf₁ = IOBuffer(; sizehint = clamp(string_size - size, 1, max(string_size, 1)))

    state = :text

    # If we are splitting just at the point where a non-printable character is, we need to
    # add all those characters to the string in `buf₀`. This variable is used to handle
    # this case.
    check_ansi_after_split = true

    for c in str
        # == String Before the Split Point =================================================
        if size > 0
            state = _next_string_state(c, state)

            if state == :text
                cw = textwidth(c)

                # Printable width still available in the string before the split point.
                available_width = size

                size -= cw

                # If `size` is negative, the character straddles the split point because it
                # occupies more than one column. Since a character cannot be broken, we
                # replace it by spaces on both sides so that the printable width of each
                # part is preserved.
                if size < 0
                    write(buf₀, " "^available_width)
                    write(buf₁, " "^(cw - available_width))
                    size = 0
                    continue
                end
            end

            write(buf₀, c)
            continue
        end

        # == String After the Split Point ==================================================

        if check_ansi_after_split
            state = _next_string_state(c, state)

            # All non-printable character just after splitting must go to `buf₀`.
            if state != :text
                write(buf₀, c)
                continue
            end

            # After the first text character, we should add everything to `buf₁`.
            check_ansi_after_split = false
        end

        write(buf₁, c)
    end

    return String(take!(buf₀)), String(take!(buf₁))
end

## Description #############################################################################
#
# Tests related with highlights.
#
############################################################################################

@testset "Highlight Searches in Strings" begin
    str      = "Test high\e[1mlight\e[0m in a string with no underlines."
    expected = "Test \e[7mhighlight\e[0m\e[0m in a string with no underlines."
    hstr     = highlight_search(str, r"highlight")
    @test expected == hstr

    str      = "Test high\e[1mlight\e[0m in a string with no underlines."
    expected = "Test \e[30;43mhighlight\e[0m\e[0m in a string with no underlines."
    hstr     = highlight_search(str, r"highlight"; active_match = 1)
    @test expected == hstr

    str      = "Test high\e[4mlight in a string with underlines."
    expected = "Test \e[7mhighlight\e[0m\e[4m in a string with underlines."
    hstr     = highlight_search(str, r"highlight")
    @test expected == hstr

    # No matches in the string.
    hstr = highlight_search(str, r"Nothing to match")
    @test hstr == str
end

@testset "Highlight Searches in Texts With Multiple Lines" begin
    str = """
        Test high\e[1mlight\e[0m in a string with no underlines.
        Test high\e[4mlight in a string with underlines\e[0m.
        Test another high\e[33mlight with colors.
        This is the last line."""
    lines = split(str, '\n')

    expected = """
        Test \e[7mhighlight\e[0m\e[0m in a string with no underlines.
        Test \e[7mhighlight\e[0m\e[4m in a string with underlines\e[0m.
        Test another \e[7mhighlight\e[0m\e[33m with colors.
        This is the last line."""
    hstr = highlight_search(lines, r"highlight")
    @test hstr == expected

    expected = """
        Test \e[7mhighlight\e[0m\e[0m in a string with no underlines.
        Test \e[30;43mhighlight\e[0m\e[4m in a string with underlines\e[0m.
        Test another \e[7mhighlight\e[0m\e[33m with colors.
        This is the last line."""
    hstr = highlight_search(lines, r"highlight"; active_match = 2)
    @test hstr == expected

    expected = """
        Test \e[7mhighlight\e[0m\e[4m in a string with underlines\e[0m.
        Test another \e[30;43mhighlight\e[0m\e[33m with colors."""
    hstr = highlight_search(
        lines, r"highlight"; active_match = 3, start_line = 2, end_line = 3
    )
    @test hstr == expected

    # No matches in the string.
    expected = """
        Test high\e[1mlight\e[0m in a string with no underlines.
        Test high\e[4mlight in a string with underlines\e[0m.
        Test another high\e[33mlight with colors."""
    hstr = highlight_search(
        lines, r"nothing to match"; active_match = 3, start_line = 1, end_line = 3
    )
    @test hstr == expected
end

@testset "Highlight Searches With Out-of-Range Lines" begin
    lines = ["a", "b"]
    matches = Dict(1 => [(1, 1)])
    expected = "\e[7ma\e[0m\nb"

    # `end_line` must be clamped to the number of lines.
    @test highlight_search(lines, matches; end_line = 5) == expected
    @test highlight_search(lines, matches) == expected

    # `start_line` must be clamped to 1.
    @test highlight_search(lines, matches; start_line = -3) == expected
end

@testset "Highlight Searches With Decorations at the Boundaries" begin
    # An escape sequence placed exactly where a match begins must be written before the
    # highlight, whereas one inside the match must be suppressed and reapplied after it.
    str = "ab\e[31mcd\e[0mef"
    matches = string_search(str, r"cd")
    @test highlight_search(str, matches) == "ab\e[31m\e[7mcd\e[0m\e[0mef"

    str = "abcd"
    @test highlight_search(str, [(2, 2)]) == "a\e[7mbc\e[0md"

    # A match that extends past the end of the string must still be closed.
    @test highlight_search("abc", [(2, 10)]) == "a\e[7mbc\e[0m"

    # Wide characters must keep their printable width.
    @test printable_textwidth(highlight_search("日本語", string_search("日本語", r"本"))) ==
        printable_textwidth("日本語")

    # Many matches in a single line must be handled in linear time. This only checks the
    # result, but a quadratic implementation is unusably slow here.
    long = repeat("abc match ", 500)
    long_matches = string_search(long, r"match")
    @test length(long_matches) == 500

    highlighted = highlight_search(long, long_matches)
    @test printable_textwidth(highlighted) == printable_textwidth(long)
    @test count("\e[7m", highlighted) == 500
end

## Description #############################################################################
#
# Functions related to string highlighting.
#
############################################################################################

export highlight_search

"""
    highlight_search(
        lines::Vector{T},
        search_matches::Dict{Int, Vector{Tuple{Int, Int}}};
        kwargs...
    ) where T <: AbstractString -> String
    highlight_search(
        lines::Vector{T},
        regex::Regex;
        kwargs...
    ) where T <: AbstractString -> String

Return the text composed of the `lines` with the `search_matches` (see
[`string_search_per_line`](@ref)) highlighted. If a `regex` is passed in the place of
`search_matches`, the latter is automatically computed using
[`string_search_per_line`](@ref).

# Keywords

- `active_match::Int`: The match number that is considered active. This match is highlighted
    using `active_highlight` instead of `highlight`.
    (**Default** = 0)
- `active_highlight::String`: ANSI escape sequence that contains the decoration of the
    active highlight.
    (**Default** = `\\e[30;43m`.)
- `end_line::Int`: Line to end the processing. If it is equal or lower than 0, all lines
    will be processed. This value is clamped to the number of lines.
    (**Default** = 0)
- `highlight::String`: ANSI escape sequence that contains the decoration of the highlight.
    (**Default** = `\\e[7m`)
- `max_column::Int`: Stop processing if the match is after this column. If it is equal or
    lower than 0, this limit will not be considered.
    (**Default** = 0)
- `min_column::Int`: Do not process matches before this column. If it is equal or lower than
    0, this limit will not be considered.
    (**Default** = 0)
- `start_line::Int`: Line to begin the processing. This value is clamped to 1.
    (**Default** = 0)
"""
function highlight_search(
    lines::Vector{T},
    search_matches::Dict{Int, Vector{Tuple{Int, Int}}};
    active_highlight::String = _CSI * "30;43m",
    active_match::Int = 0,
    end_line::Int = 0,
    highlight::String = _CSI * "7m",
    max_column::Int = 0,
    min_column::Int = 0,
    start_line::Int = 0,
) where {T <: AbstractString}
    buf = IOBuffer()

    start_line = max(start_line, 1)

    # `end_line` must be clamped to the number of lines. Otherwise, we would try to access
    # a line that does not exist.
    end_line = end_line ≤ 0 ? length(lines) : min(end_line, length(lines))

    # Count how many matches we have before this line.
    num_matches = 0
    for l in 1:(start_line - 1)
        !haskey(search_matches, l) && continue
        num_matches += length(search_matches[l])
    end

    for l in start_line:end_line
        if haskey(search_matches, l)
            line_active_match = active_match - num_matches

            search_matches_l = search_matches[l]

            write(
                buf,
                highlight_search(
                    lines[l],
                    search_matches_l;
                    active_match = line_active_match,
                    highlight,
                    active_highlight,
                    min_column,
                    max_column,
                ),
            )

            num_matches += length(search_matches_l)
        else
            write(buf, lines[l])
        end

        (l != end_line) && write(buf, '\n')
    end

    return String(take!(buf))
end

function highlight_search(
    lines::Vector{T}, regex::Regex; kwargs...
) where {T <: AbstractString}
    search_matches = string_search_per_line(lines, regex)
    return highlight_search(lines, search_matches; kwargs...)
end

"""
    highlight_search(
        str::AbstractString,
        search_matches::Vector{Tuple{Int, Int}};
        kwargs...
    ) -> String
    highlight_search(str::AbstractString, regex::Regex; kwargs...) -> String

Return the text in the string `str` with the `search_matches` (see [`string_search`](@ref))
highlighted. If a `regex` is passed in the place of `search_matches`, the latter is
automatically computed using [`string_search`](@ref).

# Keywords

- `active_match::Int`: The match number that is considered active. This match is highlighted
    using `active_highlight` instead of `highlight`.
    (**Default** = 0)
- `active_highlight::String`: ANSI escape sequence that contains the decoration of the
    active highlight.
    (**Default** = `\\e[30;43m`.)
- `highlight::String`: ANSI escape sequence that contains the decoration of the highlight.
    (**Default** = `\\e[7m`)
- `max_column::Int`: Stop processing if the match is after this column. If it is equal or
    lower than 0, this limit will not be considered.
    (**Default** = 0)
- `min_column::Int`: Do not process matches before this column. If it is equal or lower than
    0, this limit will not be considered.
    (**Default** = 0)
- `start_column::Int`: The algorithm will consider that the first character in `str` is in
    this column.
    (**Default** = 1)
"""
function highlight_search(
    str::AbstractString,
    search_matches::Vector{Tuple{Int, Int}};
    active_highlight::String = _CSI * "30;43m",
    active_match::Int = 0,
    highlight::String = _CSI * "7m",
    max_column::Int = 0,
    min_column::Int = 0,
    start_column::Int = 1,
)
    num_matches = length(search_matches)

    (num_matches == 0) && return String(str)

    # The matches are sorted by their initial column. Hence, we can use a binary search to
    # find the first and the last match that can be visible in this view, avoiding a scan
    # over all of them.
    first_match = 1
    if (start_column > 1) || (min_column > 1)
        first_visible_column = max(start_column, min_column)
        low = 1
        high = num_matches
        while low ≤ high
            middle = (low + high) >>> 1
            match = search_matches[middle]
            if match[1] + match[2] - 1 < first_visible_column
                low = middle + 1
            else
                high = middle - 1
            end
        end
        first_match = low
    end

    last_match = num_matches
    if max_column > 0
        low = first_match
        high = num_matches
        while low ≤ high
            middle = (low + high) >>> 1
            if search_matches[middle][1] ≤ max_column
                low = middle + 1
            else
                high = middle - 1
            end
        end
        last_match = high
    end

    h_str = IOBuffer(; sizehint = sizeof(str))

    # Buffer to accumulate the ANSI escape sequence we are currently processing.
    buf_ansi = IOBuffer()

    # Current decoration of the string, considering every escape sequence seen so far.
    decoration = Decoration()

    state = :text

    # Printable column of the character we are processing. The first character of `str` is
    # at `start_column` because the string was already cropped by the caller.
    column = start_column

    match_index      = first_match
    match_end_column = 0
    in_match         = false

    for c in str
        state = _next_string_state(c, state)

        # == ANSI Escape Sequences =========================================================

        if state != :text
            write(buf_ansi, c)

            if state == :escape_state_end
                ansi = String(take!(buf_ansi))
                decoration = update_decoration(decoration, ansi)

                # Inside a match, the escape sequences must not be written because they
                # would override the highlight decoration. They are applied again when the
                # match ends.
                in_match || write(h_str, ansi)
            end

            continue
        end

        # == Printable Characters ==========================================================

        match_index, match_end_column, in_match = _apply_match_boundaries!(
            h_str,
            search_matches,
            decoration,
            column,
            match_index,
            match_end_column,
            in_match,
            last_match,
            active_match,
            highlight,
            active_highlight,
            start_column,
            min_column,
        )

        character_width = textwidth(c)
        next_column     = column + character_width

        # If a boundary falls strictly inside this character, we cannot break it. Hence, we
        # replace the character by spaces, keeping the printable width unchanged.
        boundary = if in_match
            match_end_column
        elseif match_index ≤ last_match
            search_matches[match_index][1]
        else
            typemax(Int)
        end

        if column < boundary < next_column
            for _ in column:(boundary - 1)
                write(h_str, ' ')
            end

            column = boundary

            match_index, match_end_column, in_match = _apply_match_boundaries!(
                h_str,
                search_matches,
                decoration,
                column,
                match_index,
                match_end_column,
                in_match,
                last_match,
                active_match,
                highlight,
                active_highlight,
                start_column,
                min_column,
            )

            for _ in boundary:(next_column - 1)
                write(h_str, ' ')
            end

            column = next_column
            continue
        end

        write(h_str, c)
        column = next_column
    end

    # A match can begin or end after the last character of the string, for example when the
    # line was cropped. Hence, we must process the remaining boundaries here.
    match_index, match_end_column, in_match = _apply_match_boundaries!(
        h_str,
        search_matches,
        decoration,
        column,
        match_index,
        match_end_column,
        in_match,
        last_match,
        active_match,
        highlight,
        active_highlight,
        start_column,
        min_column,
    )

    # If a match extends past the end of the string, we still must close its highlight.
    in_match && write(h_str, _RESET_DECORATIONS, convert(String, decoration))

    return String(take!(h_str))
end

"""
    _apply_match_boundaries!(
        h_str::IOBuffer,
        search_matches::Vector{Tuple{Int, Int}},
        decoration::Decoration,
        column::Int,
        match_index::Int,
        match_end_column::Int,
        in_match::Bool,
        last_match::Int,
        active_match::Int,
        highlight::String,
        active_highlight::String,
        start_column::Int,
        min_column::Int
    ) -> Int, Int, Bool

Open and close in `h_str` all the highlights whose boundary is at `column`, advancing over
the matches that are not visible in the view.

A highlight is opened by writing `highlight`, or `active_highlight` if the match is the
active one, and closed by writing a reset followed by `decoration`, which restores the
decoration of the text that was suppressed inside the match.

# Returns

- `Int`: Index of the next match to be processed.
- `Int`: Column just after the end of the match being processed.
- `Bool`: `true` if we are inside a match after processing the boundaries.
"""
function _apply_match_boundaries!(
    h_str::IOBuffer,
    search_matches::Vector{Tuple{Int, Int}},
    decoration::Decoration,
    column::Int,
    match_index::Int,
    match_end_column::Int,
    in_match::Bool,
    last_match::Int,
    active_match::Int,
    highlight::String,
    active_highlight::String,
    start_column::Int,
    min_column::Int,
)
    while true
        if in_match
            (column < match_end_column) && break

            write(h_str, _RESET_DECORATIONS, convert(String, decoration))
            in_match = false
            match_index += 1

        else
            (match_index > last_match) && break

            match = search_matches[match_index]
            match_last_column = match[1] + match[2] - 1

            # Skip the matches that are not visible in this view.
            if (match_last_column < start_column) ||
                ((min_column > 0) && (match_last_column < min_column))
                match_index += 1
                continue
            end

            (column < match[1]) && break

            write(h_str, match_index == active_match ? active_highlight : highlight)
            in_match         = true
            match_end_column = match[1] + match[2]
        end
    end

    return match_index, match_end_column, in_match
end

function highlight_search(str::AbstractString, regex::Regex; kwargs...)
    search_matches = string_search(str, regex)
    return highlight_search(str, search_matches; kwargs...)
end

## Description #############################################################################
#
# Functions to compute the printable width of the string.
#
############################################################################################

export printable_textwidth, printable_textwidth_per_line

"""
    printable_textwidth(str::AbstractString) -> Int

Return the text width of `str` considering only the printable characters, *i.e.* removing
all ANSI escape sequences related to decorations.

!!! note

    Characters like `\\n` and `\\t` are treated as normal characters.
"""
function printable_textwidth(str::AbstractString)
    # Fast path: a string composed only of printable ASCII characters cannot contain an
    # escape sequence, and each of its characters occupies exactly one column.
    _is_printable_ascii(str) && return ncodeunits(str)

    width = 0
    state = :text

    # We must not materialize the undecorated string only to measure it. Hence, we walk the
    # string once and accumulate the width of the characters outside an escape sequence.
    for c in str
        state = _next_string_state(c, state)
        (state == :text) && (width += textwidth(c))
    end

    return width
end

"""
    printable_textwidth_per_line(str::AbstractString) -> Vector{Int}

Return a vector with the printable textwidth of each line in `str`. The lines are split
considering the character `\\n`.
"""
function printable_textwidth_per_line(str::AbstractString)
    # `eachsplit` has no length, meaning a comprehension would grow the vector. Since the
    # number of lines is known from the number of newlines, we can allocate it once.
    widths = Vector{Int}(undef, count('\n', str) + 1)

    for (i, line) in enumerate(eachsplit(str, '\n'))
        widths[i] = printable_textwidth(line)
    end

    return widths
end

############################################################################################
#                                    Private Functions                                     #
############################################################################################

"""
    _is_printable_ascii(str::AbstractString) -> Bool

Return `true` if `str` contains only printable ASCII characters.

Notice that we check the code units instead of the characters because any byte of a
multi-byte UTF-8 sequence is greater than `0x7E`, meaning that such a string is correctly
rejected without being decoded.
"""
function _is_printable_ascii(str::AbstractString)
    return all(b -> 0x20 ≤ b ≤ 0x7E, codeunits(str))
end

"""
    _has_escape_byte(str::AbstractString) -> Bool

Return `true` if `str` contains an escape byte (`0x1b`), meaning that it can contain an ANSI
escape sequence.

Notice that `0x1b` cannot be part of a multi-byte UTF-8 sequence, so scanning the code units
never yields a false positive.
"""
_has_escape_byte(str::AbstractString) = 0x1b ∈ codeunits(str)

# Repository Guide

## Package Structure

- Treat this repository as one Julia package compatible with Julia `^1.10`.
- Use `src/StringManipulation.jl` as the single module entrypoint. Preserve its include order: alignment, ansi, crop, decorations, highlighting, state, split, layout, search, view, width, precompilation.
- Treat feature files in `src/` as module includes, not independent subpackages.
- Keep tests in the files unconditionally included by `test/runtests.jl`: alignment, ansi, crop, decorations, highlighting, layout, search, split, view, and width. Do not expect dedicated test files for state or precompilation.
- Review `src/precompilation.jl` and its explicit `PrecompileTools.@compile_workload` when public API changes should be precompiled.
- Remember that PrecompileTools is the only runtime dependency; the test target supplies Test and Markdown.

## Commands

- Instantiate dependencies with `julia --project=. -e 'using Pkg; Pkg.instantiate()'`.
- Run the full suite with `julia --project=. -e 'using Pkg; Pkg.test()'`.
- Run one test file with `julia --project=. -e 'using StringManipulation, Test, Markdown; include("test/alignment.jl")'`; replace `alignment.jl` with another included test file. There is no test-name selector.
- Allow a generous timeout on the first instantiate or test run because precompilation can take time.
- Approximate CI order, when needed, with `julia --project=. -e 'using Pkg; Pkg.build(); Pkg.test()'`. There is no `deps/build.jl`, so build is effectively a no-op and `Pkg.test()` covers the meaningful local behavior.
- Format with `julia -e 'using JuliaFormatter; format(".")'`. Install JuliaFormatter in the active non-project environment and do not pass `--project=.` because it is not a package dependency.
- Check formatting changes by running the formatter and then `git diff --exit-code`; do not treat the formatter invocation as check-only.
- Expect standard CI to test Julia 1.10 and stable 1.x, with nightly handled separately. Across the workflows, supported runners are Ubuntu x64, macOS arm64, and Windows x64; matrix exclusions remove Ubuntu arm64, macOS x64, and Windows arm64.
- Expect every CI job to run buildpkg before runtest; standard CI also publishes coverage through Codecov.

## Code Style

- Follow `.JuliaFormatter.toml`, which configures Blue style plus repository-specific settings.
- Run formatting locally when appropriate; CI does not check formatting.
- Add test groups using the `@testset "Name" verbose = true begin ... end` pattern from `test/runtests.jl`.

## Behavioral Constraints

- Preserve behavior for ANSI escapes and decorations, Unicode and emoji, printable width, cropping, splitting, alignment, highlighting, and views.
- Preserve or add focused coverage when changing logic in those areas.
- Load Test, StringManipulation, and Markdown when reproducing the `test/runtests.jl` environment.

## Not Configured

- Do not invent workflows for a linter, pre-commit hooks, generated documentation, package extensions, or weak dependencies; none are configured.
- Do not expect `CLAUDE.md`, `deps/build.jl`, a docs project/build, or `test/Project.toml`.
- Do not expect a tracked `Manifest.toml`; it is not committed, so it is generated locally by `Pkg.instantiate()` and can be out of sync with `Project.toml`.
